// author: Chuck Baker
// Version 7.0


document.onreadystatechange = function () {
	if (document.readyState == "complete") {
		window.addEventListener("load",febeLoad,true);
		window.addEventListener("close",febeClose,true);
		window.addEventListener("DOMContentLoaded",febeCheckForMissedScheduledBackupLoad,true);
		
		febeSetMsgs();
		febeGetPrefs();
		febeGetAddonList();  
	}//if
}//function()

	//window.addEventListener("load",febeStatusbarVisibility,true);

function febeLoad(){
	febeInitEssentials();	
	febeCheckIfNewInstall();
	
	setTimeout(febeCheckBackupOnStartup,5000);
	if(!febeScheduledBuTimer){
		febeScheduledBuTimer = Cc['@mozilla.org/timer;1'].createInstance(Ci.nsITimer);
	}//if
	
	febeScheduleBackup();
	febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
//alert(document.title+"\n"+window.windowtype)
	febeObserverService = new febeObserver();
	febeSetStatusbarVisibility2();
	febeGetAddonList();
	window.removeEventListener("load",febeLoad,true);
	return true;
}//febeLoad()

function febeInitDir(){
	febeExBackedUp = false;
	febeThBackedUp = false;
	febeBmBackedUpJSON = false;
	febeBmBackedUpHTML = false;
	febePrBackedUp = false;
	febeCkBackedUp = false;
	febeChBackedUp = false;
	febeUcBackedUp = false;
	febePwBackedUp = false;
	//pdBackedUp = false;
	febeSpBackedUp = false;
	febeHsBackedUp = false;
	febeFfBackedUp = false;
	febePmBackedUp = false;
	febeUpBackedUp = false;
	
	// Get platform
	febePlatform = febeGetPlatform();
	
	// Get pointer to FEBE extension directory
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	FEBEdir = febeProfDir.clone();
	FEBEdir.append("extensions");
	FEBEdir.append(FEBE_GUID);
	//FEBEdir = FEBEdir.path;

	if(febeInitialized == true){return true;}	// Only run the rest of this routine once
	febeInitialized = true;	
	
//	Get profile name
	var tmp = febeProfDir.leafName;
	var p = tmp.indexOf(".")
	febeProfName  = tmp.substr(p+1);
	return true;
}//febeInitDir()

function febeInitEssentials(){
	// Pointer to profile directory
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"]
        .getService(Ci.nsIProperties)
        .get("ProfD", Ci.nsIFile);
	febeSetUnicharPref("extensions.febe.curProfDir",febeProfDir.path);
				
  // Pointer to main browser window
	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);  
	febeMainWindow = wm.getMostRecentWindow("navigator:browser"); 
	
	// Get pointer to FEBE extension directory
	FEBEdir = febeProfDir.clone();
	FEBEdir.append("extensions");
	FEBEdir.append(FEBE_GUID);

	return true;
}//febeInitEssentials()

function febeCheckBackupOnStartup(){
	var windowtype = document.documentElement.getAttribute('windowtype');
	if(windowtype != "navigator:browser"){return false;}
	if(!febeCheckWaitTime("startup"))return false;	
	var ok = false;
	if(febePrefs.getBoolPref("extensions.febe.backupOnStartup")){ok = true;}
	if(febePrefs.getBoolPref("extensions.febe.backupOnStartup.prompt") && ok){
		var tmp = "<style>color: purple; font-size: 15px;</style>"+febeMsg[281]+"\n";
		tmp += "<style>color: black;</style>"+febeMsg[283]+"\n";
		ok = febeConfirm(tmp);
	}//if
	if(ok){
		febeBackupRunType = 2	// 'On startup'
		febePrefs.setCharPref("extensions.febe.lastbackuponstartup",febeNow())
		febeInit();
	}else{
		febeRemind();
	}//if
	return true;
}//febeCheckBackupOnStartup()

function febeCheckWaitTime(which){
	var lastbustartup = febePrefs.getCharPref("extensions.febe.lastbackuponstartup");
	var lastbushutdown = febePrefs.getCharPref("extensions.febe.lastbackuponshutdown");
	var waitstartup = febePrefs.getIntPref("extensions.febe.daystowaitforbackupOnStartup");
	var waitshutdown = febePrefs.getIntPref("extensions.febe.daystowaitforbackupOnShutdown");
	var startupelapsed = febeDaysElapsed(lastbustartup);
	var shutdownelapsed = febeDaysElapsed(lastbushutdown);
	switch(which){
		case "startup":
			if(lastbustartup == "") return true;
			if(startupelapsed >= waitstartup) return true;
			break;
		case "shutdown":
			if(lastbushutdown == "") return true;
			if(shutdownelapsed >= waitshutdown) return true;
			break;
	}//switch
	return false;
}//febeCheckWaitTime()

function febeDaysElapsed(starttime){
	// Return the number of days elapsed between starttime (in milliseconds) and now
	var now = febeNow();
	var diff = now - starttime;
	var elapsed = diff / (24 * 60 * 60 * 1000);
	return elapsed;
}//febeDaysElapsed()

function febeCheckForMissedScheduledBackupLoad(){
	var prefName = "extensions.febe.disableMissedScheduledBackup";
	if(febePrefs.getBoolPref(prefName)){return false}	// Not checking for missed backups
	setTimeout(febeCheckForMissedScheduledBackup,10000);
	return true;
}//febeCheckForMissedScheduledBackupLoad

function febeClose(){
  // Re-assign the schedule controller to another window
	if(!febeIsScheduleController) {return true;}	// This is not the controller, so just return
	
	// This is the controlling window
	// See how many open windows we have ... If there is only one (this one) then no need to re-assign
	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var wincnt = 0;
	var enumerator = wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		wincnt++;
	}//while
	if(wincnt == 1){return true;}	// Only one window (this one) is opened, so it must be the controller ... just return
	
	// More than one window is open ... assign to a different one
	var enumerator = wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		if(win == window){
			continue;
		}else{
			win.febeIsScheduleController = true;
			win.document.getElementById("febestatusbar").hidden = febeHideIcons;
			win.document.getElementById("febestatusbar").collapsed = febeHideIcons;
			febeControllerWindow = win;
//febeProps(win)
			febeScheduleBackup();
			febeSetStatus();
			break;
		}//if
	}//while
	return true;
}//febeClose()

function febeLocales(){
  // Return a list of installed locales

	// Parse chrome.manifest
	// ex:
	// locale	febe	en-US	jar:chrome/febe.jar!/locale/en-US/
	// locale	febe	bg-BG	jar:chrome/febe.jar!/locale/bg-BG/
	// locale	febe	da-DK	jar:chrome/febe.jar!/locale/da-DK/

	var extDir = Cc["@mozilla.org/file/directory_service;1"]
        .getService(Ci.nsIProperties)
        .get("ProfD", Ci.nsIFile);
	
	extDir.append("extensions");
	extDir.append(FEBE_GUID);
	extDir.append("chrome.manifest");
	
	// open an input stream from file
	var istream = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
	istream.init(extDir, 0x01, 0444, 0);
	istream.QueryInterface(Ci.nsILineInputStream);
	
	// read lines into array
	var lArray = [];
	var line = {}, hasmore;
	var str = "jar:chrome/febe.jar!/locale/";
	do {
		hasmore = istream.readLine(line);			// locale	febe	en-US	jar:chrome/febe.jar!/locale/en-US/
		var idx = line.value.indexOf(str);
		if(idx != -1){
			var tmp = line.value.substring(idx);	// jar:chrome/febe.jar!/locale/en-US/
			tmp = tmp.substring(str.length);		// en-US/
			idx = tmp.indexOf("/");
			tmp = tmp.substring(0,idx);				// en-US
			lArray.push(tmp);
		}//if
		
	} while(hasmore);
	istream.close();
	return lArray;
}//febeLocales()

function febeWelcomePageDisplay(){
	try{
		gBrowser.selectedTab = gBrowser.addTab(febeWelcomePage);
	}catch(e){;}
}//febeWelcomePage()

function febeRemind(){
  // See if we need to remind about a backup
	var prefName = "extensions.febe.lastbackup";
	if(!febePrefs.prefHasUserValue(prefName)){return true;}
	var lastBU = Date.parse(febePrefs.getCharPref(prefName));
	var now = Date.parse(Date());

	var reminderDays = febePrefs.getIntPref("extensions.febe.reminderdays");
	if(reminderDays > 0){
		if(febeReminded == true){return true;}
		var elapsed = (now - lastBU) / (24 * 60 * 60 * 1000);	// Number of days since last backup
		//elapsed = 100
		if(elapsed >= reminderDays){
			var tmp = "<style>color: red; font-weight: bold; font-size: 15px;</style>"+febeMsg[171]+"\n";
			tmp += "<style>color: black;</style>"+febeMsg[172].replace("%days%",parseInt(elapsed))+"\n";
			tmp += febeLocalizedDate(lastBU)+"\n\n";
			tmp += "<style>color: black;</style>"+febeMsg[232]+"\n";
			tmp += "<style>color: black; font-weight: bold; font-size: 15px;</style>"+febeMsg[233]+"\n";
			if(febeReminded != true){
				if(febeConfirm(tmp)){
				febeBackupRunType = 5	// 'Reminded'
				febeInit();}
				febeReminded = true;
			}//if
		}//if
	}//if
	return true;	
}//febeRemind()

function febeGetEnvironmentVariableValue(envString){
	var env = Cc["@mozilla.org/process/environment;1"].createInstance(Ci.nsIEnvironment);
  return env.get(envString);
}//febeGetEnvironmentVariableValue

function febeInit(){
  // Get setup and start the backup	
	if(!febeCheckStatus()){return false;}
	var d = new Date();
	var febeStartTime = d.getTime();
	febePrefs.setCharPref("extensions.febe.buStartTime",febeStartTime);
	febeVersion = febeMsg[49]+" "+febeGetVersion();
	febeGetPrefs();
	if(!febeGetBDD()){return false;}
	if(!febeSanityCheck()){return false;}
	if(!febeInitDir()){return false;}
	if(!febeCheckPending()){return false;}
	febeFEBEbackedUp = false;
	
	// Create timestamped directory if needed
	if(febeUseTimestampedDir){
		var ts = febePrefs.getCharPref("extensions.febe.timestamp.format");
		if(!febeVerifyTimestamp(ts)){return false;}
		febeDelTimestampDirs();
		var timestamp = febeMakeTimestampName(ts);
		febeBuDesDir.append(timestamp);
		if(!febeBuDesDir.exists() || !febeBuDesDir.isDirectory()){
			febeBuDesDir.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
		}//if
		febeExBuDir = febeBuDesDir.path;
	}//if
	febeSetUnicharPref("extensions.febe.curBUdir",febeExBuDir);
	if(!febeClearDir()){return false;}

	febeProfDir = Cc["@mozilla.org/file/directory_service;1"]
		.getService(Ci.nsIProperties)
		.get("ProfD", Ci.nsIFile);
	febeSetUnicharPref("extensions.febe.curProfDir",febeProfDir.path);
	
	// Set max script execution time if needed
	var febeMaxScriptTimeDflt = febePrefs.getIntPref("dom.max_chrome_script_run_time");
	var febeMaxScriptTimeFEBE = febePrefs.getIntPref("extensions.febe.max.chrome.script.execution.seconds");
	Application.storage.set("febeMaxScriptTimeDflt",febeMaxScriptTimeDflt);
	Application.storage.set("febeMaxScriptTimeFEBE",febeMaxScriptTimeFEBE);	
	if(febeMaxScriptTimeDflt != febeMaxScriptTimeFEBE) febePrefs.setIntPref("dom.max_chrome_script_run_time",febeMaxScriptTimeFEBE);
	
	febeStartBackup();
	return true;
}//febeInit()

function febeMakeTimestampName(timestamp){
	var d=new Date();
	var YYYY = String(d.getFullYear());
	var MM = String(d.getMonth()+1);
	if(MM.length == 1){MM = "0" + MM;}
	var DD = String(d.getDate());
	if(DD.length == 1){DD = "0" + DD;}
	var hh = String(d.getHours());
	if(hh.length == 1){hh = "0" + hh;}
	var mm = String(d.getMinutes());
	if(mm.length == 1){mm = "0" + mm;}
	var ss = String(d.getSeconds());
	if(ss.length == 1){ss = "0" + ss;}
	
	timestamp = timestamp.replace("YYYY",YYYY);
	timestamp = timestamp.replace("MM",MM);
	timestamp = timestamp.replace("DD",DD);
	timestamp = timestamp.replace("hh",hh);
	timestamp = timestamp.replace("mm",mm);
	timestamp = timestamp.replace("ss",ss);
	return timestamp;
}//febeMakeTimestampName()

function febeVerifyTimestamp(timestamp){
  // Verify the timestamp mask
	if(timestamp == "FEBE YYYY MM-DD hh.mm.ss"){return true;}	// ISO8601
	if(timestamp == "FEBE YYYY DD.MM hh.mm.ss"){return true;}	// European
	var tmp="<style>color: red; font-weight: bold; font-size: 15px;</style>"+febeMsg[208];
	tmp = tmp.replace("%TIMESTAMP%",timestamp) +"\n\n";
	tmp += febeMsg[209].replace("%FORMAT1%","FEBE YYYY MM-DD hh.mm.ss")+"\n";
	tmp += febeMsg[210].replace("%FORMAT2%","FEBE YYYY DD.MM hh.mm.ss")+"\n\n";
	tmp += "<style>color: red; font-weight: bold; font-size: 15px;</style>"+febeMsg[211];
	febeAlert(tmp);
	return false;
}//febeVerifyTimestamp()

function febeVerify(verifyFileName){
return true
  // Verify backup was created
	if(!febeBuInProgress()){return true;} // Don't verify restores
	if(febeVerifyBackups == false){return true;}
	
	// Check for existance of backup file every second for a maximum of 10 seconds
	for(var i=0; i<5; i++){ 
		var chkFile = febeBuDesDir.clone();
		chkFile.append(verifyFileName);
		if(chkFile.exists()){return true;}
		febePause(1000);
	}//for	
	return false;
}//febeVerify()

function febeGetBDD(){
  // See if backup destination directory exists
	var prefName = "extensions.febe.extBUdir";
	if(febePrefs.prefHasUserValue(prefName)){
		febeExBuDir = febeGetUnicharPref(prefName); 
		if(febeExBuDir == ""){
			if(febePlatform == 1){febeExBuDir = "C:\\";}
			if(febePlatform == 2){febeExBuDir = "/";}
			if(febePlatform == 3){febeExBuDir = "/";}
		}//if
		febeBuDesDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		febeBuDesDir.initWithPath(febeExBuDir);
		if (!(febeBuDesDir.exists() && febeBuDesDir.isDirectory())){
			febeAlert(febeMsg[0]+" \""+febeExBuDir+"\" "+febeMsg[1]+"\n"+febeMsg[2]);
			return false;
		}//if
	} else {
		febeAlert(febeMsg[3]+"\n"+febeMsg[2]);
		return false;
	}//if
	return true;
}//febeGetBDD()

function febeDelTimestampDirs(){
  // Delete timestamped directories if needed
	if(febeMaxDirs == 0){return true;}	// No limit
	var timestamp = febePrefs.getCharPref("extensions.febe.timestamp.format");
	switch(timestamp){
		case "FEBE YYYY MM-DD hh.mm.ss":
			febeDelISO8601Dirs();
			break;
		case "FEBE YYYY DD.MM hh.mm.ss":
			febeDelEuropeanDirs();
			break;
	}//switch
	return true;
}//function febeDelTimestampDirs(){

function febeDelISO8601Dirs(){
  // Delete ISO8601 formated directories 
	var dirArray = [];
	var mask = /^FEBE \d\d\d\d \d\d-\d\d \d\d\.\d\d\.\d\d$/;
	var buDirRoot = febeBuDesDir.clone();
	var entries = buDirRoot.directoryEntries;
	
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var dirName = entry.leafName;
		if(!entry.isDirectory()){continue;}
		if(!dirName.match(mask)){continue;}
		dirArray.push(dirName);
	}
	var numDirsToDelete = dirArray.length - febeMaxDirs + 1;
	dirArray.sort();
	for(var i=0; i<numDirsToDelete; i++){
		var rmDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		rmDir.initWithPath(buDirRoot.path);
		rmDir.append(dirArray[i]);
		rmDir.remove(true);
	}//for
	return true;
}//febeDelTimestampDirs()

function febeDelEuropeanDirs(){
  // Delete European formated directories 
	var dirArray = {};
	var sortArray = [];
	var mask = /^FEBE \d\d\d\d \d\d.\d\d \d\d\.\d\d\.\d\d$/;
	var buDirRoot = febeBuDesDir.clone();
	var entries = buDirRoot.directoryEntries;
	
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var dirName = entry.leafName;
		if(!entry.isDirectory()){continue;}
		if(!dirName.match(mask)){continue;}
		var ISO8601 = febeNewDirName(0,dirName);
		sortArray.push(ISO8601);
		dirArray[ISO8601] = dirName;
	}
	sortArray.sort();
	var numDirsToDelete = sortArray.length - febeMaxDirs + 1;
	for(var i=0; i<numDirsToDelete; i++){
		var rmDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		rmDir.initWithPath(buDirRoot.path);
		var which = sortArray[i];
		rmDir.append(dirArray[which]);
		rmDir.remove(true);
	}//for
	return true;
}//febeDelEuropeanDirs()

function febeAbortBackup(){
  // Abort scheduled backup before it starts (only if statusbar icon is in "warning" state)
	var d = document.getElementById("febestatusbar");
	if(Boolean(d)){
		//if(febeHideIcons){febeSetStatusbarVisibility2(); return true;}
		var status = d.getAttribute("status");
		switch(status){
			case "warning":
				var tmp="<style>color: red; font-weight: bold; font-size: 15px;</style>"+febeMsg[179];
				if(!febeConfirm(tmp)){return;}

				for(var i in febeSetTimeoutID){
					var to = new febeSetTimeoutObj;
					to.PID = febeSetTimeoutID[i].PID;
					to.Process = febeSetTimeoutID[i].Process;
					clearTimeout(to.PID);
				}//for
				febeSetTimeoutID = [];

				febeScheduledBuTimer.cancel();
				var tmp = "<style>color: red; font-weight: bold;</style>"+febeMsg[150]+"\n";
				tmp += "<style>color: black; font-weight: bold;</style>"+febeMsg[151]+"\n";
				tmp += "<style>color: black; font-weight: normal;</style>"+febeMsg[152]+"\n";
				febeAlert(tmp);
				febePrefs.setBoolPref("extensions.febe.backupInProgress",false);	// In case it tries to start, just say no ...
				
				// Turn off scheduled backups 
				var prefName = "extensions.febe.schedule.frequency";
				febePrefs.setCharPref(prefName,"none");
				febeScheduleBackup();
				break;
			case "normal":
				var prefName = "extensions.febe.schedule.description";
				var tmp = "<style>color: blue; font-weight: normal;</style>"+febeMsg[114]+"\n";
				tmp += "<style>color: black; font-weight: normal;font-family: courier;</style>"+febeGetUnicharPref(prefName)+"\n\n";
				var lastBu = febeGetUnicharPref("extensions.febe.lastbackup");
				var lastBuType = febeMsg[267];
				var prefName = "extensions.febe.lastbackup.type.desc";
				if(febePrefs.prefHasUserValue(prefName)){lastBuType = febeGetUnicharPref(prefName);}
				tmp += "<style>color: blue; font-weight: normal;</style>"+febeMsg[268]+" "+lastBuType+"\n";
				tmp += "<style>color: black; font-weight: normal;font-family: courier;</style>"+lastBu+"\n\n";
				tmp += "<style>color: green; font-weight: bold; font-size: 12pt;</style>"+febeMsg[266];
				var OK = febeConfirm(tmp);
				if(OK){
					febeBackupRunType = 1;	//'Manual'
					febeInit();
				}
				break;
			case "nobackup": 
				var tmp = "<style>color: red; font-weight: normal; font-size: 12px;</style>"+febeMsg[113]+"\n\n";
				var lastBu = febeGetUnicharPref("extensions.febe.lastbackup");
				var lastBuType = febeMsg[267];
				var prefName = "extensions.febe.lastbackup.type.desc";
				if(febePrefs.prefHasUserValue(prefName)){lastBuType = febeGetUnicharPref(prefName);}
				tmp += "<style>color: blue; font-weight: normal;</style>"+febeMsg[268]+" "+lastBuType+"\n";
				tmp += "<style>color: black; font-weight: normal;font-family: courier;</style>"+lastBu+"\n\n";;
				tmp += "<style>color: green; font-weight: bold; font-size: 12pt;</style>"+febeMsg[266];
				febeSetStatus();
				var OK = febeConfirm(tmp);
				if(OK){
					febeBackupRunType = 1;	//'Manual'
					febeInit();
				}
				break;
		}//switch
	}//if
	return true;
}//febeAbortBackup()

function febeCheckPending(){
  // See if any pending extension/theme installations exist
	var prefName = "extensions.febe.warnpending";
	var warn = febePrefs.getBoolPref(prefName);
	
	var extDir = febeProfDir.clone();
	extDir.append("extensions");
	extDir.append("staged");
	if(!extDir.exists()){return true;}
	febePendingCount = 0;
	var entries = extDir.directoryEntries;
	while(entries.hasMoreElements()){	
		var item = entries.getNext().QueryInterface(Components.interfaces.nsIFile);
		var ext = item.leafName.substr(item.leafName.lastIndexOf("."));
		if(ext != ".json")febePendingCount++;  		
	}//while
	var style = "<style>color: red;font-size: 12pt;</style>";
	var tmp = febeMsg[212].replace("%NUM%",febePendingCount);
	tmp = style+tmp+"\n\n"+febeMsg[213];
	if(warn){return febeConfirm(tmp);}
	return true;
}//febeCheckPending()

function febeSanityCheck(){
  // Check to see if there is anything to backup
	var OK = (
		febeBuExtensions ||
		febeBuThemes ||
		febeBuBookmarksJSON ||
		febeBuBookmarksHTML ||
		febeBuPreferences ||
		febeBuCookies ||
		febeBuUserChrome ||
		febeBuUserPwd ||
		febeBuSearchPlugins ||
		febeBuBrowserHistory ||
		febeBuFormFillHistory ||
		febeBuPermissions ||
		febeBuUDBu ||
		febeIncludeFEBEinBu ||
		febeBuProfile);
	if(!OK){febeAlert(febeMsg[131]);}
	return OK;
}//febeSanityCheck()

function febeDoBackup(){
	febeExtensionsList = {};
	febeThemesList = {};
	febeErrorList = [];
	febeWarningList = [];
	febeDisabledCount = 0;
	febeSkippedCount = 0;
	//febePendingCount = 0;
	febeExtensionsList["**total**"] = 0;  	// Associative arrays don't have a 
	febeThemesList["**total**"] = 0;		// 'length' property ... So keep count
	febePrefs.setBoolPref("extensions.febe.backupInProgress",true);
	febeGetPrefs();
	if(!febeBuProfile){
		if(!febeBackupExtensions()){
			febeCloseProgressWindow();
			return false;
		}//if
		febeBackupPersonas();
		febeBackupBookmarksJSON();
		febeBackupBookmarksHTML();
		febeBackupPreferences();
		febeBackupCookies();
		febeBackupUserChrome();
		febeBackupPasswords();
		febeBackupSearchPlugins();
		febeBackupBrowserHistory();
		febeBackupFormFillHistory();
		febeBackupPermissions();
		febeBackupUDBu();
		febeUpBackedUp = false;
		if(febeBUtype == "both"){
			febeBackupProfile();
		}//if
	}else{
		febeBackupProfile();
	}
	febeIncludeFEBE();
	febeWriteResults();
	febeStoreBUdate(); 
	
	setTimeout(febeCloseProgressWindow,500);
		
	febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
	febeScheduleBackup();	// Schedule the next backup
	febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
	
	// Reset javascript execution time if necessary
	var febeMaxScriptTimeDflt = Application.storage.get("febeMaxScriptTimeDflt",0);
	var febeMaxScriptTimeFEBE = Application.storage.get("febeMaxScriptTimeFEBE",0);
	if(febeMaxScriptTimeDflt != febeMaxScriptTimeFEBE){febePrefs.setIntPref("dom.max_chrome_script_run_time",febeMaxScriptTimeDflt);}

	// Upload to box.net?
	var prefName = "extensions.febe.boxnet.enabled";
	var enabled = febePrefs.getBoolPref(prefName);
	var prefName = "extensions.febe.boxnet.autoupload";
	var upload = febePrefs.getBoolPref(prefName);
	var prefName = "extensions.febe.boxnet.uploadwindow";
	var dispwindow = febePrefs.getBoolPref(prefName);
	
	if(enabled && upload){	// Upload if requested - shutdown is initiated at the end of the upload routine if we're doing a backup on shutdown
		febeOpenBoxUploadWindow();
/*
		if(dispwindow == true){
			window.openDialog('chrome://febe/content/BoxNet.xul','FEBE upload', 'chrome,alwaysRaised,centerscreen,resizable,minimizable',febeMsg);		
		}else{	// Don't display window, but do the upload
			Application.storage.set("febeMsg",febeMsg)
			setTimeout(febeUploadBackup,2000)
		}//if
*/
	}else{	
		if(Application.storage.get("backupOnShutdownCompleted", false)){setTimeout(febeShutdown,3000)}	// Backup on shutdown
	}//if
	return true;
}//febeDoBackup()

function febeCloseProgressWindow(){
	// Close the progress window, dammit!
	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var enumerator = wm.getEnumerator("febe:progress");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		win.close();
	}//while
	//febeProgressWin.close();	// Don't just merely close, but really most sincerely close!
}//febeCloseProgressWindow()

function febeShutdown(){
	var application = Cc["@mozilla.org/toolkit/app-startup;1"].getService(Ci.nsIAppStartup);
	application.quit(application.eAttemptQuit);
	return true;
}//febeShutdown()

function febeStoreBUdate(){
  // Write last backup info to preferences
	febeSetUnicharPref("extensions.febe.lastbackup",new Date());
	febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
	febeSetUnicharPref("extensions.febe.lastbackup.folder",febeBuDesDir);
	return true;
}//febeStoreBUdate()

function febeIncludeFEBE(){
  // Include a copy of FEBE with backup
	if(!febeIncludeFEBEinBu){return;}
	if(febeFEBEbackedUp){return;}	// Don't need two copies!  Was aready backed up during extension backup.
	
	var febeExtBuName = "FEBE{" + febePrefs.getCharPref("extensions.febe.currentversion") + "}.xpi";
	febeExBuDir = febeGetUnicharPref("extensions.febe.curBUdir");	
	//var eDir = febeProfDir.clone();
	//eDir.append("extensions");
	//eDir.append(FEBE_GUID);	
	//var extPath = eDir.path;
	var item = febeAddons[FEBE_GUID];
	if(item.isXpi == true){	// Perform a straight copy for xpis
		febeCopyFile(item.installlocation,febeExBuDir,febeExtBuName);
	}else{
		febeZip(item.installlocation,febeExBuDir,febeExtBuName,false,false,febeRunAsync);	
	}//if
	if(febeErr == "skip"){
		item.skipped = true;
		item.iconURL = "chrome://febe/skin/nobu.png";
		febeSkippedCount++;
	}else{
		item.skipped = false;
		febeExtensionsList["**total**"]++;	
	}//if
	febeExtensionsList[febeExtBuName] = item;
	return true;
}//febeIncludeFEBE()

function febeWriteResults(){
	febeInitEssentials();
	febeVerifyBackup();
 // Stop timer
	var d = new Date();
	var febeStopTime = d.getTime();
	var febeStartTime = febePrefs.getCharPref("extensions.febe.buStartTime");
	var elapsedTime =  (febeStopTime - febeStartTime)/1000;
	
  // Create results page	
	febeUpdateProgressWindow(febeMsg[77]);
    
	// Pointer to results page html file
	var febeResultsPage = febeProfDir.clone();
	febeResultsPage.append("FEBEresults.html");
		
  // Open results page for writing
	var resultsFile = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	resultsFile.init(febeResultsPage, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
  // Get results template
	var resultsTemplate=febeGetResultsTemplate("chrome://febe/content/FEBEresultsTemplate.html")
	
  // Detail or summary?	
	var format = febePrefs.getCharPref("extensions.febe.resultsFormat");
	var detail = Boolean(false);
	if(format == "detail"){detail = true;}
  
  // Add results to results page
	var middle = new String();
	var cnt = 0;
		
  // Create the new content
	var numExt = parseInt(febeExtensionsList["**total**"]);
	var numThemes = parseInt(febeThemesList["**total**"]);

	delete febeExtensionsList["**total**"];
	delete febeThemesList["**total**"];

	// Sort using key array
	var febeExtKey = [];
	var febeThemeKey = [];
	for(var i in febeExtensionsList){
		febeExtKey.push(i);
	}//for

	for(var i in febeThemesList){
		febeThemeKey.push(i);
	}//for
	febeExtKey.sort();
	febeThemeKey.sort();

	var total = numExt + numThemes;
	if (febeBmBackedUpJSON){total++};
	if (febeBmBackedUpHTML){total++};
	if (febePrBackedUp){total++};
	if (febeCkBackedUp){total++};
	if (febeChBackedUp){total++};
	if (febeUcBackedUp){total++};
	if (febePwBackedUp){total++};
	//if (pdBackedUp){total++};
	if (febeSpBackedUp){total++};
	if (febeHsBackedUp){total++};
	if (febeFfBackedUp){total++};
	if (febePmBackedUp){total++};
	if (febeUpBackedUp){total++};
	total += febeUdBackedUp;

	var re = new RegExp("\\\\", "g");
	var errCnt = 0;
	var warnCnt = 0;
	var imgstyle = ' height="16" width="16" '
	var table = ['<table border="0" cellpadding="2" cellspacing="2">\n<tbody>',"</tbody>\n</table>"];
	var tr = ["<tr>\n","</tr>\n"];
	var tdnum = ['<td style="vertical-align: middle; text-align: right;"><num>'
			,"</num></td>\n"];
	var tdimg = ['<td style="text-align: center;">','</td>\n'];
	var tdnolink = ['<td style="font-weight: bold;"><nolink>','</nolink></td>\n'];
	var tdlink = ['<td style="font-weight: bold;">','</td>\n'];
	var tdguid = ['<td><guid>','</guid></td>\n'];
	var div = ['<div style="text-align:left; direction: ltr;">\n',"</div>\n"];
	var disabledIndicator = '<img src="chrome://febe/skin/disabled.png"'+imgstyle+'>';
	var itemSkipped = '<img src="chrome://febe/skin/nobu.png"'+imgstyle+'>';
	var itemIgnored = '<img src="chrome://febe/skin/ignore.png"'+imgstyle+'>';
	var useragent = ['<useragent>','</useragent>'];
	var febeBUdate = febeLocalizedDate(Date());
	middle += febeBUdate+"<br/>\n";
	middle += "<p>"+febeMsg[285]+"&nbsp;"+febeGetUnicharPref("extensions.febe.lastbackup.type.desc");
	middle += "&nbsp;&nbsp;&mdash;&nbsp;&nbsp;<i>"+febeMsg[284].replace("%SECONDS%",elapsedTime)+"</i><br/>\n"	
	middle += febeBuildLegendTable()+"<br/>\n";
	middle += febeMsg[12]+"     "+total+"&nbsp;"+febeMsg[13];
	var prefix = "file:///";
	if (febeExBuDir.substring(0,2) == "\\\\"){prefix = "file:///"}	// add extra "\" for networked drive
	middle += "&nbsp;&nbsp;&mdash;&nbsp;&nbsp;<i>"+febeMsg[15]+'&nbsp;<a href=\"'+prefix+febeExBuDir.replace(re,"/")+'\">'+febeExBuDir+"</a></i></p>\n";
	if(febeSkippedCount != 0){
		middle += "<i>*** "+febeMsg[353].replace("%skipped%",febeSkippedCount)+"</i><br/>\n";
		cnt = 0;
		febeIgnoredList = Application.storage.get("febeIgnoredList","");

		if(detail == true){
			middle += "</p>\n"+div[0]+table[0];
			for(var i in febeIgnoredList){
				cnt++;
				var item = febeIgnoredList[i];
				middle += tr[0];
				middle += tdnum[0]+cnt+"."+tdnum[1];
				middle += tdimg[0]+itemIgnored+tdimg[1];
				var tmp = item.name;				
				var ver = "<span class='version'>"
				ver +="&nbsp;(v"+item.version+")&nbsp;</span>"
				
				var desc = item.desc;
				desc = "<span class='description'>&nbsp;&nbsp;&nbsp;&mdash;&nbsp;"+desc+"</span>";
				
				if(item.homepageURL != null){
					middle += tdlink[0]+"<a href='"+item.homepageURL+"' "+item.tooltip+">"+tmp+"</a>"+ver+desc+tdlink[1];
				}else{
					middle += tdnolink[0]+"<span "+item.tooltip+">"+tmp+"</span>"+ver+desc+tdnolink[1];
				}//if	
				middle += tr[1];
			}//for
			middle += table[1]+div[1];
		}//if	
	}//if
	
	cnt = 0;
	if ((total) != 0){
		if (numExt != 0){
			middle += "<p>"+febeMsg[14]+" "+numExt+"&nbsp;"+febeMsg[13]+"\n";
			if(febeDisabledCount != 0){
				middle += "&nbsp;&nbsp;<i>*** "+febeMsg[107].replace("%num%",febeDisabledCount)+"</i>\n";
			}else{
				//middle += "&nbsp;&nbsp;&mdash;&nbsp;&nbsp;"+febeMsg[120].replace("%disabled%",disabledIndicator)+"\n";
			}//if
			if(febePendingCount != 0){
				middle += "<br/><i>*** "+febeMsg[278].replace("%num%",febePendingCount)+"</i>\n";
			}//if
			if(detail == true){
				middle += "</p>\n"+div[0]+table[0];
				for(var i=0; i<febeExtKey.length; i++){
					var key = febeExtKey[i];
					var item = febeExtensionsList[key];
					item.verified = null;
					if(febeVerifyBackups == true) item.verified = febeBuItemVerifiedList[key].verified;
					//if(item.verified == false){
						//febeErrorList.push(febeMsg[18]+"&nbsp;"+item.name);
						//errCnt++;
						//continue;
					//}//if
					cnt++;
					middle += tr[0];
					middle += tdnum[0]+cnt+"."+tdnum[1];
					if(item.verified != null){
						if(item.verified == true){
							var img = "chrome://febe/skin/checkbox.png";
						}else{
							var img = "chrome://febe/skin/notvalid.png";
						}//if
						middle += tdimg[0]+"<img src='"+img+"'"+imgstyle+">"+tdimg[1];
					}//if
					middle += tdimg[0]+"<img src='"+item.iconURL+"'"+imgstyle+">"+tdimg[1];
					var tmp = item.name;
					if(item.userDisabled){
						tmp = "<i>"+tmp+"</i>";
					}else{
						tmp = tmp;
					}//if
					
					var ver = "<span class='version'>"
					ver +="&nbsp;(v"+item.version+")&nbsp;</span>"
					
					var desc = item.desc;
					desc = "<span class='description'>&nbsp;&nbsp;&nbsp;&mdash;&nbsp;"+desc+"</span>";
					
					if(item.homepageURL != null){
						middle += tdlink[0]+"<a href='"+item.homepageURL+"' "+item.tooltip+">"+tmp+"</a>"+ver+desc+tdlink[1];
					}else{
						middle += tdnolink[0]+"<span "+item.tooltip+">"+tmp+"</span>"+ver+desc+tdnolink[1];
					}//if	
					middle += tr[1];
				}//for
				middle += table[1]+div[1];
			}//if
		}//if
		
		cnt = 0;
		if (numThemes != 0){
			middle += "<p>"+febeMsg[16]+" ("+numThemes+"&nbsp;"+febeMsg[13]+")</p>\n";
			if(detail == true){
				middle += div[0]+table[0];
				//var item = new febeExtObj;
				for(var i=0; i<febeThemeKey.length; i++){
					var key = febeThemeKey[i];
					var item = febeThemesList[key];
/*
					if(item.verified == false){
						febeErrorList.push(febeMsg[18]+"&nbsp;"+item.Name);
						errCnt++;
						continue;
					}//if
*/
					cnt++;
					middle += tr[0];
					middle += tdnum[0]+cnt+"."+tdnum[1];
					middle += tdimg[0]+"<img src='"+item.iconURL+"'"+imgstyle+">"+tdimg[1];

					var tmp = item.name;
					if(item.userDisabled){
						tmp = "<i>"+tmp+"</i>";
					}else{
						tmp = tmp;
					}//if
					
					var desc = item.desc;
					if(item.isPersona) desc = febeMsg[340]+"  "+desc;
					desc = "<span class='description'>&nbsp;&nbsp;&nbsp;&mdash;&nbsp;"+desc+"</span>";

					if(item.homepageURL != null){
						middle += tdlink[0]+"<a href='"+item.homepageURL+"' "+item.tooltip+">"+tmp+"</a>"+ver+desc+tdlink[1];
					}else{
						middle += tdnolink[0]+"<span "+item.tooltip+">"+tmp+"</span>"+ver+desc+tdnolink[1];
					}//if	
					middle += tr[1];
				}//for
				middle += table[1]+div[1];
			}//if
		}//if
	}else{
		febeErrorList.push("<p>"+febeMsg[19]+"</p>\n");
		errCnt++;
	}//if
	
	middle += "<p>";
	if(!febeBuProfile){
		// Optional backups
		if (febeBuBookmarksJSON){
			if (febeBmBackedUpJSON){
				middle +=febeMsg[27]+"&nbsp;<b>"+febeBmBuNameJSON+"</b><br/>\n"
			}else{
				febeErrorList.push(febeMsg[30]);
				errCnt++;
			}//if
		}//if
		if (febeBuBookmarksHTML){
			if (febeBmBackedUpHTML){
				middle +=febeMsg[27]+"&nbsp;<b>"+febeBmBuNameHTML+"</b><br/>\n"
			}else{
				febeErrorList.push(febeMsg[30]);
				errCnt++;
			}//if
		}//if
		if (febeBuPreferences){
			if (febePrBackedUp){
				middle +=febeMsg[28]+"&nbsp;<b>"+febePrBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[31]);
				warnCnt++;
			}//if
		}//if
		if (febeBuCookies){
			if (febeCkBackedUp){
				middle +=febeMsg[29]+"&nbsp;<b>"+febeCkBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[32]);
				warnCnt++;
			}//if	
		}//if	
			if (febeBuUserChrome){
			if (febeChBackedUp){
				middle +=febeMsg[52]+"&nbsp;<b>"+febeChBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[60]);
				warnCnt++;
			}//if
		}//if	
			if (febeBuUserPwd){
			if (febePwBackedUp){
				middle +=febeMsg[54]+"&nbsp;<b>"+febePwBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[62]);
				warnCnt++;
			}//if	
		}//if
			if (febeBuSearchPlugins){
			if (febeSpBackedUp){
				middle +=febeMsg[56]+"&nbsp;<b>"+febeSpBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[64]);
				warnCnt++;
			}//if
		}//if	
			if (febeBuBrowserHistory){
			if (febeHsBackedUp){
				middle +=febeMsg[57]+"&nbsp;<b>"+febeHsBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[65]);
				warnCnt++;
			}//if
		}//if	
			if (febeBuFormFillHistory){
			if (febeFfBackedUp){
				middle +=febeMsg[58]+"&nbsp;<b>"+febeFfBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[66]);
				warnCnt++;
			}//if
		}//if	
			if (febeBuPermissions){
			if (febePmBackedUp){
				middle +=febeMsg[116]+"&nbsp;<b>"+febePmBuName+"</b><br/>\n"
			}else{
				febeWarningList.push(febeMsg[115]);
				warnCnt++;
			}//if
		}//if	
		if (febeBuUDBu){
			for(var i in febeUDBuDone){
				var item = new febeUDBuDoneObj;
				item.Description = febeUDBuDone[i].Description;
				item.Name = febeUDBuDone[i].Name;
				var tmp = febeMsg[148].replace("%description%","\""+item.Description+"\"");
				tmp = tmp.replace("%name%","&nbsp;<b>"+item.Name+"</b><br/>\n");
				middle += tmp;
			}//for
		}//if	
	}//if
	if(febeBuProfile == true || febeBUtype == "both"){
//alert(febeUpBackedUp)
		if (febeUpBackedUp){
			middle +=febeMsg[59]+"&nbsp;<b>"+febeUpBuName+"</b><br/>\n"
		}else{
			febeErrorList.push(febeMsg[67]);
			errCnt++;
		}//if	
	}//if
	middle += "</p>\n";
	
  // Write the final results
	var pageSource = resultsTemplate.replace("%title%", febeMsg[108]);
	pageSource = resultsTemplate.replace("%title%", febeMsg[108]);
	pageSource = pageSource.replace("%reportheading%", febeMsg[109]);
	pageSource = pageSource.replace("%version%", febeMsg[49]+" "+febePrefs.getCharPref("extensions.febe.currentversion"));
	
	var fmt = febePrefs.getCharPref("extensions.febe.resultsFormat");
	if(fmt == "detail"){
		pageSource = pageSource.replace("%format%", febeMsg[323]);
	}else{
		pageSource = pageSource.replace("%format%", febeMsg[324]);
	}//if
	
	pageSource = pageSource.replace("%by%", febeMsg[180]);
	pageSource = pageSource.replace("%results%", middle);
	var prefName = "extensions.febe.orientation";
	var orientation = febePrefs.getCharPref(prefName);
	pageSource = pageSource.replace("%orientation%", orientation);
	middle = "";
	errCnt = febeErrorList.length;
	if(errCnt != 0){
		pageSource = pageSource.replace("%errmsg%", "<errh>"+errCnt+" "+febeMsg[112]+"</errh>");
		middle = div[0];
		for(var i=0; i<febeErrorList.length; i++){
			middle += "<err>"+febeErrorList[i]+"</err><br/>\n";
		}//for
		middle += "<br/><i>"+febeMsg[355]+"</i><br/>\n";
		middle += div[1];
		pageSource = pageSource.replace("%errlist%", middle);
	}else{
		pageSource = pageSource.replace("%errmsg%<br/>", "<!-- %errmsg% -->\n");
		pageSource = pageSource.replace("%errlist%<br/>", "<!-- %errlist% -->\n");
	}//if
	if(warnCnt != 0){
		pageSource = pageSource.replace("%warnmsg%", "<warnh>"+warnCnt+" "+febeMsg[132]+"</warnh>");
		middle = div[0];
		for(var i=0; i<febeWarningList.length; i++){
			middle += "<warn>"+febeWarningList[i]+"</warn><br/>\n";
		}//for
		middle += div[1];
		pageSource = pageSource.replace("%warnlist%", middle);
	}else{
		pageSource = pageSource.replace("%warnmsg%<br/>", "<!-- %warnmsg% -->\n");
		pageSource = pageSource.replace("%warnlist%<br/>", "<!-- %warnlist% -->\n");
	}//if
	
	if(febePrefs.getBoolPref("extensions.febe.boxnet.enabled") && febePrefs.getBoolPref("extensions.febe.boxnet.autoupload")){
		var boxmsg = '<div style="text-align:left; color: green; font-weight: bold;">'+febeMsg[265]+"</div><br/>";
		pageSource = pageSource.replace("%boxupload%", boxmsg);
	}else{
		pageSource = pageSource.replace("%boxupload%", "<!-- %boxupload% -->\n");
	}//if
	
	pageSource = pageSource.replace("%useragent%", useragent[0]+febeMsg[191] + " " + navigator.userAgent+useragent[1]);
	pageSource = pageSource.replace("%hompagemsg%", febeMsg[110]);
	pageSource = pageSource.replace("%linkmsg%", febeMsg[111]);
	
	// Create an UTF-8 output stream
	var charset = "UTF-8";
	var os = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);

	os.init(resultsFile, charset, 4096, 0x0000);
	os.writeString(pageSource);
	os.close();
	
  // Open and display results
	var finalPage = "chrome://febe/content/febeResultsLoad.html";
	if(febeDispResults){
		febeOpenResultsPage(finalPage);
  }//if
	var resultsPageURL = "";
	if(febeSaveResults){
	  // Save results page with backup
		var timestamp = febePrefs.getCharPref("extensions.febe.timestamp.format");
		var d=new Date();
		var YYYY = String(d.getFullYear());
		var MM = String(d.getMonth()+1);
		if(MM.length == 1){MM = "0" + MM;}
		var DD = String(d.getDate());
		if(DD.length == 1){DD = "0" + DD;}
		var hh = String(d.getHours());
		if(hh.length == 1){hh = "0" + hh;}
		var mm = String(d.getMinutes());
		if(mm.length == 1){mm = "0" + mm;}
		var ss = String(d.getSeconds());
		if(ss.length == 1){ss = "0" + ss;}
		
		timestamp = timestamp.replace("YYYY",YYYY);
		timestamp = timestamp.replace("MM",MM);
		timestamp = timestamp.replace("DD",DD);
		timestamp = timestamp.replace("hh",hh);
		timestamp = timestamp.replace("mm",mm);
		timestamp = timestamp.replace("ss",ss);

		var dName = febeMsg[76]+" - "+timestamp+".html"; 
		febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
		febeCopyFile(febeResultsPage.path,febeBuDesDir,dName);
		
		// Save pointer to results page
		var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		aFile.initWithPath(febeBuDesDir);
		aFile.append(dName);
		if(aFile.exists()) resultsPageURL = aFile.path;
	}//if
	febeSetUnicharPref("extensions.febe.lastbackupresultspageurl",resultsPageURL);
	
	// Set last backup type in preferences
	var lastbutype;
	if(febeBuProfile == false){
		lastbutype = "selective"
	}else{
		lastbutype = "profile";
	}//if
	febePrefs.setCharPref("extensions.febe.lastbackup.type", lastbutype);
	
	// Write backup history
	var history = new Object;
	history.date = febeBUdate;
	history.type = febeGetUnicharPref("extensions.febe.lastbackup.type.desc");
	history.time = elapsedTime;
	history.runtype = febeBackupRunType;
	history.resultsurl = febeExBuDir;
	history.resultspage = resultsPageURL;
	febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	febeDataFile.append(FEBEBUHISTORYFILE);
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(febeDataFile, 0x08 | 0x10 | 0x04, 0700, 0); // Create, append, read/write
	var cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	var jstr = JSON.stringify(history);
	cos.writeString(jstr+"\n");
	cos.close();

	// Play sound
	if(errCnt == 0){
		febePlaySound("success");
	}else{
		febePlaySound("failure");
	}//if	

  return true;
}//febeWriteResults()

function febeBuildLegendTable(){
	var doc = document.implementation.createDocument ('http://www.w3.org/1999/xhtml', 'html', null);
	var body = doc.createElementNS('http://www.w3.org/1999/xhtml', 'body');
	doc.documentElement.appendChild(body);
	var span = doc.createElement("span");
	var table = doc.createElement("table");
	var row = doc.createElement("tr");
	var txt = document.createTextNode("");
	var cell = doc.createElement("td");
	var img = doc.createElement("img");
	var imgStyle = "width: 16px; height: 16px;"
	var cellStyle = "text-align: center;";

	// Setup the table
	table.setAttribute("style","text-align: left;");
	table.setAttribute("border","1");
	table.setAttribute("cellpadding","2");
  table.setAttribute("cellspacing","2");
	row.setAttribute("style","font-family: Helvetica,Arial,sans-serif; font-size: 16px;");
	
	// Create the cells
	cell.setAttribute("style",cellStyle);
	var txt = document.createTextNode(febeMsg[360]+" ");
	cell.appendChild(txt);
	row.appendChild(cell);
	
	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/disabled.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[361]);
	cell.appendChild(img);
	row.appendChild(cell);

	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/nobu.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[362]);
	cell.appendChild(img);
	row.appendChild(cell);

	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/checkbox.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[363]);
	cell.appendChild(img);
	row.appendChild(cell);

	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/notvalid.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[364]);
	cell.appendChild(img);
	row.appendChild(cell);

	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/xpinstallItemGeneric.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[365]);
	cell.appendChild(img);
	row.appendChild(cell);

	var cell = cell.cloneNode(false);
	cell.setAttribute("style",cellStyle);
	var img = img.cloneNode(false);
	img.setAttribute("src","chrome://febe/skin/ignore.png");
	img.setAttribute("style",imgStyle);
	img.setAttribute("title",febeMsg[392]);
	cell.appendChild(img);
	row.appendChild(cell);

	table.appendChild(row);
	span.appendChild(table);
	body.appendChild(span);
	return body.innerHTML;
}//febeBuildLegendTable()

function febeWarn(){
  // Display scheduled backup warning in statusbar
	if(!febeIsScheduleController) {return true;}
	if(febeHideIcons){return true;}
	var d = febeControllerWindow.document.getElementById("febestatusbar");
	d.setAttribute("status","warning");
	febePlaySound("warning");
	for(var i=10000; i<= 40000; i += 10000){
		var to = new febeSetTimeoutObj;
		to.PID = setTimeout(febePlayWarning,i)
		to.Process = '';
		febeSetTimeoutID.push(to);
	}//for
	return true;
}//febeWarn()

function febePlayWarning(){
	febePlaySound("warning");
}//febePlayWarning()

function febeDebug(aMsg) {
   setTimeout(function() { throw new Error("[debug] " + aMsg); }, 0);
   return true;
}//debug

function febeStartBackup(){
	if(febeBuInProgress()){
		if(!febeBuInProgressCheck()) {return false;}
	}//if
	var win = febeControllerWindow;
	try{
		if(win.document.getElementById("febeTLBRbutton")){
			win.document.getElementById("febeTLBRbutton").status = "disabled";
			win.document.getElementById("febeTLBRbutton").hidden = "true";
		}//if
	}catch(e){;}
	if(febeDispProgress == true){
		// Open the progress window
		febeProgressWin = openDialog("chrome://febe/content/febeProgress.xul", "FEBE", "chrome,alwaysRaised,centerscreen,dialog='no',modal='no'");
		Application.storage.set("febeProgressWin", febeProgressWin);
		setTimeout(febeDoBackup,1000);
	}else{
		febeGetBuType();
		febeDoBackup();
	}//if
	
	try{
		if(win.document.getElementById("febeTLBRbutton")){
			win.document.getElementById("febeTLBRbutton").setAttribute("status","normal");
			win.document.getElementById("febeTLBRbutton").setAttribute("hidden","false");
		}//if
		win.document.getElementById("febestatusbar").Class = "statusbarpanel-iconic febe-normal";
		win.document.getElementById("febestatusbar").hidden = febeHideIcons;
		win.document.getElementById("febestatusbar").collapsed = febeHideIcons;
	}catch(e){;}
	var win = "";	// Clear memory
	return true;
}//febeStartBackup()

function febeGetResultsTemplate(aURL){
	var req = new XMLHttpRequest();
	req.open('GET', aURL, false);
	req.send(null);
	return req.responseText;
}//febeGetResultsTemplate()

function febeDirCopy(sourceDir){
// Recursively copy individual files and sub-directories to a destination directory
// 
// Example:
//	sourceDir (intially) = [profiledir]/extensions
//	febeSubRootDir = {4BBDD651-70CF-4821-84F8-2B918CF89CA3}
//	febeDestDir = nsIFile to [temp]/febe.tmp
//
//		All files and sub-directories in [profiledir]/extensions/{4BBDD651-70CF-4821-84F8-2B918CF89CA3}
//		will be copied to [temp]/febe.tmp/{4BBDD651-70CF-4821-84F8-2B918CF89CA3}

	var tmp = "sourceDir: "+sourceDir;
	tmp += "\nfebeSubRootDir: "+febeSubRootDir;
	tmp += "\nfebeDestDir: "+febeDestDir.path;
	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aFile) return false;

	aFile.initWithPath(sourceDir);
	var entries = aFile.directoryEntries;
	
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var src = entry.path;
		var p = src.indexOf(febeSubRootDir)
		if(p == -1){continue;}
		if(entry.isDirectory()){
			febeDirCopy(src);
		}else{
			var parentPath = entry.parent.path;
			var dest = febeDestDir.path+"\\"+parentPath.substring(p);
			var file = entry.leafName;
			febeCopyFile(src,dest,file);
		}//if
	}//while
	return true;
}//febeDirCopy()

function febePickFiles(filter,msgNum){
  // Select extension/themes to install
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[msgNum], nsIFilePicker.modeOpenMultiple);
	fp.appendFilter(filter,filter);
	
	// Set the default directory to the backup destination directory
	var prefName = "extensions.febe.extBUdir";
	if(!febePrefs.prefHasUserValue(prefName)){
		febeGetPrefs();
		if(febePlatform == 1){febeExBuDir = "C:\\";}
		if(febePlatform == 2){febeExBuDir = "/";}
		if(febePlatform == 3){febeExBuDir = "/";}
	}else{
		febeExBuDir = febeGetUnicharPref(prefName);
	}//if
	
	if(febeExBuDir != ""){
		var aDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		aDir.initWithPath(febeExBuDir);
		fp.displayDirectory = aDir;
	}//if

	var rv = fp.show();
	febeETinstall = [];
	if (rv == nsIFilePicker.returnOK){
		var files = fp.files;
		while(files.hasMoreElements()) {
			var file = files.getNext()
				.QueryInterface(Ci.nsILocalFile);
			var obj = {};
			obj.Name = file.leafName;
			obj.Path = file.path;
			obj.nsFile = file
			febeETinstall.push(obj);
		}//while
	}//if
//alert(febeETinstall)
	return true;
}//febePickFiles()

function febePickRestoreFile(filter,msgNum){
  // Select a file to restore
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[msgNum], nsIFilePicker.modeOpen);
	febePlatform = febeGetPlatform();
	
	// Fix for mac - Can't handle strings like "bookmarks*.json". - Change to "*.json"
	if(febePlatform == 3){
		var n = filter.indexOf("*");
		filter = filter.substr(n);
	}//if
//alert("febePlatform: "+febePlatform+"\nfilter: "+filter)
	fp.appendFilter(filter,filter);
	// Set the default directory to the backup destination directory
	var prefName = "extensions.febe.extBUdir";
	if(!febePrefs.prefHasUserValue(prefName)){
		febeGetPrefs();
		if(febePlatform == 1){febeExBuDir = "C:\\";}
		if(febePlatform == 2){febeExBuDir = "/";}
		if(febePlatform == 3){febeExBuDir = "/";}
	}else{
		febeExBuDir = febeGetUnicharPref(prefName);
	}//if
	if(febeExBuDir != ""){
		var aDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		aDir.initWithPath(febeExBuDir);
		fp.displayDirectory = aDir;
	}//if

	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		rv = fp.file;
		febePathName = rv.path;
		febePrName = febePfName = rv.leafName;
		febePfParent = rv.parent.path;
		return true;
	}//if
	return false;
}//febePickRestoreFile()

function febePickFile(filter,msgNum,dfltDir){
  // Select a file to restore
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[msgNum], nsIFilePicker.modeOpen);
	
	// Fix for mac - Can't handle strings like "bookmarks*.json". - Change to "*.json"
	if(febePlatform == 3){
		var n = filter.indexOf("*");
		filter = filter.substr(n);
	}//if
	
	fp.appendFilter(filter,filter);
	
	if(dfltDir != ""){
		var aDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		aDir.initWithPath(dfltDir);
		fp.displayDirectory = aDir;
	}//if
	
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		//rv = fp.file;
		//febePathName = rv.path;
		//febePrName = febePfName = rv.leafName;
		//febePfParent = rv.parent.path;
		return fp.file.path;
	}//if
	return false;
}//febePickFile()

function febePickDir(dfltDir,msgNum){
  // Select a directory
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[msgNum], nsIFilePicker.modeGetFolder);
	fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    // Set default directory to current backup directory
	if(dfltDir != ""){
		var dd = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dd.initWithPath(dfltDir);
		fp.displayDirectory = dd;
	}//if
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		return fp.file.path;
	}else{
		return false;
	}//if
}//febePickDir()

function febeConfirmRestore(msgNum,bDate){
	febeGetPlatform();
	if(febePlatform == 3){return true;}	// Mac can't handle modal alerts properly, so just assume they clicked "OK"
	var style = "<style>color: red;font-size: 14pt;</style>";
	var tmp = style+febeMsg[36] +"\n";
	tmp += febeMsg[msgNum] + "\n";
	if(bDate != ""){tmp += febeLocalizedDate(bDate) + "\n";}
	tmp += "\n";
	if(bDate != ""){tmp += febeMsg[45] + "\n";} 
	tmp += febeMsg[40];
	tmp += "\n" + febeMsg[41];
	return febeConfirm(tmp);
}//febeConfirmRestore()

function febeUpdateProgressWindow(pMsg){
	if(!febeDispProgress) return true;
	//try{
		var pMsgField = febeProgressWin.document.getElementById("febeProgressText");
		if(pMsgField){pMsgField.setAttribute("value",pMsg)};
		febeProgressWin.focus();
	//}catch(e){;}
	return true;
}//febeUpdateProgressWindow()

function febeClearDir(){
	// Clear destination directory
	febeBackupAborted = false;
  if(febeClearDestDir == false){return true;}
	var entries = febeBuDesDir.directoryEntries;
	var numFiles = 0;
	var numDirs = 0;
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		if(entry.isFile()){numFiles++;}
		if(entry.isDirectory()){numDirs++;}
	}//while

	// Warn before delete?
	var prefName = "extensions.febe.clearwarning";
	var clearWarning = febePrefs.getBoolPref(prefName);	
	if((clearWarning) && numFiles != 0){
		var promptService = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);
		var checkResult = {};

		var x1 = new RegExp("x1");
		var x2 = new RegExp("x2");
		var tmp = febeMsg[99];
		tmp = tmp.replace(x1,numFiles);
		tmp = tmp.replace(x2,numDirs);
		tmp += "\n"+febeMsg[100];
	
		var OK = febeConfirm(tmp);
		if(!OK){
			febeAlert(febeMsg[351]);
			febeBackupAborted = true;
			return false;
		}//if
	}//if
	
	var entries = febeBuDesDir.directoryEntries;
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		if(entry.isFile()){entry.remove(false);}
	}//while
	return true;
}//febeClearDir()

function febeDosHappy(aString){
	// Mask out DOS incompatable characters
	if(febePlatform != 1){return aString;}
	var badList = "\\/:*\"<>|";
	for (var i = 0; i < aString.length; i++){	
		var c = aString.charAt(i);
		var OK = Boolean(true);
		for (var j = 0; j < badList.length; j++){
			var tChar = badList.charAt(j);
			if(c == tChar){
				OK = false;
				break;
			}//if
		}//for
		if(OK == false){aString = aString.replace(c,"_");}
	}//for
	return aString;
}//febeDosHappy

function febeSetStatusbarMsg(){
  // This doesn't work - statusbar never updates
	return true;
	var d = document.getElementById("febestatusbarprogress");
	var msg = febeMsg[243].replace("%ITEM%",febeLocalizedStr["current"]);
	d.setAttribute("label",msg);
	return true;
}//febeSetStatusbarMsg()

function febeSetStatusbarVisibility2(){
	febeHideIcons = febePrefs.getBoolPref("extensions.febe.hideIcons");
	var d = window.document.getElementById("febestatusbar");
	if(!Boolean(d)){return false;}
	if(febeIsScheduleController){
		setTimeout(function(){d.hidden = d.collapsed = febeHideIcons;},1000);
	}else{
		setTimeout(function(){d.hidden = d.collapsed = true;},1000);
	}//if
	return true;
}//febeSetStatusbarVisibility2()

// ------------------ Backup Functions --------------------

function febeBackupExtensions(){
	if(febeBuExtensions == false && febeBuThemes == false)return true;
	if(febeDispProgress) var pMsgField = febeProgressWin.document.getElementById("febeProgressText");
	febeAddons = Application.storage.get("febeAddons","");
	for(var i in febeAddons){
		var item = febeAddons[i];
		if(item.type != "extension" && item.type != "theme") continue;
		if(item.isPersona == true) continue;			
		if(item.type == "theme" && febeBuThemes == false) continue;
		if(item.type == "extension" && febeBuExtensions == false) continue;
		if(item.isValid == false) continue;
		if(febeIgnoreDisabled == true){
			if(item.userDisabled == true){
				febeDisabledCount++;
				continue;
			}//if
		}//if	
		if(item.ignore == true || item.isGlobal == true){ 
			item.skipped = true;
//alert(item.guid+" skipped");
			//var tmp = febeMsg[18].replace("%ITEM%",item.name);
			//febeErrorList.push(tmp);
			febeSkippedCount++;
			continue;
		}else{
			item.skipped = false;
		}//if
		
		if(item.guid == FEBE_GUID){febeFEBEbackedUp = true;}
		
		// OK, let's back it up ...
		febeErr = null;
		//febeUpdateProgressWindow(item.buname);
		if(febeDispProgress) pMsgField.setAttribute("value",item.buname);
		//febeProgressWin.focus();

//alert(window.document.title)
		if(item.isXpi == true){	// Perform a straight copy for xpis
			febeCopyFile(item.installlocation,febeExBuDir,item.buname);
		}else{
			febeZip(item.installlocation,febeExBuDir,item.buname,false,false,febeRunAsync);	
			if(febeErr == "abort") return false;
			if(febeErr == "skip"){
				item.skipped = true;
				item.iconURL = "chrome://febe/skin/nobu.png";
				var tmp = febeMsg[18].replace("%ITEM%",item.name);
				febeErrorList.push(tmp);
				febeSkippedCount++;
			}//if
		}//if
		if(item.type == "theme"){
			febeThemesList[item.buname] = item;
			if(!febeErr){
				febeThemesList["**total**"]++;
				febeThBackedUp = true;
			}else{
				febeThBackedUp = false;
			}//if
		}else{
			febeExtensionsList[item.buname] = item;
			if(!febeErr){
				febeExtensionsList["**total**"]++;	
				febeExBackedUp = true;
			}else{
				febeExBackedUp = false;
			}//if
		}//if	
	}//for
	return true;
}//function febeBackupExtensions

function febeBackupPersonas(){
	if(febeBuThemes == false){return true;}
	var prefName = "lightweightThemes.usedThemes";
	if(!febePrefs.prefHasUserValue(prefName)) return true;
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var personas = [];
	var personasInstalled = JSON.parse(febeGetUnicharPref(prefName));
	for(var i in personasInstalled){
		var pId = personasInstalled[i].id + "@personas.mozilla.org";
		personas[pId] = personasInstalled[i];
	}//for
	
	for(var i in febeAddons){
		var item = febeAddons[i];
		if(item.isValid == false) continue;
		if(item.ignore == true) continue;
		if(item.isPersona == false) continue;
		if(febeIgnoreDisabled == true){	// Is addon disabled?
			if(item.userDisabled == true){
				febeDisabledCount++;
				continue;
			}//if
		}//if	

		// Backup persona to .json file
		var dFile, fos, cos;
		
		dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
		dFile.initWithPath(febeBuDesDir);
		dFile.append(item.buname);

		fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
		fos.init(dFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
		
		cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
		cos.init(fos, "UTF-8", 0, 0x0000);
		
		var jstr = JSON.stringify(personas[item.guid]);
		cos.writeString("["+jstr+"]\n"); 
		cos.close();
		fos.close();
		
		febeThemesList[item.buname] = item;
		febeThemesList["**total**"]++;
		febeThBackedUp = true;		
		
	}//for
	
	// Backup lightweight theme preference to .json file (i.e., All personas)
	var dFile, fos, cos;
	var item = new Object();
	item.guid = "";
	item.type = "theme";
	item.name = "LightweightThemes";
	item.version = "";
	item.buname = "AllInstalledLightweightThemes.personas.json";
	item.desc = febeMsg[338];
	item.homepageURL = "https://addons.mozilla.org/en-US/firefox/personas/";
	item.userDisabled = false;
	item.isCompatible = true;
	item.iconURL = "chrome://febe/skin/xpinstallItemGeneric.png";
	item.installlocation = "";
	item.ignore = true;
	item.isValid = false;
	item.isPersona = true;
	
	dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
	dFile.initWithPath(febeBuDesDir);
	dFile.append(item.buname);

	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(dFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	//var jstr = "["+JSON.stringify(personasInstalled)+"]";
	var jstr = JSON.stringify(personasInstalled);
	cos.writeString(jstr); 

	cos.close();
	fos.close();
	
	febeThemesList[item.buname] = item;
	febeThemesList["**total**"]++;
	febeThBackedUp = true;		

	return true;
}//function febeBackupPersonas()

function febeBackupBookmarksJSON(){
	febeBmBackedUpJSON = false;
	if (!febeBuBookmarksJSON){return true;}
	
//	Get profile name
	var tmp = febeProfDir.leafName;
	var p = tmp.indexOf(".")
	febeProfName  = tmp.substr(p+1);
	febeBmBuNameJSON ="bookmarks{" + febeProfName  + "}.json";
	
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	febeExBuDir = febeGetUnicharPref("extensions.febe.curBUdir");
	dFile.initWithPath(febeExBuDir);
	dFile.append(febeBmBuNameJSON);
	PlacesUtils.backupBookmarksToFile(dFile);
	febeBmBackedUpJSON = febeVerify(febeBmBuNameJSON);
	return true;
}//febeBackupBookmarks()

function febeBackupBookmarksHTML(){
	febeBmBackedUpHTML = false;
	if (!febeBuBookmarksHTML){return true;}
	febeBmBuNameHTML ="bookmarks{" + febeProfName  + "}.html";
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febeExBuDir);
	dFile.append(febeBmBuNameHTML);
	var exporter = Cc["@mozilla.org/browser/places/import-export-service;1"]
	.getService(Ci.nsIPlacesImportExportService);
	exporter.exportHTMLToFile(dFile);
	febeBmBackedUpHTML = febeVerify(febeBmBuNameHTML);
	return true;
}//febeBackupBookmarksHTML()

function febeBackupPreferences(){
	febePrBackedUp = false;
	if (!febeBuPreferences){return true;}
	var profileDir = febeProfDir.clone();
	profileDir.append("prefs.js");
	var srcFile = profileDir.path
	febePrBuName ="prefs{" + febeProfName  + "}.js";
	if (febeCopyFile(srcFile,febeExBuDir,febePrBuName)){febePrBackedUp = febeVerify(febePrBuName);}
	return true;
}//febeBackupPreferences()

function febeBackupCookies(){
	febeCkBackedUp = false;
	if (!febeBuCookies){return true;}
	febeCkBuName ="cookies{" + febeProfName  + "}.json";
	var dFile, fos, cos;
	var cookieManager = Cc["@mozilla.org/cookiemanager;1"].getService(Ci.nsICookieManager);
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	
	dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
	dFile.initWithPath(febeBuDesDir);
	dFile.append(febeCkBuName);
	
	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(dFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	var cnt = 0;	
	var iter = cookieManager.enumerator;
	while (iter.hasMoreElements()){
		var cookie = iter.getNext();
		if (cookie instanceof Ci.nsICookie){
			var cookieObj = new febeCookieObj(
				cookie.expires,
				cookie.host,
				cookie.isDomain,
				cookie.isSecure,
				cookie.name,
				cookie.path,
				cookie.policy,
				cookie.status,
				cookie.value);
				
			cookieObj.expires = cookie.expires * 1000;  // Convert seconds to milliseconds
			var jstr = JSON.stringify(cookieObj);
			cos.writeString(jstr+"\n"); 
			cnt++;
		}//if
	}//while
	cos.close();
	fos.close();
	febeCkBackedUp = febeVerify(febeCkBuName);
	return true;
}//febeBackupCookies()

function febeBackupUserChrome(){
	febeChBackedUp = false;
	if (!febeBuUserChrome){return true;}
	var profileDir = febeProfDir.clone();
    profileDir.append("chrome");
    if (!profileDir.exists()){return true;}
    var srcDir = profileDir.path;
    febeChBuName ="userChrome{" + febeProfName  + "}.fbu";
	febeZip(srcDir,febeExBuDir,febeChBuName,false,false,febeRunAsync);	
	febeChBackedUp = febeVerify(febeChBuName);
	return true;
}//febeBackupUserChrome()

function febeBackupPasswords(){
	febePwBackedUp = false;
	if (!febeBuUserPwd){return true;}
    febePwBuName = "usernames-passwords{" + febeDosHappy(febeProfName)  + "}.json";
	
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField
	var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);
	var dFile, fos, cos;
	
	dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
	dFile.initWithPath(febeBuDesDir);
	dFile.append(febePwBuName)
	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(dFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	var logins = loginManager.getAllLogins({});
	for (var i = 0; i < logins.length; i++) {
		var login = {};
	  login.hostname = logins[i].hostname;
		login.formSubmitURL = logins[i].formSubmitURL;
		login.httpRealm = logins[i].httpRealm;
		login.username = logins[i].username;
	  login.usernameField = logins[i].usernameField;
		login.password = febeObfuscate(true,logins[i].password); 
		login.passwordField = logins[i].passwordField;
	  var jstr = JSON.stringify(login);
		cos.writeString(jstr+"\n"); 
	}//for
	
	cos.close();
	fos.close();
    febePwBackedUp = febeVerify(febePwBuName);
	return true;
}//febeBackupPasswords()

function febeBackupSearchPlugins(){
	febeSpBackedUp = false;
	if (!febeBuSearchPlugins){return true;}
	
  // See if search plugins exist
	var profileDir = febeProfDir.clone();
    profileDir.append("searchplugins");
    if (!(profileDir.exists() && profileDir.isDirectory())){return true;}
    febeSpBuName = "searchPlugins{" + febeDosHappy(febeProfName)  + "}.fbu";
	var srcName = febeProfDir.clone();
    srcName.append("searchplugins");
    srcName = srcName.path;
    febeZip(srcName,febeExBuDir,febeSpBuName,false,false,febeRunAsync);	
	febeSpBackedUp = febeVerify(febeSpBuName);
	return true;
}//febeBackupSearchPlugins()

function febeBackupBrowserHistory(){
	febeHsBackedUp = false;
	if (!febeBuBrowserHistory){return true;}
	febeHsBuName ="history{" + febeProfName  + "}.json";
	var dFile, fos, cos, cnt;
	var historyService = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService);
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
					
	dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	febeBuDesDir = febeGetUnicharPref("extensions.febe.curBUdir");
	dFile.initWithPath(febeBuDesDir);
	dFile.append(febeHsBuName);
	
	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(dFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	// Get all history entries
	var options = historyService.getNewQueryOptions();
	var query = historyService.getNewQuery();
	var result = historyService.executeQuery(query, options); 

	var rr = result.root;
	rr.containerOpen = true;
	cnt = 0;

	for (var i = 0; i < rr.childCount; ++i) {
		var childNode = rr.getChild(i);
		var type = childNode.type;
		if(type != rr.RESULT_TYPE_URI) continue;
		var obj = {aURI : childNode.uri, aTitle : childNode.title, aLastVisited : childNode.time};
		var jstr = JSON.stringify(obj);
		cos.writeString(jstr+"\n"); 
		cnt++;
	}//for
	
	cos.close();
	fos.close();
	febeHsBackedUp = febeVerify(febeHsBuName);
	return true;
}//febeBackupBrowserHistory()

function febeBackupFormFillHistory(){
	febeFfBackedUp = false;
	if (!febeBuFormFillHistory){return true;}
	febeFfBuName ="ffhistory{" + febeProfName  + "}.json";
	var dFile, fos, cos, outFile, dbFile, cnt;
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	
	outFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	outFile.initWithPath(febeGetUnicharPref("extensions.febe.curBUdir"));
	outFile.append(febeFfBuName);
	
	dbFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dbFile.initWithPath(febeGetUnicharPref("extensions.febe.curProfDir"));
	dbFile.append("formhistory.sqlite");

	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var db = storageService.openDatabase(dbFile);

	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(outFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);

	cnt = 0;        
	var sQuery = "SELECT * FROM moz_formhistory";
	var stmt = db.createStatement(sQuery);
	while (stmt.executeStep()) {
		var obj = {id : stmt.getString(0), fieldname : stmt.getString(1), value : stmt.getString(2)};
		var jstr = JSON.stringify(obj);
		cos.writeString(jstr+"\n"); 
		cnt++;
	}//while
	cos.close();
	fos.close();
	febeFfBackedUp = febeVerify(febeFfBuName);
	return true;
}//febeBackupFormFillHistory()

function febeBackupPermissions(){
	febePmBackedUp = false;
	if (!febeBuPermissions){return true;}
	febePmBuName ="permissions{" + febeProfName  + "}.json";
	var dFile, fos, cos, outFile, dbFile, cnt;
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	
	outFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	outFile.initWithPath(febeGetUnicharPref("extensions.febe.curBUdir"));
	outFile.append(febePmBuName);
	
	dbFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dbFile.initWithPath(febeGetUnicharPref("extensions.febe.curProfDir"));
	dbFile.append("permissions.sqlite");

	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var db = storageService.openDatabase(dbFile);

	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(outFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);

	cnt = 0;        
	var sQuery = "SELECT * FROM moz_hosts";
	var stmt = db.createStatement(sQuery);
	while (stmt.executeStep()) {
		var obj = {id : stmt.getString(0), host : stmt.getString(1), type : stmt.getString(2), permission : stmt.getString(3)};
		var jstr = JSON.stringify(obj);
		cos.writeString(jstr+"\n"); 
		cnt++;
	}//while
	cos.close();
	fos.close();
	febePmBackedUp = febeVerify(febePmBuName);
	return true;
}//febeBackupPermissions()

function febeBackupUDBu(){
	if (!febeBuUDBu){return true;}
	febeUdBackedUp = 0;
	febeUDBuDone = [];
	if(!febeUDBuInit()){return false;}	// UDBU is empty
	for(var i in febeUDBuList){
		var Label = new String(febeUDBuList[i].Label);
		if(Label.length == 0){continue;}	// Datafile is empty?
		var Type = new Number(febeUDBuList[i].Type);
		var Description = new String(febeUDBuList[i].Description);
		var Path = new String(febeUDBuList[i].Path);
		var Include = Boolean(false);
		Include = febeUDBuList[i].Include;
		var item = new febeUDBuDoneObj;
		item.Description = Description;
		item.Type = Type;	// Not really needed ... just for completeness	
		if(Include == "false"){continue;}
		if(Type == 1){	// Folder
			febeUdBuName = Label+"{" + febeDosHappy(febeProfName)  + "}.fbu";
			var srcName = Path;
			item.Name = febeUdBuName;
			febeZip(srcName,febeExBuDir,febeUdBuName,true,false,febeRunAsync);	
			
			if(febeVerify(febeUdBuName)){		
				febeUdBackedUp++;
			}else{
				item.Description = "*** Error backing up "+Description;
			}//if

			febeUDBuDone[Label] = item;
			
		}else{		// File
			var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
			file.initWithPath(Path);
			var UDBuName = Label+"{"+febeProfName+"}-"+file.leafName;
			item.Name = UDBuName;
			
			if(file.exists()){
				febeCopyFile(Path,febeExBuDir,UDBuName);	
			}else{
				var style = "<style>color: red;font-size: 12pt;</style>";
				var tmp = style+febeMsg[166].replace("%path%",Path)+"\n"
				febeAlert(tmp);
			}//if
			
			if(febeVerify(UDBuName)){		
				febeUdBackedUp++;
			}else{
				item.Description = febeMsg[167].replace("%description%",Description);
			}//if
			febeUDBuDone[Label] = item;
		}//if
	}//for	
	return true;
}//febeBackupUDbu()

function febeBackupProfile(){
	febeUpBackedUp = false;
//	Get profile name
	var tmp = febeProfDir.leafName;
	var p = tmp.indexOf(".")
	febeProfName  = tmp.substr(p+1);

  febeUpBuName = "profileFx4{" + febeProfName  + "}.fbu"; 
	var srcName = febeProfDir.clone();
  srcName = srcName.path;
	febeExBuDir = febeGetUnicharPref("extensions.febe.curBUdir"); 
//alert(srcName+"\n"+febeExBuDir+"\n"+febeUpBuName)
  febeZip(srcName,febeExBuDir,febeUpBuName,false,false,febeRunAsync);	
	febeUpBackedUp = febeVerify(febeUpBuName);
	//febeUpBackedUp = true;
	return true;
}//febeBackupProfile()

// ------------------ End of Backup Functions -------------

// ------------------ Restore Functions -------------------

function febeRestoreOnlineBackup(which){
	if(!febeInitDir()){return false;}	
	Application.storage.set("type", which);
	window.openDialog("chrome://febe/content/BoxRestore.xul", "FEBE Online Restore", "chrome,modal=yes,dialog=yes,centerscreen,resizable",febeMsg,window);	
	var abort = Application.storage.get("abort", false);
	if(abort){return false;}
	return true;
}//febeRestoreOnlineBackup()

function febeRestoreExtensions(){
	if(!febeInitDir()){return false;}
	
	// Get set up
	var installCnt = 0;
	var listener = {
		onDownloadFailed: DownloadFailed,
		onDownloadCancelled: DownloadCancelled,
		onInstallFailed: InstallFailed,
		onInstallCancelled: InstallCancelled,
		onInstallEnded: installFinished,
	};

	function DownloadFailed(aInstall) {
		alert("onDownloadFailed: "+aInstall.name);
		aInstall.removeListener(listener);
		return true;
	}
	function DownloadCancelled(aInstall) {
		alert("onDownloadCancelled: "+aInstall.name);
		aInstall.removeListener(listener);
		return true;
	}
	
	function InstallFailed(aInstall) {
		alert("onInstallFailed: "+aInstall.name);
		aInstall.removeListener(listener);
		return true;
	}
	
	function InstallCancelled(aInstall) {
		alert("onInstallCancelled: "+aInstall.name);
		aInstall.removeListener(listener);
		return true;
	}

	function installError(aInstall) {
		alert("Install error: "+aInstall.name);
		aInstall.removeListener(listener);
		return true;
	}
	
	function installFinished(aInstall) {
		aInstall.removeListener(listener);
		installCnt++;
		return true;
	}
	
	function IgnoreError(aInstall) {
		aInstall.removeListener(listener);
		return true;
	}

	// Get a list of items to restore
	febePickFiles("*.xpi",25);
	febeGetPlatform();
	if(febePlatform == 3){return true;}	// Mac can't handle modal alerts properly, so just assume they clicked "OK"

	// Create an aInstall object for each item to restore
	var installItems = [];
	febeETinstall.forEach(function(aFile,index) {
		AddonManager.getInstallForFile(aFile.nsFile, function(aInstall) {
			aInstall.fname = aFile.Name;
			aInstall.addListener(listener);
			installItems.push(aInstall);
			if(febeETinstall.length == installItems.length){
				// Got the list, now parse each item and build the prompt
				var restore = new Array();
				var restoreCnt = 0;
				var restoreObj = new Object();
				installItems.forEach(function(item){
					if(!!item.linkedInstalls){// Item is a multipack
						restoreObj.type = "Multipack";
						restoreObj.name = item.fname;
						restoreObj.cnt = item.linkedInstalls.length;
						restore.push(JSON.stringify(restoreObj));
						
						// Parse the multipack
						for(var i=0;i<item.linkedInstalls.length;i++){
							if(!!item.linkedInstalls[i].linkedInstalls){// Multipack contains other multipacks
								alert("Multipack contains other multipacks")
							}else{
								if(item.linkedInstalls[i].type == "extension"){
									restoreObj.type = "MultipackExtension";
								}else{
									restoreObj.type = "MultipackTheme";
								}//if
							}//if
							restoreObj.name = item.linkedInstalls[i].name;
							restoreObj.cnt = 0;
							restore.push(JSON.stringify(restoreObj));
						};//for
					}else{
						// Item is not a multipack
						if(item.type == "extension"){
							restoreObj.type = "Extension";
						}else{
							restoreObj.type = "Theme";
						}//if
						restoreObj.name = item.name;
						restoreObj.cnt = 0;
						restore.push(JSON.stringify(restoreObj));
					};//if - Item parsed
				});
				
				// Display the list in an alert box
				var febeWin  = window.openDialog("chrome://febe/content/febeRestoreExtensionMessageBox.xul", 
					"FEBE Confirm", 
					"chrome,modal=yes,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",
					restore);	
				febeWin.focus();
				var OK = febePrefs.getBoolPref("extensions.febe.confirm");
			
				if(OK){	// Restore the items

					installItems.forEach(function(item){
						item.removeListener(listener);
					});//forEach
			
					// Display the normal install confirmation for the installs
					febeOpenLink("about:addons");
					AddonManager.installAddonsFromWebpage("application/x-xpinstall",this, null, installItems);
				}else{
					return false;
				}//if
			};//if(febeETinstall.length == installItems.length)
		});//AddonManager.getInstallForFile(aFile.nsFile, function(item)
	});//installItems.forEach
	return true;
}//febeRestoreExtensions()

function febeBuildExtensionRestoreWin(){
	var restoreList = window.arguments[0];
	var msgBox = document.getElementById("febeMsgBox");
	document.getElementById("header").value = febeMsg[341]+"\n\n";
	var oLabel = document.createElement("label");
	var oHbox = document.createElement("hbox");
	var oMenulist = document.createElement("menulist");
	var oMenupopup = document.createElement("menupopup");
	var oMenuitem = document.createElement("menuitem");

	for(var i=0;i<restoreList.length;i++){	
		var item = JSON.parse(restoreList[i]);
		switch(item.type){
			case "Multipack":
				var hbox = oHbox.cloneNode(false);
				hbox.setAttribute("class","multipack");		
				var label = oLabel.cloneNode(false);
				label.value = item.name;
				hbox.appendChild(label);
				var menulist = oMenulist.cloneNode(false);
				menulist.setAttribute("onselect","this.selectedIndex = 0");
				hbox.appendChild(menulist);
				var menupopup = oMenupopup.cloneNode(false);
				menupopup.setAttribute("class","multipacklistitem");
				for(var j = -1;j<item.cnt;j++){	
					var mitem = JSON.parse(restoreList[i+j+1]);
					var menuitem = oMenuitem.cloneNode(false);	
					if(j == -1){
						menuitem.label = "Cleopack";
						menuitem.setAttribute("class","multipacklistitem");
					}else{
						if(mitem.type == "MultipackExtension"){
							menuitem.setAttribute("class","multipackextensionitem");
						}else{
							menuitem.setAttribute("class","multipackthemeitem");
						}//if
						menuitem.label = mitem.name;
					}//if
		
					menupopup.appendChild(menuitem);
				}//for
				menulist.appendChild(menupopup);
				hbox.appendChild(menulist);
				i += j;
				msgBox.appendChild(hbox);
				break;;
			case "Extension":
				var label = oLabel.cloneNode(false);
				label.value = item.name;
				label.setAttribute("class","extensionitem");
				msgBox.appendChild(label);
				break;;
			case "Theme":
				var label = oLabel.cloneNode(false);
				label.value = item.name;
				label.setAttribute("class","themeitem");
				msgBox.appendChild(label);
				break;;
			case "Multipackpack":
				var label = oLabel.cloneNode(false);
				label.value = item.name;
				label.setAttribute("class","multipack");
				msgBox.appendChild(label);
				break;;

		}//switch
	}//for
	febePlaySound('message');
}//febeBuildExtensionRestoreWin()

function febeRestoreExtensionsOnline(febeMainWindow){
	febePathName = Application.storage.get("location", "");
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febePathName);

	AddonManager.getInstallForFile(dFile, function(aInstall) {
		var listener = {
			onDownloadFailed: ExtInstallCompleted,
			onDownloadCancelled: ExtInstallCompleted,
			onInstallFailed: ExtInstallCompleted,
			onInstallCancelled: ExtInstallCompleted,
			onInstallEnded: ExtInstallCompleted
		};
		aInstall.addListener(listener);
		aInstall.install(dFile);
		var extName = febeMainWindow.Application.storage.get("boxname", "");
		var tmp = "<style>color: purple; font-weight: normal; font-size: 12px;</style>";
		tmp += febeMainWindow.febeMsg[345].replace("%EXT%",extName);
		tmp += "\n<style>color: red; font-weight: normal; font-size: 14px;</style>"+febeMainWindow.febeMsg[342];
		var ok = febeMainWindow.febeConfirm(tmp);
		if(ok == true){
			febeMainWindow.febeRestartFx();
		}//if
	}, febeMainWindow);
	function ExtInstallCompleted(aInstall) {
		aInstall.removeListener(listener);
		if (getAddonTestType(aInstall.addon.name) == "userdisabled") {
			aInstall.addon.userDisabled = true;
		}//if
		return true;
	}//ExtInstallCompleted
	return true;
}//febeRestoreExtensions(Online)

function febeRestoreThemes(){
	if(!febeInitDir()){return false;}
	febePickFiles("*.jar",24);
	
	var restored = new Array();
	for (var i = 0; i < febeETinstall.length; i++){	
	}//for
	var listener = {
		onDownloadFailed: installCompleted,
		onDownloadCancelled: installCompleted,
		onInstallFailed: installCompleted,
		onInstallCancelled: installCompleted,
		onInstallEnded: installCompleted
	};
	function installCompleted(aInstall) {
    aInstall.removeListener(listener);
		restored.push(aInstall.name);
		if(febeETinstall.length == restored.length){
			//var tmp = "<style>color: purple; font-weight: normal; font-size: 10px;</style>";
			var tmp = "<class>purple</class>";
			tmp += febeMsg[341]+"\n\n";
			//tmp += "<style>color: black; font-weight: normal; font-size: 10px;</style>";
			//tmp += restored.join("\n<style>color: green; font-weight: normal; font-size: 12px;</style>");
			tmp += "<class>themeitem</class>";
			tmp += restored.join("\n<class>themeitem</class>");
			//tmp += "\n<style>color: red; font-weight: normal; font-size: 14px;</style>"+febeMsg[342];
			tmp += "\n<class>red</class>"+febeMsg[342];
			var ok = febeConfirm(tmp);
			if(ok == true){
				febeRestartFx();
			}//if
		}//if
		if (getAddonTestType(aInstall.addon.name) == "userdisabled") {
			aInstall.addon.userDisabled = true;
		}//if
	}//installCompleted(aInstall)

	//Cu.import("resource://gre/modules/AddonManager.jsm");
	febeETinstall.forEach(function(aFile) {
		AddonManager.getInstallForFile(aFile.nsFile, function(aInstall) {
			aInstall.addListener(listener);
			aInstall.install(aFile.nsFile);
		});
	});
	return true;
}//febeRestoreThemes()

function febeRestoreThemesOnline(febeMainWindow){
	febePathName = Application.storage.get("location", "");
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febePathName);

	//Cu.import("resource://gre/modules/AddonManager.jsm");
	AddonManager.getInstallForFile(dFile, function(aInstall) {
		var listener = {
			onDownloadFailed: ThemeInstallCompleted,
			onDownloadCancelled: ThemeInstallCompleted,
			onInstallFailed: ThemeInstallCompleted,
			onInstallCancelled: ThemeInstallCompleted,
			onInstallEnded: ThemeInstallCompleted
		};
		aInstall.addListener(listener);
		aInstall.install(dFile);
		var extName = febeMainWindow.Application.storage.get("boxname", "");
		var tmp = "<style>color: purple; font-weight: normal; font-size: 12px;</style>";
		tmp += febeMainWindow.febeMsg[346].replace("%THEME%",extName);
		tmp += "\n<style>color: red; font-weight: normal; font-size: 14px;</style>"+febeMainWindow.febeMsg[342];
		var ok = febeMainWindow.febeConfirm(tmp);
		if(ok == true){
			febeMainWindow.febeRestartFx();
		}//if
	}, febeMainWindow);
	function ThemeInstallCompleted(aInstall) {
		aInstall.removeListener(listener);
		if (getAddonTestType(aInstall.addon.name) == "userdisabled") {
			aInstall.addon.userDisabled = true;
		}//if
		return true;
	}//ThemeInstallCompleted
	return true;
}//febeRestoreThemesOnline()

function febeRestoreIndividualPersonas(){
	if(!febeInitDir()){return false;}
	febePickFiles("*.persona.json",24);
	if(febeETinstall.length == 0){
		febeAlert(febeMsg[46]);
		return true;
	}//if

	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var personasInstalled = [];
	var personas = [];
	var prefName = "lightweightThemes.usedThemes";
	if(febePrefs.prefHasUserValue(prefName)){
		prefData = febeGetUnicharPref(prefName);
		personasInstalled = JSON.parse(prefData);
	}//if
	
	for(var i in personasInstalled){
		try{
			var pId = personasInstalled[i].id + "@personas.mozilla.org";
			personas[pId] = new Object(personasInstalled[i]);
		}catch(e){;;}
		//personas.push(personasInstalled[i]);
	}//for
	
	for(var i=0; i<febeETinstall.length; i++){
		var dFile = febeETinstall[i].nsFile;
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		var personasInstalled = "";
		do {
			hasmore = lis.readLine(line);
			var persona = new Object(JSON.parse(line.value));
			var pId = persona[0].id + "@personas.mozilla.org";
			//personas[pId] = JSON.stringify(persona[0]);
			personas[pId] = persona[0];
		} while(hasmore);
		cis.close();
		fis.close();
	}//for
	var personasInstalled = "[";
	var cnt = 0;
	for(var i in personas){
		if(cnt != 0) personasInstalled += ",";
		personasInstalled += JSON.stringify(personas[i]);
		cnt++;
	}//for
	personasInstalled += "]";
	
	febeSetUnicharPref(prefName,personasInstalled);
	febeAlert(febeMsg[343]);
	return true;
}//febeRestoreIndividualPersonas()

function febeRestoreIndividualPersonasOnline(){
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var personasInstalled = [];
	var personas = [];
	var prefName = "lightweightThemes.usedThemes";
	if(febePrefs.prefHasUserValue(prefName)){
		prefData = febeGetUnicharPref(prefName);
		personasInstalled = JSON.parse(prefData);
	}//if
	
	for(var i in personasInstalled){
		try{
			var pId = personasInstalled[i].id + "@personas.mozilla.org";
			personas[pId] = new Object(personasInstalled[i]);
		}catch(e){;;}
	}//for
	
	febePathName = Application.storage.get("location", "");
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febePathName);
	
	var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
	fis.init(dFile, 0x01, 0444, 0);
	fis.QueryInterface(Ci.nsILineInputStream);

	var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
	cis.init(fis,"UTF-8", 0, 0x0000);
	
	var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

	// read lines into array and parse into individual fields
	var line = {}, hasmore;	
	var personasInstalled = "";
	do {
		hasmore = lis.readLine(line);
		var persona = new Object(JSON.parse(line.value));
		var pId = persona[0].id + "@personas.mozilla.org";
		personas[pId] = persona[0];
	} while(hasmore);
	cis.close();
	fis.close();
		
	var personasInstalled = "[";
	var cnt = 0;
	for(var i in personas){
		if(cnt != 0) personasInstalled += ",";
		personasInstalled += JSON.stringify(personas[i]);
		cnt++;
	}//for
	personasInstalled += "]";
	
	febeSetUnicharPref(prefName,personasInstalled);
	febeAlert(febeMsg[343]);	
	
	return true;
}//febeRestoreIndividualPersonas()

function febeRestoreAllPersonas(){
	if(!febeInitDir()){return false;}
	febePickFiles("*.personas.json",344);
	if(febeETinstall.length == 0){
		febeAlert(febeMsg[46]);
		return true;
	}//if

	for(var i=0; i<febeETinstall.length; i++){
		var dFile = febeETinstall[i].nsFile;
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		do {
			hasmore = lis.readLine(line);
			var personasInstalled = line.value;
		} while(hasmore);
		cis.close();
		fis.close();
	}//for
	var prefName = "lightweightThemes.usedThemes";
	febeSetUnicharPref(prefName,personasInstalled);
	febeAlert(febeMsg[343]);
	return true;
}//febeRestoreAllPersonas()

function febeRestoreAllPersonasOnline(){
	febePathName = Application.storage.get("location", "");
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febePathName);
	var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
	fis.init(dFile, 0x01, 0444, 0);
	fis.QueryInterface(Ci.nsILineInputStream);

	var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
	cis.init(fis,"UTF-8", 0, 0x0000);
	
	var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

	// read lines into array and parse into individual fields
	var line = {}, hasmore;	
	do {
		hasmore = lis.readLine(line);
		var personasInstalled = line.value;
	} while(hasmore);
	cis.close();
	fis.close();
	
	var prefName = "lightweightThemes.usedThemes";
	febeSetUnicharPref(prefName,personasInstalled);
	febeAlert(febeMsg[343]);
	return true;
}//febeRestoreAllPersonasOnline()

function febeRestoreBookmarksJSON(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("bookmarks*.json",33)){return true};
	var check1 = febePrName.indexOf("bookmarks{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[50].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if
	
	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(37,febeBUdate)){
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		PlacesUtils.restoreBookmarksFromJSONFile(dFile);
		febeAlert(febeMsg[42]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreBookmarks()

function febeRestoreBookmarksOnlineJSON(){
	var date = Application.storage.get("created", "");
	var name = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));

	if(febeConfirmRestore(37,febeBUdate)){
		febeSetStatusbarMsg();
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		PlacesUtils.restoreBookmarksFromJSONFile(dFile);
		febeAlert(febeMsg[42]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreBookmarks(Online)

function febeRestoreBookmarksHTML(){
	if(febePathName.length == 0){
		febeAlert(febeMsg[33]);
		return false;
	}//if
	
	var option = document.getElementById("febeBookmarksRestoreOption").value;
	var overwriteflag = ((option == "overwrite") ? true : false);
	if(!febeInitDir()){return false;}
	var check1 = febePrName.indexOf("bookmarks{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.html");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[50].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if
	
	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(37,febeBUdate)){
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		var importer = Cc["@mozilla.org/browser/places/import-export-service;1"]
		.getService(Ci.nsIPlacesImportExportService);
		importer.importHTMLFromFile(dFile, overwriteflag);
		febeAlert(febeMsg[42]);
	}else{
		febeAlert(febeMsg[46]);
	}
	window.close();
	return true;
}//febeRestoreBookmarksHTML()

function febeGetBookmarksRestoreFile(){
	if(!febePickRestoreFile("bookmarks*.html",33)){return false};
	var d = document.getElementById("febeBookmarksRestoreDir");
	d.setAttribute("value",febePathName);
}//febeGetBookmarksRestoreFile()

function febeRestoreBookmarksOnlineHTML(){
	var date = Application.storage.get("created", "");
	var name = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));

	if(febeConfirmRestore(37,febeBUdate)){
		febeSetStatusbarMsg();
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		var importer = Cc["@mozilla.org/browser/places/import-export-service;1"]
		.getService(Ci.nsIPlacesImportExportService);
		importer.importHTMLFromFile(dFile, true);
		febeAlert(febeMsg[42]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreBookmarksOnlineHTML()

function febeRestorePreferences(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("prefs*.js",34)){return true};
	var check1 = febePrName.indexOf("prefs{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.js");
	if(check1 != 0 || check2 != 4){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[69].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(38,febeBUdate)){
		
		// Pointer to preferences
		var oldPrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
		
		// Pointer to new (restored) preferences
		var newPrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
					
		// Pointer to backed up preferences file
		var newPrefFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		
		// Get pointer to "Prefs.js"
		var PrefsFile = febeProfDir.clone();
                   
		PrefsFile.append("prefs.js")
		newPrefFile.initWithPath(febePathName); 	// Initialize backed up prefs file
		oldPrefs.deleteBranch("");					// Delete old preferences
		newPrefs.readUserPrefs(newPrefFile);		// Read in backed up preferences
		newPrefs.savePrefFile(PrefsFile);			// Save the restored preferences file
		
		// Reset febePrefs pointer
		febePrefs = newPrefs.getBranch("");
		alert(febeMsg[43]);
		//febeAlert(febeMsg[43]);
		febeRestartFx();							// Restart Firefox
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestorePreferences()

function febeRestorePreferencesOnline(){
	var date = Application.storage.get("created", "");
	var name = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));
	if(febeConfirmRestore(38,febeBUdate)){
		febeSetStatusbarMsg();
		// Pointer to preferences
		var oldPrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);
		
		// Pointer to new (restored) preferences
		var newPrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
					
		// Pointer to backed up preferences file
		var newPrefFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		
		// Get pointer to "Prefs.js"
		var PrefsFile = febeProfDir.clone();
                   
		PrefsFile.append("prefs.js")
		newPrefFile.initWithPath(febePathName); 	// Initialize backed up prefs file
		oldPrefs.deleteBranch("");					// Delete old preferences
		newPrefs.readUserPrefs(newPrefFile);		// Read in backed up preferences
		newPrefs.savePrefFile(PrefsFile);			// Save the restored preferences file
		febeAlert(febeMsg[43]);
		febeRestartFx();							// Restart Firefox
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestorePreferencesOnline()

function febeGetCookiesRestoreFile(){
	if(!febePickRestoreFile("cookies*.json",35)){return false};
	var d = document.getElementById("febeCookiesRestoreDir");
	d.setAttribute("value",febePathName);
}//febeGetCookiesRestoreFile()

function febeRestoreCookies(){
	if(febePathName.length == 0){
		febeAlert(febeMsg[33]);
		return false;
	}//if
	
	var option = document.getElementById("febeCookiesRestoreOption").value;
	var overwriteflag = ((option == "overwrite") ? true : false);
	if(!febeInitDir()){return false;}
	var check1 = febePrName.indexOf("cookies{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[71].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(39,febeBUdate)){
		// Save value of cookie behavior pref and temporarily set it to accept all cookies
		var prefName = "network.cookie.cookieBehavior";
		var prefVal = febePrefs.getIntPref(prefName);
		febePrefs.setIntPref(prefName, 0);
		
		if(overwriteflag) Cc["@mozilla.org/cookiemanager;1"].getService(Ci.nsICookieManager).removeAll();
		
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);

		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var cookie = JSON.parse(line.value)
			var url = "http" + ((cookie.isSecure)?"s":"") + "://" + cookie.host + (cookie.path || "").replace(/^(?!\/)/, "/");
			var cookieUri = ios.newURI(url, null, null);
			var dt = new Date()
			dt.setTime(cookie.expires)
			var str = cookie.name+"="+cookie.value+";domain="+cookie.host+";expires="+dt.toUTCString();
			cookieSvc.setCookieString(cookieUri, null, str, null);
			//document.cookie = unescape(str);	// Commit the cookie
			cnt++;
		} while(hasmore);
		febeAlert(febeMsg[44]);
		
		// Reset cookie behavior pref
		febePrefs.setIntPref(prefName, prefVal);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	
	return true;
}//febeRestoreCookies()

function febeRestoreCookiesOnline(){
	var date = Application.storage.get("created", "");
	var name = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));

	if(febeConfirmRestore(39,febeBUdate)){
		// Save value of cookie behavior pref and temporarily set it to accept all cookies
		var prefName = "network.cookie.cookieBehavior";
		var prefVal = febePrefs.getIntPref(prefName);
		febePrefs.setIntPref(prefName, 0);

		febeSetStatusbarMsg();
		Cc["@mozilla.org/cookiemanager;1"].getService(Ci.nsICookieManager).removeAll();
		
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);

		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var cookie = JSON.parse(line.value)
			var url = "http" + ((cookie.isSecure)?"s":"") + "://" + cookie.host + (cookie.path || "").replace(/^(?!\/)/, "/");
			var cookieUri = ios.newURI(url, null, null);
			var dt = new Date()
			dt.setTime(cookie.expires)
			var str = cookie.name+"="+cookie.value+";domain="+cookie.host+";expires="+dt.toUTCString();
			cookieSvc.setCookieString(cookieUri, null, str, null);
			//document.cookie = unescape(str);	// Commit the cookie
			cnt++;
		} while(hasmore);
		febeAlert(febeMsg[44]);
		
		// Reset cookie behavior pref
		febePrefs.setIntPref(prefName, prefVal);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	
	return true;
}//febeRestoreCookiesOnline()

function febeRestoreUserChrome(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	var chromeDir = febeProfDir.clone();
	chromeDir.append("chrome");
	if(!febePickRestoreFile("userChrome*.fbu",78)){return true};
	var check1 = febePrName.indexOf("userChrome{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.fbu");
	if(check1 != 0 || check2 != 5){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[83].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(68,febeBUdate)){
		var sourceDir = febePfParent;
		var destDir = chromeDir.path;
		var zipName = febePfName;
		febeUnzip(sourceDir,destDir,zipName);
		febeChmod(destDir);
		febeAlert(febeMsg[79]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreUserChrome()

function febeRestoreUserChromeOnline(){
	var chromeDir = febeProfDir.clone();
	chromeDir.append("chrome");
	var destDir = chromeDir.path;
	var date = Application.storage.get("created", "");
	var zipName = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	var sourceDir = Application.storage.get("parent", "");
	febeBUdate = new Date(parseInt(date));

	if(febeConfirmRestore(68,febeBUdate)){
		febeSetStatusbarMsg();
		febeUnzip(sourceDir,destDir,zipName);
		febeChmod(destDir);
		febeAlert(febeMsg[79]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreUserChromeOnline()

function febeRestorePasswords(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("usernames-passwords*.json",80)){return true};	
	var check1 = febePrName.indexOf("usernames-passwords{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[125].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if
	
	febeBUdate = febeGetBuDate(febePathName);

	if(febeConfirmRestore(70,febeBUdate)){

		// Clear existing paswords
		var hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField, login, dFile;
		var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);
		var logins = loginManager.getAllLogins({}); 
		for (var i = 0; i < logins.length; i++) {
			//login = new nsLoginInfo(hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField);
			login = {};
		  login.hostname = logins[i].hostname;
			login.formSubmitURL = logins[i].formSubmitURL;
			login.httpRealm = logins[i].httpRealm;
			login.username = logins[i].username;
		  login.usernameField = logins[i].usernameField;
			login.password = logins[i].password; 
			login.passwordField = logins[i].passwordField;
			loginManager.removeLogin(login);
		}//for
		
		dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);

		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
		var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Ci.nsILoginInfo,"init");

		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var data = JSON.parse(line.value)
			login = new nsLoginInfo(hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField);
			login.hostname = data.hostname;
			login.formSubmitURL = data.formSubmitURL;
			login.httpRealm = data.httpRealm;
			login.username = data.username;
		    login.usernameField = data.usernameField;
			login.password = febeObfuscate(false,data.password);
			login.passwordField = data.passwordField;
			try{
				loginManager.addLogin(login);
				cnt++;
			}catch(e){
				var err = e;
				var tmp = "<style>color: red; font-weight: bold; font-size: 10px;</style>"+err+"\n";
				tmp += "Host: "+login.hostname+"\n"
				tmp += "Username: "+login.username+"\n\n";
				tmp += "<style>color: black; font-weight: bold; font-size: 12px;</style>"
				tmp += "Login entry skipped";
				febeAlert(tmp);
			}
		} while(hasmore);
		febeAlert(febeMsg[81]);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	return true;
}//febeRestorePasswords()

function febeRestorePasswordsOnline(){
	var date = Application.storage.get("created", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));

	if(febeConfirmRestore(70,febeBUdate)){
		febeSetStatusbarMsg();
		// Clear existing paswords
		var hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField
		var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);
		var logins = loginManager.getAllLogins({}); 
		for (var i = 0; i < logins.length; i++) {
			login = {};
		    login.hostname = logins[i].hostname;
			login.formSubmitURL = logins[i].formSubmitURL;
			login.httpRealm = logins[i].httpRealm;
			login.username = logins[i].username;
		    login.usernameField = logins[i].usernameField;
			login.password = logins[i].password; 
			login.passwordField = logins[i].passwordField;
			loginManager.removeLogin(login);
		}//for
		
		dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);

		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
		var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Ci.nsILoginInfo,"init");

		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var data = JSON.parse(line.value)
			login = new nsLoginInfo(hostname, formSubmitURL, httprealm, username, password, usernameField, passwordField);
			login.hostname = data.hostname;
			login.formSubmitURL = data.formSubmitURL;
			login.httpRealm = data.httpRealm;
			login.username = data.username;
		    login.usernameField = data.usernameField;
			login.password = febeObfuscate(false,data.password);
			login.passwordField = data.passwordField;
			try{
				loginManager.addLogin(login);
				cnt++;
			}catch(e){
				var err = e;
				var tmp = "<style>color: red; font-weight: bold; font-size: 10px;</style>"+err+"\n";
				tmp += "Host: "+login.hostname+"\n"
				tmp += "Username: "+login.username+"\n\n";
				tmp += "<style>color: black; font-weight: bold; font-size: 12px;</style>"
				tmp += "Login entry skipped";
				febeAlert(tmp);
			}
		} while(hasmore);
		febeAlert(febeMsg[81]);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	return true;
}//febeRestorePasswordsOnline()

function febeRestoreSearchPlugins(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("searchPlugins*.fbu",84)){return true};
	var check1 = febePrName.indexOf("searchPlugins{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.fbu");
	if(check1 != 0 || check2 != 5){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[55].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(72,febeBUdate)){
		var profileDir = febeProfDir.clone();
	    profileDir.append("searchplugins");
	    if (!(profileDir.exists() && profileDir.isDirectory())){
			// Create firedctory
			profileDir.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
		}//if
		var zipFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		zipFile.initWithPath(febePathName);
		
		var sourceDir = zipFile.parent.path;
		var destDir = profileDir.path;
		var zipName = zipFile.leafName
		febeUnzip(sourceDir,destDir,zipName);
		febeChmod(destDir);
		febeAlert(febeMsg[85]);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	return true;
}//febeRestoreSearchPlugins()

function febeRestoreSearchPluginsOnline(){
	var date = Application.storage.get("created", "");
	var zipName = Application.storage.get("name", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));
	if(febeConfirmRestore(72,febeBUdate)){
		febeSetStatusbarMsg();
		var profileDir = febeProfDir.clone();
	    profileDir.append("searchplugins");
	    if (!(profileDir.exists() && profileDir.isDirectory())){
			// Create firedctory
			profileDir.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
		}//if
		var zipFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		zipFile.initWithPath(febePathName);
		
		var sourceDir = zipFile.parent.path;
		var destDir = profileDir.path;
		var zipName = zipFile.leafName
		febeUnzip(sourceDir,destDir,zipName);
		febeChmod(destDir);
		febeAlert(febeMsg[85]);
	}else{
		febeAlert(febeMsg[46]);
	}//if
	return true;
}//febeRestoreSearchPlugins(Online)

function febeRestoreBrowserHistory(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("history*.json",86)){return true};
	var check1 = febePrName.indexOf("history{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[63].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(73,febeBUdate)){
		
		// Delete current history
		var bh = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsIBrowserHistory);
		bh.removeAllPages();
        try {
          var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
          os.notifyObservers(null, "browser:purge-session-history", "");
        }
        catch (e) { }
        
        // Clear last URL of the Open Web Location dialog
        var prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch2);
        try {
          prefs.clearUserPref("general.open_location.last_url");
        }
        catch (e) { }

		// Restore browser history
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);

		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var histObj = JSON.parse(line.value);
			// create an nsIURI 
			var uri = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI(histObj.aURI, null, null);

			try{
				bh.addPageWithDetails(uri, histObj.aTitle, histObj.aLastVisited) 
			}catch(e){
				var msg = "\n\naURI: "+histObj.aURI+"\naTitle: "+histObj.aTitle+"\naLastVisited: "+histObj.aLastVisited;
				febeRestoreError(e, msg)
				return false;
			}//try/catch
			cnt++;
		} while(hasmore);
		//febeProgressWin.close();
		febeAlert(febeMsg[106]);
	}else{	
		//febeProgressWin.close();
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	return true;
}//febeRestoreBrowserHistory()

function febeRestoreBrowserHistoryOnline(){
	var date = Application.storage.get("created", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));
	if(febeConfirmRestore(73,febeBUdate)){
		febeSetStatusbarMsg();
		// Delete current history
		var bh = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsIBrowserHistory);
		bh.removeAllPages();
        try {
          var os = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);
          os.notifyObservers(null, "browser:purge-session-history", "");
        }
        catch (e) { }
        
        // Clear last URL of the Open Web Location dialog
        var prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch2);
        try {
          prefs.clearUserPref("general.open_location.last_url");
        }
        catch (e) { }

		// Restore browser history
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var cookieSvc = Cc["@mozilla.org/cookieService;1"].getService(Ci.nsICookieService);

		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			var histObj = JSON.parse(line.value);
			// create an nsIURI 
			var uri = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService).newURI(histObj.aURI, null, null);

			try{
				bh.addPageWithDetails(uri, histObj.aTitle, histObj.aLastVisited) 
			}catch(e){
				var msg = "\n\naURI: "+histObj.aURI+"\naTitle: "+histObj.aTitle+"\naLastVisited: "+histObj.aLastVisited;
				febeFatal(e, msg)
				return false;
			}//try/catch
			cnt++;
		} while(hasmore);
		//febeProgressWin.close();
		febeAlert(febeMsg[106]);
	}else{	
		//febeProgressWin.close();
		febeAlert(febeMsg[46]);
	}//if
	cis.close();
	fis.close();
	return true;
}//febeRestoreBrowserHistoryOnline()

function febeRestoreFormFillHistory(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("ffhistory*.json",88)){return true};
	var check1 = febePrName.indexOf("ffhistory{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[82].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(74,febeBUdate)){
		// Get database file in profile folder
		var dbFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		dbFile.append("formhistory.sqlite"); 

		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		var db = storageService.openDatabase(dbFile);

		var stmt;
		db.beginTransactionAs(db.TRANSACTION_DEFERRED);
		// Delete the existing table
		stmt = db.createStatement("DELETE FROM `moz_formhistory`");
		stmt.execute();

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var inFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		inFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(inFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
	
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		// Read the backup file
		var line = {}, hasmore;	
		var cnt = 0;
		try{
		do {
			hasmore = lis.readLine(line);
			obj = JSON.parse(line.value);
			var sQuery = "INSERT INTO moz_formhistory VALUES ('"+febeEscape(obj.id)+"','"+febeEscape(obj.fieldname)+"','"+febeEscape(obj.value)+"')"
			stmt = db.createStatement(sQuery);
			stmt.execute();
			cnt++;
		} while(hasmore);
		db.commitTransaction();
		febeAlert(febeMsg[89]);
		}catch(e){
			febeFatal(e,febeMsg[306]);
			return false;
		}//try/catch
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreFormFillHistory()

function febeRestoreFormFillHistoryOnline(){
	var date = Application.storage.get("created", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));
	if(febeConfirmRestore(74,febeBUdate)){
		febeSetStatusbarMsg();
		// Get database file in profile folder
		var dbFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		dbFile.append("formhistory.sqlite"); 

		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		var db = storageService.openDatabase(dbFile);

		var stmt;
		db.beginTransactionAs(db.TRANSACTION_DEFERRED);
		// Delete the existing table
		stmt = db.createStatement("DELETE FROM `moz_formhistory`");
		stmt.execute();

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var inFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		inFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(inFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
	
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		// Read the backup file
		var line = {}, hasmore;	
		var cnt = 0;
		do {
			hasmore = lis.readLine(line);
			obj = JSON.parse(line.value);
			var sQuery = "INSERT INTO moz_formhistory VALUES ('"+febeEscape(obj.id)+"','"+febeEscape(obj.fieldname)+"','"+febeEscape(obj.value)+"')"
			stmt = db.createStatement(sQuery);
			stmt.execute();
			cnt++;
		} while(hasmore);
		db.commitTransaction();

		febeAlert(febeMsg[89]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestoreFormFillHistoryOnline()

function febeRestorePermissions(){
	if(!febeInitDir()){return false;}
	febePathName = ""
	if(!febePickRestoreFile("permissions*.json",117)){return true};
	var check1 = febePrName.indexOf("permissions{");
	var check2 = febePrName.length - febePrName.lastIndexOf("}.json");
	if(check1 != 0 || check2 != 6){
		var tmp = "<style>color: purple; font-weight: bold; font-size: 12px;</style>"+febeMsg[96].replace("%FILE%","'"+febePrName+"'")+"\n";
		tmp += "<style>color: red; font-weight: bold; font-size: 14px;</style>"+febeMsg[46];
		febeAlert(tmp);
		return false;
	}//if

	febeBUdate = febeGetBuDate(febePathName);
	if(febeConfirmRestore(118,febeBUdate)){
		// Get database file in profile folder
		var dbFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		dbFile.append("permissions.sqlite"); 

		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		var db = storageService.openDatabase(dbFile);

		var stmt;
		// Delete the existing table
		stmt = db.createStatement("DROP TABLE `moz_hosts`");
		stmt.execute();
		// Create a new table
		stmt = db.createStatement("CREATE TABLE moz_hosts ( id INTEGER PRIMARY KEY,host TEXT,type TEXT,permission INTEGER)");
		stmt.execute();
		// Clean it up
		stmt = db.createStatement("VACUUM");
		stmt.execute(); 

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var inFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		inFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(inFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
	
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		// Read the backup file
		var line = {}, hasmore;	
		var cnt = 0;
		db.beginTransactionAs(db.TRANSACTION_DEFERRED);
		do {
			hasmore = lis.readLine(line);
			obj = JSON.parse(line.value)
			stmt = db.createStatement("INSERT INTO moz_hosts VALUES ('"+obj.id+"','"+obj.host+"','"+obj.type+"','"+obj.permission+"')");
			stmt.execute();
			cnt++;
		} while(hasmore);
		db.commitTransaction();

		febeAlert(febeMsg[119]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestorePermissions()

function febeRestorePermissionsOnline(){
	var date = Application.storage.get("created", "");
	febePathName = Application.storage.get("location", "");
	febeBUdate = new Date(parseInt(date));
	if(febeConfirmRestore(118,febeBUdate)){
		febeSetStatusbarMsg();
		// Get database file in profile folder
		var dbFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		dbFile.append("permissions.sqlite"); 

		var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
		var db = storageService.openDatabase(dbFile);

		var stmt;
		// Delete the existing table
		stmt = db.createStatement("DROP TABLE `moz_hosts`");
		stmt.execute();
		// Create a new table
		stmt = db.createStatement("CREATE TABLE moz_hosts ( id INTEGER PRIMARY KEY,host TEXT,type TEXT,permission INTEGER)");
		stmt.execute();
		// Clean it up
		stmt = db.createStatement("VACUUM");
		stmt.execute(); 

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
		var inFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		inFile.initWithPath(febePathName);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(inFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);
	
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		// Read the backup file
		var line = {}, hasmore;	
		var cnt = 0;
		db.beginTransactionAs(db.TRANSACTION_DEFERRED);
		do {
			hasmore = lis.readLine(line);
			obj = JSON.parse(line.value)
			stmt = db.createStatement("INSERT INTO moz_hosts VALUES ('"+obj.id+"','"+obj.host+"','"+obj.type+"','"+obj.permission+"')");
			stmt.execute();
			cnt++;
		} while(hasmore);
		db.commitTransaction();

		febeAlert(febeMsg[119]);
	}else{
		febeAlert(febeMsg[46]);
	}
	return true;
}//febeRestorePermissionsOnline()

function febeRestoreUDBU(index){
	var udbuLabel = febeUDBuList[index].Label;
	var udbuDescription = febeUDBuList[index].Description;
	var udbuType = parseInt(febeUDBuList[index].Type);
	var udbuPath = febeUDBuList[index].Path; 
	febePathName = ""
	if(!febeInitDir()){return false;}
	var fMask = udbuLabel.replace(/ /g,"?")+"*";
	if(udbuType == 1){fMask = udbuLabel.replace(/ /g,"?")+"*.fbu";}
	if(!febePickRestoreFile(fMask,161)){return false;};
	febeBUdate = febeGetBuDate(febePathName);
	febeSetMsgs();
	febeMsg[163] = febeMsg[163].replace(/%fname%/,udbuDescription);
	febeMsg[164] = febeMsg[164].replace(/%fname%/,udbuDescription);
	if(udbuType == 0){
	  // File restore is a straight copy
		if(febeConfirmRestore(163,febeBUdate)){
			febeCopyFile(febePathName,febeParent(udbuPath),febeLeafname(udbuPath));
			febeAlert(febeMsg[164]);
		}else{
			febeAlert(febeMsg[46]);
		}//if
	}else{
	  // Restore backed up folder
		if(febeConfirmRestore(163,febeBUdate)){
			var zipFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
			zipFile.initWithPath(udbuPath);
		
			var sourceDir = febePfParent;
			febeGetPrefs();
			var destDir = "";
			if(febePlatform == 1){destDir = udbuPath.substr(0,3)};	// e.g., "C:\\"
			if(febePlatform == 2){destDir = "/";}
			if(febePlatform == 3){destDir = "/";}

			var zipName = febePrName;
			var OK = Boolean(true);
			OK = febeUnzip(sourceDir,destDir,zipName);
			//febeProgressWin.close();
			if(OK){
				febeChmod(destDir);
				febeAlert(febeMsg[164].replace("%fname%",udbuLabel));
			}else{
				febeAlert(febeMsg[46]);
			}//if
		}//if
	}//if
	return true;
}//febeRestoreUDBU()

function febeRestoreUDBUOnline(){
	febeSetStatusbarMsg();
	febeUDBuInit();
	var date = Application.storage.get("created", "");
	var name = Application.storage.get("boxname", "");
	febePathName = Application.storage.get("location", "");
	var zipName = Application.storage.get("name", "");
	var sourceDir = Application.storage.get("parent", "");
	febeBUdate = new Date(parseInt(date));
	var pName = "{"+febeProfName+"}";
	var p = name.indexOf(pName);
	var index = name.substr(0,p);
	var udbuLabel = febeUDBuList[index].Label;
	var udbuDescription = febeUDBuList[index].Description;
	var udbuType = parseInt(febeUDBuList[index].Type);
	var udbuPath = febeUDBuList[index].Path; 
	febeSetMsgs();
	febeMsg[163] = febeMsg[163].replace(/%fname%/,udbuDescription);
	febeMsg[164] = febeMsg[164].replace(/%fname%/,udbuDescription);
	if(udbuType == 0){
	  // File restore is a straight copy
		if(febeConfirmRestore(163,febeBUdate)){
			febeCopyFile(febePathName,febeParent(udbuPath),febeLeafname(udbuPath));
			febeAlert(febeMsg[164]);
		}else{
			febeAlert(febeMsg[46]);
		}//if
	}else{
	  // Restore backed up folder
		if(febeConfirmRestore(163,febeBUdate)){
			var zipFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
			zipFile.initWithPath(udbuPath);		
			febeGetPrefs();
			var destDir = "";
			if(febePlatform == 1){destDir = udbuPath.substr(0,3)};	// e.g., "C:\\"
			if(febePlatform == 2){destDir = "/";}
			if(febePlatform == 3){destDir = "/";}
			var OK = Boolean(true);
			OK = febeUnzip(sourceDir,destDir,zipName);
			if(OK){
				febeChmod(destDir);
				febeAlert(febeMsg[164].replace("%fname%",udbuLabel));
			}else{
				febeAlert(febeMsg[46]);
			}//if
		}//if
	}//if
	return true;
}//febeRestoreUDBUOnline()

function febeDirCopy2(sourceDir,batchFileName){
// Recursively copy individual files and sub-directories to a destination directory
// Very tricky code ... could be written better.  So little time, so much to do
	var tmp = "sourceDir: "+sourceDir;
	tmp += "\nfebeSubRootDir: "+febeSubRootDir;
	tmp += "\nfebeDestDir: "+febeDestDir.path;

	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aFile) return false;

	aFile.initWithPath(sourceDir);
	var entries = aFile.directoryEntries;
	
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var src = entry.path;
		var p = src.indexOf(febeSubRootDir)
		if(p == -1){continue;}
		if(entry.isDirectory()){
			febeDirCopy2(src,batchFileName);
		}else{
			var parentPath = entry.parent.path;
			var dest = febeDestDir.path+"\\"+parentPath.substring(p);
			var re = "\\"+batchFileName+"";
			;
			var file = entry.leafName;
			febeCopyFile(src,dest.replace(re,"\\"),file);
		}//if
	}//while
	return true;
}//febeDirCopy2()

// ------------------ End of Restore Functions ------------
function febeReturnList(){
	return febeBuItemVerifiedList
}

function febeGotNewInstall(aInstall) {
	var name = aInstall.file.leafName;
	(function() {
	if(aInstall.error == 0){febeBuItemVerifiedList[name].verified = true;} 
	}).call(febeBuItemVerifiedList);
}//febeGotNewInstall

function febeVerifyBackup(){
//alert("Verifying")
	febeBuItemVerifiedList = [];
	febeVerifyExtList = [];

	if(febeVerifyBackups == false){return true;}
	febeGetBUList();
	febeVerifyBackup();
	return true;
}//febeVerifyBackup()

function febeGetBUList(){
	var buDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!buDir) return false;

	buDir.initWithPath(febeExBuDir);
	var entries = buDir.directoryEntries;
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var type = febeGetEntryType(entry);
		var name = entry.leafName;
		febeBuItemVerifiedList[name] = new Object;
		febeBuItemVerifiedList[name].verified = false;
		febeBuItemVerifiedList[name].file = entry;
		if(type == "extension"){febeVerifyExtList.push(entry);}
	}//while
	return true;		
}// febeGetBUList()

function febeVerifyBackup(){
	var listener = {onNewInstall: febeGotNewInstall};
	//Cu.import("resource://gre/modules/AddonManager.jsm");
	AddonManager.addInstallListener(listener);
	var xpiCount = febeVerifyExtList.length;
	febeVerifyExtList.forEach(function(aFile) {
		AddonManager.getInstallForFile(aFile, function(aInstall) {
			if (--xpiCount == 0) {
				AddonManager.removeInstallListener(listener);
			}//if
		});
	});
	return true;
}//febeVerifyBackup()

function febeVerifyExtension(ext){
//alert(typeof febeBuItemVerifiedList)  works here
	var listener = {onNewInstall: febeGotNewInstall};
	//Cu.import("resource://gre/modules/AddonManager.jsm");
	AddonManager.addInstallListener(listener);
	AddonManager.getInstallForFile(aFile, function(aInstall) {
			AddonManager.removeInstallListener(listener);
	});
}//febeVerifyExtension()

function febeDoVerify(list){
	var xpiCount = list.length;
	//Cu.import("resource://gre/modules/AddonManager.jsm");
	list.forEach(function(aFile) {
		AddonManager.getInstallForFile(aFile, function(aInstall) {
			//var e = aInstall.error;
//alert(e)
			//yield e;
			if (--xpiCount == 0) {
				AddonManager.removeInstallListener(listener);
			}//if
		});
	});
}

function xfebeVerifyBackup(){
	febeBuItemVerifiedList = [];
	febeVerifyExtList = [];
	if(febeVerifyBackups == false){return true;}

	var buDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!buDir) return false;

	buDir.initWithPath(febeExBuDir);
	var entries = buDir.directoryEntries;

	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var type = febeGetEntryType(entry);
		var name = entry.leafName;
		febeBuItemVerifiedList[name] = new Object;
		febeBuItemVerifiedList[name].verified = false;

		switch(type){
			case "extension":
				break;
			case "theme":
				break;
			case "profile":
				break;
			case "searchPlugin":
				break;
			case "bookmarksHTML":
				break;
			case "resultspage":
				break;
			case "prefs":
				break;
			case "persona":
				break;
			case "bookmarksJSON":
				break;
			case "cookies":
				break;
			case "history":
				break;
			case "febedata":
				break;
			case "unknown":
				break;
		}//switch
	}//while
	return true;
}//febeVerifyBackup()

function febeGetEntryType(entry){
	var type = "";
	var name = entry.leafName;
	if(name == "AllInstalledLightweightThemes.personas.json"){
		type = "AllInstalledLightweightThemes";
		return type;
	}//if
	var p = name.lastIndexOf(".");
	var ext = name.substring(p);
	switch(ext){
		case ".xpi":
			type = "extension";
			break;
		case ".jar":
			type = "theme";
			break;
		case ".fbu":
			if(name.match(/^profileFx4\{.*\}\.fbu$/) != null){
				type = "profile";
			}//if
			if(name.substr(0,14) == "searchPlugins{"){
				type = "searchPlugin";
			}//if
			break;
		case ".html":
			if(name.substr(0,10) == "bookmarks{"){
				type = "bookmarksHTML";
			}//if
			if(name.substr(0,14) == "Results - FEBE"){
				type = "resultspage";
			}//if
			break;
		case ".js":
			if(name.substr(0,6) == "prefs{"){
				type = "prefs";
			}//if
			break;
		case ".json":
			if(name.substr(-13,13) == ".persona.json"){
				type = "persona";
			}//if
			if(name.substr(0,10) == "bookmarks{"){
				type = "bookmarksJSON";
			}//if
			if(name.substr(0,8) == "cookies{"){
				type = "cookies";
			}//if
			if(name.substr(0,8) == "history{"){
				type = "history";
			}//if
			if(name.substr(0,10) == "FEBE data{"){
				type = "febedata";
			}//if
			break;
		default:
			type="unknown";
			break;
	}//switch
	return type;
}//febeGetEntryType(entry)
