// author: Chuck Baker
// Version 7.0

//		Common (global) variables
var Cc = Components.classes;
var Ci = Components.interfaces;
var Cu = Components.utils;

Cu.import("resource://gre/modules/AddonManager.jsm");
Cu.import("resource://gre/modules/PlacesUtils.jsm");

// Set global variables
var febeAddons = [];							// Array of installed add-ons
var febeAlertFinalHeight;				// Used in alert messages
var febeAsync = true;	// If true, zip asynchronously, else zip sychronously
var febeBackupAborted = Boolean(false)	// Set to true if backup is aborted by user
var febeBackupRunType = 0;	// 1='Manual', 2='On startup', 3='On shutdowsn', 4='Scheduled, 5='Reminded''
var febeBUdate = new Date();			// Date of backup to restore
var febeBuDesDir = new String();		// Pointer to backup destination directory
var febeBuItemVerifiedList = [];
var febeBuSeq = new String();			// FEBE Batch Sequence number
var febeBUtype = new String();			// "selective" , "profile, or "alternate""
var febeClearDestDir = Boolean(false); // Clear destination directory?
var febeClipboard = [];					// Holds alert messages for the clipboard
var febeControllerWindow = null;		// Pointer to the window that is controlling the scheduled backup
var febeDataFile;						// Pointer to FEBEDATAFILE
var febeDestDir = new String();			// nsIFile pointer used in febeDirCopy()
var FEBEdir = new String();				// Pointer to FEBE extension directory
var febeDisabledCount = new Number;		// Count of disabled extensions
var febeErr;								// Error variable
var febeErrorList = [];					// Array holding failed items (errors)
var febeETinstall = [];					// Array of ext/theme objects to install
var febeExBuDir = new String();			// Directory where the results are stored
var febeExtensionsList = {};			// Array holding extension names
var febeExtObj = new Object;
var febeFEBEbackedUp = Boolean(false);	// Has FEBE itself been backed up?
var febeGlobalExtCount = 0;			// Count of globally installed extensions
var febeGlobalExtInstallDirectory = {};		
var febeIgnoredList = [];				// Array holding ignored items
var febeIgnoreError;					// Error to ignore
var febeIgnoreList = new Object;			//  List of add-ons to ignore
var febeInitialized;					// Initalize function run yet?
var febeIsOnlineBackup = Boolean;	// To determine if backup is local or online
var febeIsScheduleController = Boolean(false);	// If true, this window is controlling the FEBE scheduler
var febeLocalExtInstallDirectory = {};
var febeLocalizedStr = [];				// "extensions", " themes", "bookmarks", etc.
var febeMainWindow;						// Pointer to main browser window
var febeMaxDirs = new Number;			// Maximum number of timestamped directories
var febeMsg = [];						// Array holding localized strings
var febeObserverService;				// Observer
var febePathName = new String();		// Holds full path name of various files
var febePendingCount = new Number;				// Number of pending extension/theme installs
var febePfName = new String()			// Same as febePrName
var febePfParent = new String()			// Parent directory of filel picker file
var febePlatform = new Number;			// 1=Windows, 2=*nix, 3=Mac 
var febePlaySoundsURI = {};	// Location of sounds
var febePopupIsShowing = Boolean(false);	// Is a popup alert box showing?
var febePrName = new String();			// Leafname of file picker file
var febeProfDir = new String();			// Pointer to profile directory
var febeProfileBackupIsSelected = Boolean(false);
var febeProfileCreated = new Number;	//  Number of newly created profile 
var febeProfileDestinationIsSelected = Boolean(false);
var febeProfileIndex = new Number(-1);	// Number of index of profile being restored
var febeProfileWin = new Object;		// Profile restore window
var febeProfName = new String();		// Profile name
var febeProgressWin = new Object;				// Window object for FEBE progress window
var febeReminded;						// If true,  dont show backup reminder
var febeSkippedCount = new Number;		// Cound of items skipped
var febeSkippedScheduledLastChecked = 0;// Used to determined if scheduled  backup was missed (due to sleep mode)
var febeStatusSave;						// Current value of  dom.disable_window_status_change
var febeSubRootDir = new String();		// Used in febeDirCopy()
var febeThemesList = {};				// Array holding theme names
var febeTmpDir = new String();			// nsIFile pointer to temp directory
var febeUDBuDone = [];					// Array of completed User-defined backups
var febeUploadAborted;					// Monitors box.net upload
var febeUseTimestampedDir = Boolean(false);// Create timestamped subdirectories?
var febeVerifyExtList = [];
var febeVersion = new String();			// Version of this extension (FEBE)
var febeWait;							// Number of milliseconds until next scheduled backup
var febeWarningList = [];				// Array holding failed items (warnings)
var febeWelcomePage = new String();		// URL of welcome page
var febeWin = new Object;				// Window object for FEBE windows
var febex;  							// Misc flag
var febeIncludeFEBEinBu = new String();			// Include a copy of FEBE with backup?

// Preferences
var febeBuBookmarksHTML = Boolean(false);	// Backup bookmarks.(.html)?
var febeBuBookmarksJSON = Boolean(false);	// Backup bookmarks.(.json)?
var febeBuBrowserHistory = Boolean(false);	// Backup history.dat?
var febeBuCookies = Boolean(false);			// Backup cookies.txt?
var febeBuExtensions = Boolean(false);		// Backup extensions?
var febeBuFormFillHistory = Boolean(false);	// Backup formhistory.dat?
var febeBuPermissions = Boolean(false);		// Backup hostperm.1?
var febeBuPreferences = Boolean(false);		// Backup prefs.js?
var febeBuProfile = Boolean(false);			// Backup entire profile?
var febeBuSearchPlugins = Boolean(false);	// Backup searchplungins directory?
var febeBuThemes = Boolean(false);			// Backup themes?
var febeBuUDBu = Boolean(false);			// Backup User-defined backups?
var febeBuUserChrome = Boolean(false);		// Backup userChrome.css?
var febeBuUserPwd = Boolean(false);			// Backup key3.db and signons.txt?
var febeDispProgress = Boolean(false);	// Display progress window?
var febeDispResults = Boolean(false);	// Display results page?
var febeGlobalList = {};							// List of globally installed items (GUIDs)
var febeHideHelp = Boolean(false);		// Hide help icons?
var febeHideIcons = Boolean(false);		// Hide statusbar icons?
var febeIgnoreDisabled = Boolean(false);	// Ignore disabled extension?
var febeIncludeGlobal = Boolean(false);			// Backup globally installed items?
var febePlaySounds = Boolean(false);	// Play sounds?
var febeRunAsync = Boolean(true);		// Run zip routine asynchronously?
var febeSaveResults = Boolean(false);	// Save results page?
var febeVerifyBackups = Boolean(false);	// Verify backups?

// Backup flags	
var febeBmBackedUpHTML = Boolean(false);	// Did bookmarks backup ok (.html)?
var febeBmBackedUpJSON = Boolean(false);	// Did bookmarks backup ok (.json)?
var febeChBackedUp = Boolean(false);	// Did user chrome backup ok?
var febeCkBackedUp = Boolean(false);	// Did cookies backup ok?
var febeExBackedUp = Boolean(false);	// Did extensions backup ok?
var febeFfBackedUp = Boolean(false);	// Did form fill history backup ok?
var febeHsBackedUp = Boolean(false);	// Did history backup ok?
var febePmBackedUp = Boolean(false);	// Did permissions file backup ok?
var febePrBackedUp = Boolean(false);	// Did the preferences backup ok?
var febePwBackedUp = Boolean(false);	// Did passwords backup ok?
var febeSpBackedUp = Boolean(false);	// Did search plugins backup ok?
var febeThBackedUp = Boolean(false);	// Did themes backup ok?
var febeUcBackedUp = Boolean(false);	// Did user content backup ok?
var febeUdBackedUp = new Number;			// Number of User-defined bu's backed up
var febeUpBackedUp = Boolean(false);	// Did the user profile backup ok?

// Backup file names
var febeBcBuName = new String();	// UserContent backup filename
var febeBmBuNameHTML = new String();	// Bookmarks backup filename (.html)
var febeBmBuNameJSON = new String();	// Bookmarks backup filename (json)
var febeChBuName = new String();	// UserChrome backup filename
var febeCkBuName = new String();	// Cookies backup filename
var febeFfBuName = new String();	// Form fill history backup filename
var febeHsBuName = new String();	// Browser history backup filename
var febePmBuName = new String();	// Permissions backup filename
var febePrBuName = new String();	// Preferences backup filename
var febePwBuName = new String();	// Password backup filename
var febeSpBuName = new String();	// Search plugins backup filename
var febeUdBuName = new String();	// User-defined backup filename
var febeUpBuName = new String();	// User profile backup filename

// These should be constants, but CLEO opens this file and re-declares them
var FEBEBUHISTORYFILE = "febeBUhistory.json";
var FEBEDATAFILE = "febeUserDefinedBuData.json";
var FEBEIGNORELISTDATAFILE = "febeIgnoreListData.json";
var FEBE_GUID = "{4BBDD651-70CF-4821-84F8-2B918CF89CA3}"  // GUID of this extension

// Get pointer to preferences
var febePrefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("");

var febeDebug = febePrefs.getBoolPref("extensions.febe.debugMode");	// Set to "true" to activate 'febeDump' commands.

var febeMainWin = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	 .getService(Components.interfaces.nsIWindowMediator)
	 .getMostRecentWindow("navigator:browser");

function febeDump(msg){
	// Display messages to the Error Console
	febeDebug = febePrefs.getBoolPref("extensions.febe.debugMode");
	if(febeDebug){
		var dMsg = "FEBE debug: "+msg;
		Cu.reportError(dMsg);
	}//if
	return true;
}//febeDump()
	
function febeGetUnicharPref(prefName) {
	try{
		var tmp = febePrefs.getComplexValue(prefName, Ci.nsISupportsString).data;
		return tmp;
	}catch(e){
		febeError(prefName+"\n\n"+e);
	}//try/catch
  return 
}//febeGetUnicharPref()

function febeSetUnicharPref(prefName, prefValue) {
	var supportsString = Cc["@mozilla.org/supports-string;1"].createInstance(Ci.nsISupportsString);
	supportsString.data = prefValue;
	febePrefs.setComplexValue(prefName, Ci.nsISupportsString, supportsString);
}//febeSetUnicharPref() 

function febeResetPref(prefName) {
  var prefSvc = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
	prefSvc.clearUserPref(prefName);
	var pType = prefSvc.getPrefType(prefName);
	switch (pType){
		case prefSvc.PREF_BOOL:	
			var prefVal = febePrefs.getBoolPref(prefName); 
			break;
		case prefSvc.PREF_INT:
			var prefVal = febePrefs.getIntPref(prefName);
			break;
		case prefSvc.PREF_STRING:
			var prefVal = febeGetUnicharPref(prefName);
			break;
	}//switch
	return prefVal;
}//febeResetPref()
	
function febeSetMsgs(){
  // Error messages, prompts, etc.
	if(!febeMsg[0]){
		try{
			var fs = document.getElementById('febe-strings');
			if(!fs) {	// Can't find it?  Try looking for the FEBE options window
				var wm = Cc["@mozilla.org/appshell/window-mediator;1"] .getService(Ci.nsIWindowMediator); 
				var enumerator = wm.getEnumerator("febe:options"); 
				while(enumerator.hasMoreElements()) { 
					var win = enumerator.getNext(); 
					fs = win.document.getElementById('febe-strings');
				}//while 
			}//if
			var enumerator = fs.strings;
			var cnt=0;
			var id="";
			while (enumerator.hasMoreElements()) {
				if(cnt > 9){
					id = cnt.toString();
				}else{
					id = "0" + cnt.toString();
				}// if
				var msg = "msg"+id;
				try{
					febeMsg.push(fs.getString(msg));
				}catch(e){;}
				enumerator.getNext();
				cnt++;
			}//while
		}catch(e){alert("Can't find febe-strings\n\n"+e);}
		
		// Add a few blank messages to cover unfinished locales
		for(var i = 0; i<10; i++){febeMsg.push("");}

		// Localize backup item names
		febeLocalizedStr["bookmarks"] = febeMsg[246];
		febeLocalizedStr["cookies"] = febeMsg[248];
		febeLocalizedStr["directory"] = febeMsg[259];
		febeLocalizedStr["Error:"] = febeMsg[264];
		febeLocalizedStr["extension"] = febeMsg[244];
		febeLocalizedStr["Febe Backups"] = febeMsg[263];
		febeLocalizedStr["ffhistory"] = febeMsg[253];
		febeLocalizedStr["history"] = febeMsg[252];
		febeLocalizedStr["other"] = febeMsg[258];
		febeLocalizedStr["permissions"] = febeMsg[254];
		febeLocalizedStr["preferences"] = febeMsg[247];
		febeLocalizedStr["profile"] = febeMsg[256];
		febeLocalizedStr["searchPlugins"] = febeMsg[251];
		febeLocalizedStr["size"] = febeMsg[260];
		febeLocalizedStr["theme"] = febeMsg[245];
		febeLocalizedStr["uploaded ok"] = febeMsg[262];
		febeLocalizedStr["Uploading:"] = febeMsg[261];
		febeLocalizedStr["userChrome"] = febeMsg[249];
		febeLocalizedStr["userDefined"] = febeMsg[255];
		febeLocalizedStr["usernames-passwords"] = febeMsg[250];
	}//if
	Application.storage.set("febeMsg", febeMsg);	// Save messsages for external routines
	
	// Setup list of add-ons to ignore 
	//febeIgnoreList = new Object;
	//febeIgnoreList["{20a82645-c095-46ed-80e3-08825760534b}"] = true;	// Ignore  .NET Framework Assistant for Firefox
	//febeIgnoreList["{000a9d1c-beef-4f90-9363-039d445309b8}"] = true;	// Ignore  Firefox default theme
	//febeIgnoreList["{972ce4c6-7e08-4474-a285-3208198ce6fd}"] = true;	// Ignore  Google Gears plugin

	return true;
}//febeSetMsgs()

function febeGetPrefs(){
  // Get/set the preferences
	febeBuBookmarksHTML = febePrefs.getBoolPref("extensions.febe.buBookmarks.html");
	febeBuBookmarksJSON = febePrefs.getBoolPref("extensions.febe.buBookmarks.json");
	febeBuBrowserHistory = febePrefs.getBoolPref("extensions.febe.buBrowserHistory");
	febeBuCookies = febePrefs.getBoolPref("extensions.febe.buCookies");
	febeBuExtensions = febePrefs.getBoolPref("extensions.febe.buExtensions");
	febeBuFormFillHistory = febePrefs.getBoolPref("extensions.febe.buFormFillHistory");
	febeBuPermissions = febePrefs.getBoolPref("extensions.febe.buPermissions");
	febeBuPreferences = febePrefs.getBoolPref("extensions.febe.buPreferences");
	febeBuSearchPlugins = febePrefs.getBoolPref("extensions.febe.buSearchPlugins");
	febeBuThemes = febePrefs.getBoolPref("extensions.febe.buThemes");
	febeBuUDBu = febePrefs.getBoolPref("extensions.febe.buUDBu");
	febeBuUserChrome = febePrefs.getBoolPref("extensions.febe.buUserChrome");
	febeBuUserPwd = febePrefs.getBoolPref("extensions.febe.buUserPwd");
	febeClearDestDir = febePrefs.getBoolPref("extensions.febe.clearDestDir");
	febeDispProgress = febePrefs.getBoolPref("extensions.febe.displayprogresswin");
	febeDispResults = febePrefs.getBoolPref("extensions.febe.displayresultspage");
	febeExBuDir = febeGetUnicharPref("extensions.febe.curBUdir");	
	febeGetBuType();
	febeHideHelp = febePrefs.getBoolPref("extensions.febe.hidehelp");
	febeHideHelpIcons();
	febeHideIcons = febePrefs.getBoolPref("extensions.febe.hideIcons");
	febeIgnoreDisabled = febePrefs.getBoolPref("extensions.febe.ignoreDisabled");
	febeMaxDirs = febePrefs.getIntPref("extensions.febe.maxBuDirs");
	febePlaySounds = febePrefs.getBoolPref("extensions.febe.playSounds");
	febeRunAsync = febePrefs.getBoolPref("extensions.febe.runAsync");
	febeSaveResults = febePrefs.getBoolPref("extensions.febe.saveresultspage");
	febeStatusSave = febePrefs.getBoolPref("dom.disable_window_status_change");
	febeUseTimestampedDir = febePrefs.getBoolPref("extensions.febe.useTimestampedDir");
	febeVerifyBackups = febePrefs.getBoolPref("extensions.febe.verifyBackups");
	febeIncludeFEBEinBu = febePrefs.getBoolPref("extensions.febe.includefebe");
	
	// Create pointer to profile directory
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	
	var dir = febeProfDir.clone();
	dir.append("extensions");
	febeLocalExtInstallDirectory = dir;
//febeProps(febeLocalExtInstallDirectory)	
	var dir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("CurProcD", Ci.nsIFile);
	dir.append("extensions");
	febeGlobalExtInstallDirectory = dir;
	
	febeHandleSounds();
	return true;
}//febeGetPrefs()

function febeGetAddonList(){
  // Since most of this routine is run asychronously, do it during load to give it time to complete before it's needed

	// First get list of ignored addons
	febeIgnoreList = [];
	var febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	febeDataFile.append(FEBEIGNORELISTDATAFILE);
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	if(febeDataFile.exists() && febeDataFile.fileSize > 0){
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(febeDataFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// read lines into array and parse into individual fields
		var line = {}, hasmore;	
		do {
			hasmore = lis.readLine(line);			
			var item = new Object(JSON.parse(line.value));
			var id = item.id;
			febeIgnoreList[id] = true;
		} while(hasmore);
		cis.close();
		fis.close();
	}else{
		// Create data file and add Fx default theme
		var fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
		fos.init(febeDataFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
		
		var cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
		cos.init(fos, "UTF-8", 0, 0x0000);

		var item = new Object();
		var id = "{972ce4c6-7e08-4474-a285-3208198ce6fd}";
		var name = febeMsg[354];
		item.id = id;
		item.name = name;
		febeIgnoreList[id] = true;		
		var jstr = JSON.stringify(item);
		cos.writeString(jstr+"\n"); 
		cos.close();
		fos.close();
	}//if
	var extDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	extDir.append("extensions");
	febeBuildAddonList(extDir, febeIgnoreList);	
	return true;
}//febeGetAddonList()

function febeCheckAddonsList(){
//febeProps(febeAddons)
	var cnt = 0;
	var ar = {};
	var tmp;
	for(var i in febeAddons){
		ar[i] = new Object();
		ar[i].name = febeAddons[i].name
		ar[i].type = febeAddons[i].type
		tmp += i+" : "+febeAddons[i].name+" : "+febeAddons[i].type+"\n";
		cnt++;
	}//for
	//febeProps(ar)
	alert(tmp)
	//febeprt(tmp,"teal",15);
	return true
}//febeCheckAddonsList()

function febeBuildAddonList(extDir, febeIgnoreList){
	var debug = Application.storage.get("febeCheckAM",false);
	try{
		if(febeAddons[FEBE_GUID].guid == FEBE_GUID && !debug){return true;}	// Already initialized
	}catch(e){;;}
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var personas = [];
	var personasInstalled = [];
	var prefData = "";
	var prefName = "lightweightThemes.usedThemes";
	if(febePrefs.prefHasUserValue(prefName)){
		prefData = febeGetUnicharPref(prefName);
		personasInstalled = JSON.parse(prefData);
		for(var i in personasInstalled){
			try{
				var pId = personasInstalled[i].id + "@personas.mozilla.org";
				personas[pId] = new Object(personasInstalled[i]);
			}catch(e){;;}
		}//for
	}//if	
	var itemIsXpi = [];
	var entries = extDir.directoryEntries;
	if(debug == true){
		var extDirList = {};
		var addonMgrList = {};
		febeprt("Parsing extension directory "+extDir.path+"<br>","blue");
	}//if
	var cnt = 0;
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var item = new Object();
		item.isProxy = false;
		var p = entry.leafName.lastIndexOf(".xpi");	// Is item an xpi?
		var l = entry.leafName.length;
		if(p == (l - 4)){
			var GUID = entry.leafName.substr(0,l-4)
			itemIsXpi[GUID] = true;
			item.isXpi = true;
		}else{
			var GUID = entry.leafName;
			itemIsXpi[GUID] = false;
			item.isXpi = false;	
			if(!entry.isDirectory()) item.isProxy = true; // If it's not a directory or an .xpi, assume it is a proxy extension/plugin
		}//if
		item.guid = GUID;
		item.name = entry.leafName;
		item.isValid = false;
		item.type = "unknown";
		item.installlocation = entry.path;

		/*
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		try{			// See if it is a proxy extension
			dFile.initWithPath(item.installlocation);
			item.installlocationverified = true;
		}catch(e){
			item.installlocationverified = false;
		}//try/catch
*/
		if(debug == true){
			febeprt("guid: "+item.guid,"Olive");
			var tmp = "isXpi: "+item.isXpi+"<br>";
			tmp += "isProxy: "+item.isProxy+"<br>";
			tmp += "installlocation: "+item.installlocation+"<br><br>";
			febeprt(tmp,"green");
			extDirList[item.guid] = item.guid;
		}//if
		cnt++;
		febeAddons[GUID] = item;
	}//while
	if(debug == true){febeprt("Entries in extension directory: "+cnt,"black");}
	
	// Get info for all items
	febeIgnoredList = [];
	febeCheckForGlobalExtensions();
//febeProps(febeGlobalList)	
	AddonManager.getAllAddons(function(addons){
		var debug = Application.storage.get("febeCheckAM",false);
		if(debug == true){febeprt("<br>Getting addons from AddonManager<br><br>","blue");}
		var cnt = [];
		addons.forEach(function(addon) {
		try{
				// Remove spaces and undesirable characters from extension name
				var tmp = "";
				var mask = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
				mask += ".+-_";

				for (var i = 0; i <= addon.name.length; i++){
					var c = addon.name.charAt(i);
					if( mask.indexOf(c) != -1 ){tmp += c};
				}//for
				febeExtBuName = tmp;
				var febeExtExt = ".xpi";
				var isPersona = false;
				if(addon.type == "theme"){
					var id = addon.id;
					//itemIsXpi[id] = false;
					if(!!personas[id]){
						febeExtExt = ".persona.json";
						febeExtBuName += febeExtExt;
						isPersona = true;
					}else{
						febeExtExt = ".jar";
						febeExtBuName += "{" + addon.version + "}"+febeExtExt;
					}//if
				}else{
						febeExtBuName += "{" + addon.version + "}"+febeExtExt;
				}//if
				var item = new Object();
				//item.minVersion = minVersion;
				//item.maxVersion = maxVersion;
				item.guid = addon.id;
				item.type = addon.type;
				item.name = addon.name;
				item.version = addon.version;
				item.buname = febeExtBuName;
				item.desc = addon.description;
				item.homepageURL = addon.homepageURL;
				item.userDisabled = addon.userDisabled;
				item.isCompatible = addon.isCompatible;
				item.iconURL = febeIconToDataURL(addon.iconURL,"chrome://febe/skin/xpinstallItemGeneric.png");
				if(item.type == "theme"){
					item.iconURL64 = febeIconToDataURL(addon.icon64URL,"chrome://febe/skin/defaultThemeIcon64x64.png");
				}else{
					item.iconURL64 = febeIconToDataURL(addon.icon64URL,"chrome://febe/skin/defaultExtIcon64x64.png");
				}//if
				if(item.userDisabled && item.type != "theme") item.iconURL = "chrome://febe/skin/disabled.png";
				var dir = extDir.clone();
				item.isXpi = itemIsXpi[addon.id];
				if(item.isXpi == true){
					dir.append(item.guid+".xpi");
				}else{
					dir.append(item.guid);
					item.isProxy = false;
					if(dir.exists()){
						if(!dir.isDirectory()) item.isProxy = true;
					}//if
				}//if
				item.installlocation = dir.path
				item.ignore = false;
				if(febeIgnoreList[addon.id] == true){
					item.ignore = true;	
					febeIgnoredList[addon.id] = item;
				}else{
					item.ignore = false;
				}//if
				if(item.type == "plugin"){
					item.ignore = true;			
					item.isXpi = false;
				}//if
				if(item.isProxy){
					item.ignore = true;			
					item.isXpi = false;
				}//if
				item.isValid = true;
				item.isPersona = isPersona;
				item.size = addon.size;
				item.installDate = addon.installDate;
				item.updateDate = addon.updateDate;
				item.creator = addon.creator;
				item.id = addon.id;
				item.tooltip = febeTooltip(item);
				item.isGlobal = false;
				if(febeGlobalList[addon.id]){
					item.isGlobal = true;
					febeIgnoredList[addon.id] = item;
				}//if
				febeAddons[addon.id] = item;
				if(debug == true){
					febeprt("name: "+item.name,"Olive");
					var tmp = "guid: "+item.guid+"<br>";
					tmp += "type: "+item.type+"<br>";
					tmp += "version: "+item.version+"<br>";
					tmp += "buname: "+item.buname+"<br>";
					tmp += "desc: "+item.desc+"<br>";
					tmp += "homepageURL: "+item.homepageURL+"<br>";
					tmp += "userDisabled: "+item.userDisabled+"<br>";
					tmp += "isCompatible: "+item.isCompatible+"<br>";
					//tmp += "iconURL: "+item.iconURL+"<br>";
					//tmp += "iconURL64: "+item.iconURL64+"<br>";
					tmp += "isXpi: "+item.isXpi+"<br>";
					tmp += "installlocation: "+item.installlocation+"<br>";
					tmp += "ignore: "+item.ignore+"<br>";
					tmp += "isValid: "+item.isValid+"<br>";
					tmp += "isPersona: "+item.isPersona+"<br>";
					tmp += "size: "+item.size+"<br>";
					tmp += "installDate: "+item.installDate+"<br>";
					tmp += "updateDate: "+item.updateDate+"<br>";
					tmp += "creator: "+item.creator+"<br>";
					tmp += "id: "+item.id+"<br>";
					tmp += "isGlobal: "+item.isGlobal+"<br>";
					tmp += "isProxy: "+item.isProxy+"<br>";
					tmp += "<br>";
					febeprt(tmp,"green");
					if(item.type != "plugin" && !item.isPersona) addonMgrList[item.guid] = item.guid;
				}//if
			}catch(e){
				var tmp = febeExtBuName;
				if(debug == true){febeprt(febeMsg[04]+"\n"+tmp+"\n\n"+e,"red");}
			}//try/catch
			if(!cnt[item.type]) cnt[item.type] = 0;
			cnt[item.type] = cnt[item.type]+1;
		});
		Application.storage.set("febeAddons",febeAddons);
		Application.storage.set("febeIgnoredList",febeIgnoredList);
		Application.storage.set("febeCheckAM",false);
		try{
			febeObserverService.notify(null,"extensionsLoaded",null);
		}catch(e){;;}
		if(debug == true){
			var index = 393;
			for(var i in cnt){	// [item]s reported by AddonManager
				var tmp = febeMsg[index+5].replace("%CNT%",cnt[i]);
				febeprt(tmp,"black");
				index++;
			}//for
			var tmp = febeMsg[394].replace("%CNT%",febeGlobalExtCount);	// globally installed item(s)
			febeprt(tmp+"<br>");
			
			// Check for discrepancies
			for(var i in extDirList){	// listed in ext directory but not in AM
				var tmp = febeMsg[395].replace("%GUID%",i);
				if(!addonMgrList[i]) febeprt(tmp,"red");
			}//for
			for(var i in addonMgrList){	// listed in AM but not in ext directory
				if(febeGlobalList[i]) continue;
				var tmp = febeMsg[396].replace("%GUID%",i);
				if(!extDirList[i]) febeprt(tmp,"red");
			}//for
		}//if
	});
	return true;
}//febeBuildAddonList

function febeCheckForGlobalExtensions(){
  // Check for global extensions
	febeGlobalList = [];
	var febeGlobalExtDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("CurProcD", Ci.nsIFile);
	febeGlobalExtDir.append("extensions");
	if(febeGlobalExtDir.exists()){
		var entries = febeGlobalExtDir.directoryEntries;
		febeGlobalExtCount = 0;
		while(entries.hasMoreElements()){
			var entry = entries.getNext();
			entry.QueryInterface(Ci.nsIFile);
			var dirName = entry.leafName;
			febeGlobalList[dirName] = true;
			//if(!entry.isDirectory()){continue;}
			//if(dirName == "{972ce4c6-7e08-4474-a285-3208198ce6fd}"){continue;}	// Ignore Fx default theme
			febeGlobalExtCount++;
		}//while
	}//if
	return true;
}//febeCheckForGlobalExtensions()

function febeTooltip(ext){
// Fields: creator, description, homepageURL, iconURL, id, updateDate, isActive, name, operationsRequiringRestart, pendingOperations, permissions, screenshots, size, type, updateDate, userDisabled, version
// makeTT(event,iconData,authorLabel,authorDesc,idLabel,idDesc,sizeLabel,sizeDesc,installdateLabel,installdateDesc){

	var tooltip = 'onmouseover="makeTT(event,'
	tooltip += "'"+ext.iconURL64+"',";
	tooltip += "'"+febeMsg[356]+"','"+ext.creator+"',";
	tooltip += "'"+febeMsg[357]+"','"+ext.id+"',";
	var size = ext.size;
	var units = " bytes";
	if(size > 1024){
		size = size / 1024;
		units = " KB";
	}//if
	if(size > 1024){
		size = size / 1024;
		units = " MB";
	}//if
	size = Math.round(size);
	if(size == 0){
		size = "("+febeMsg[267]+")";
		units = "";
	}//if
	var installdate = ext.updateDate;
	if(installdate == null){
		installdate = "("+febeMsg[267]+")";
	}//if
	tooltip += "'"+febeMsg[358]+"','"+size+units+"',";
	tooltip += "'"+febeMsg[359]+"','"+installdate+"'";	
	tooltip += ')" onmouseout="deleteTT()"';
	return tooltip;
}//febeTooltip()

function febeIconToDataURL(iconURL,defaultimg){
	// Convert icon URL to data url	
	var retValue = "";
	try{
		var ioserv = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService); 
		var channel = ioserv.newChannel(iconURL, 0, null); 
		var stream = channel.open(); 

		if (channel instanceof Ci.nsIHttpChannel && channel.responseStatus != 200) {
			retValue =  defaultimg; 
		}else{
			var bstream = Cc["@mozilla.org/binaryinputstream;1"].createInstance(Ci.nsIBinaryInputStream); 
			bstream.setInputStream(stream); 

			var size = 0; 
			var file_data = ""; 
			while(size = bstream.available()) { 
				file_data += bstream.readBytes(size); 
			}//while
			var data = btoa(file_data);
			retValue = "data:image;base64,"+data;
		}//if
	}catch(e){
//alert(e)
		retValue = defaultimg;
	}//try/catch
	return retValue;
}//febeIconToDataURL(retValue)

function febeGetBuType(){
	//febeSetMsgs();
	febeBUtype = febePrefs.getCharPref("extensions.febe.buType");
	var selective = febeMsg[269];
	var profile = febeMsg[270];
	var alternate = febeMsg[271];
	var both = febeMsg[272];
	var txt;
	switch(febeBUtype){
		case "selective":
			febeBuProfile = false;
			txt = selective;
			break;
		case "profile":
			febeBuProfile = true;
			txt = profile;
			break;
		case "alternate":
			var lastbutype = febePrefs.getCharPref("extensions.febe.lastbackup.type");
			febeBuProfile = false;
			if(lastbutype == "selective"){febeBuProfile = true;}
			var type = "";
			if(febeBuProfile == true){
				type = profile;
			}else{
				type = selective;
			}//if
			txt = alternate +" ("+type+")";
			break;
		case "both":
			febeBuProfile = false;
			txt = both + "  ("+selective+" & "+profile+")";
			break;
	}//switch
	febeSetUnicharPref("extensions.febe.lastbackup.type.desc",txt);
	febeSetUnicharPref("extensions.febe.currentbackup.type",txt);
	return txt;
}//febeGetBuType()

function febeBuInProgress(){
	return febePrefs.getBoolPref("extensions.febe.backupInProgress");
}//febeBuInProgress()

function febeBuInProgressCheck(){
	var style = "<style>color: red; font-weight: bold; font-size: 15px;</style>";
	var tmp = style+febeMsg[229]+"\n\n"
	style = "<style>color: black; font-size: 14px;</style>";
	tmp += style+febeMsg[230]+"\n\n";
	style = "<style>color: purple; font-size: 15px;</style>";
	tmp += style+febeMsg[231];
	if(!febeConfirm(tmp)){
		febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
		return false;
	}//if
	return true;
}//febeBuInProgressCheck()

function febeAbort(){
  // 'Abort' button pressed
	febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
	window.close();
	febeAlert(febeMsg[351]);
	febeBackupAborted = true;
	return false;
}//febeAbort()

function febeInitPref(prefName, dflt){
  // Set a preference to default if needed
	if(!febePrefs.prefHasUserValue(prefName)){		
		febeSetUnicharPref(prefName,dflt);
	}else if(febeGetUnicharPref(prefName) == ""){
		febeSetUnicharPref(prefName,dflt);
	}//if
	return true;
}//febeInitPref()

// Object declarations
function febeExtObj(Name, Type, Version, Path, Icon, Home, Guid, Verified, Include, isDisabled, Minversion, Maxversion){
	this.Name = new String(Name);
	this.Type = new Number(Type);
	this.Version = new String(Version);
	this.Path = new String(Path); 
	this.Icon = new String(Icon); 
	this.Home = new String(Home); 
	this.Guid = new String(Guid); 
	this.Verified = Boolean(Verified);
	this.Include = Boolean(Include);
	this.isDisabled = Boolean(isDisabled);
	this.Minversion = new String(Minversion); 
	this.Maxversion = new String(Maxversion); 
	return true;
}//febeExtObj

function febeUDBuDoneObj(Description, Name){
	this.Description = Description;
	this.Name = Name;
	return true;
}//febeUDBuDoneObj()

function febeSetTimeoutObj(PID,Process,Started,Wait){
	this.PID = PID;
	this.Process = Process;
	this.Started = Started;
	this.Wait = Wait;
	return true;
}//febeSetTimeoutObj

function febeCookieObj(expires, host, isDomain, isSecure, name, path, policy, status, value){
	this.expires = expires;
	this.host = host;
	this.isDomain = isDomain;
	this.isSecure = isSecure;
	this.name = name;
	this.path = path;
	this.policy = policy;
	this.status = status;
	this.value = value;
}//febeCookieObj()

function febePrefObj(Name, Type, Value){
	this.Name = Name;
	this.Type = Type;
	this.Value = Value;
}//febePrefObj()

function febeGetPlatform(){
	var platform = navigator.platform.toLowerCase();
	febePlatform = 2;	// Default to *nix since there are so many different flavors
	if(platform.indexOf("win") != -1){febePlatform = 1;}
	if(platform.indexOf("linux") != -1){febePlatform = 2;}
	if(platform.indexOf("unix") != -1){febePlatform = 2;}
	if(platform.indexOf("sunos") != -1){febePlatform = 2;}
	if(platform.indexOf("darwin") != -1){febePlatform = 3;}
	if(platform.indexOf("macintel") != -1){febePlatform = 3;}
	if(platform.indexOf("macppc") != -1){febePlatform = 3;}
	
	return febePlatform;
}//febeGetPlatform()

function febeGetVersion() {
	var ver = new String();;
	try{
		ver = febePrefs.getCharPref("extensions.febe.currentversion");
	}catch(e){
		ver="0.0";
	}//try/catch
	return ver;
}

function febeCheckIfNewInstall() {
	//Cu.import("resource://gre/modules/AddonManager.jsm");
	AddonManager.getAddonByID(FEBE_GUID, function(addon){
		var version = addon.version;
		febePrefs.setCharPref("extensions.febe.currentversion",version);
		var newFEBEinstall = Boolean(false);
		var prefName = "extensions.febe.previousversion";
		if(febePrefs.prefHasUserValue(prefName)){
			var pversion = febePrefs.getCharPref(prefName);
			if (pversion != version){newFEBEinstall = true;}
		}else{
			newFEBEinstall = true;
		}//if
		febePrefs.setCharPref(prefName,version);

		if(newFEBEinstall == true){
			// Get a list on installed locales
			var locales = febeLocales();
			var locale = febePrefs.getCharPref("general.useragent.locale");	
			if(locale.length == 2){		// If the locale is only two characters, just guess what it's supposed to be
				switch(locale){
					case "en":
						locale = "en-US";
						break;
					case "fr":
						locale = "fr-FR";
						break;
					case "es":
						locale = "es-ES";
						break;
					case "pl":
						locale = "pl-PL";
						break;
					case "nl":
						locale = "nl-NL";
						break;
					case "zh":
						locale = "zh-CN";
						break;
					case "de":
						locale = "de-DE";
						break;
					case "ja":
						locale = "ja-JP";
						break;
					case "it":
						locale = "it-IT";
						break;
					case "pt":
						locale = "pt-BR";
						break;
					case "sv":
						locale = "sv-SE";
						break;
					case "sk":
						locale = "sk-SK";
						break;
					case "ru":
						locale = "ru-RU";
						break;

					default:
						locale = "en-US";
						break;
				}//switch
			}//if		
			if(locales.indexOf(locale) == -1){locale = "en-US";}
//alert(locale)
			febeWelcomePage = "http://softwarebychuck.com/febe/Welcome%20pages/FEBE7welcome.html";
			setTimeout(febeWelcomePageDisplay,1500);	// Let the browser catch up
		}//if

	});
	return true;
}//febeCheckIfNewInstall()

function febeSetVersion(){
	febeSetMsgs();
	var febeVer = febeGetVersion();
	if(document.getElementById("febeVersionID")){
		document.getElementById("febeVersionID").value = febeMsg[49]+" "+febeVer;
	}//if
	var fxVer = Cc['@mozilla.org/xre/app-info;1'].getService(Ci.nsIXULAppInfo).version;
	if(document.getElementById("febeFxVersionID")){
		document.getElementById("febeFxVersionDispID").value = fxVer;
	}//if
//alert("Fx version: "+fxVer)
	return true;
}//febeSetVersion()

function febeValidateMaxDirs(){
	var maxDirs = document.getElementById("maxBuDirsID").value;
	if(isNaN(maxDirs)){
		var w = this.window;
		febeAlert(febeMsg[101]);
		w.focus();
		document.getElementById("maxBuDirsID").focus();
		document.getElementById("maxBuDirsID").select();
		return false;
	}//if
	document.getElementById("maxBuDirsID").value = parseInt(maxDirs);
	return true;
}//febeValidateMaxDirs()
	
function febeOpenLink(URL,title){
	if(!URL){return false;}
	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var win = wm.getMostRecentWindow("navigator:browser");
	var febeGetBrowser = win.getBrowser();
	var currBlank = (febeGetBrowser &&
		(febeGetBrowser.mCurrentTab.linkedBrowser &&
		(febeGetBrowser.mCurrentTab.linkedBrowser.contentDocument.location == "about:blank")) ||
		(!febeGetBrowser.mCurrentTab.linkedBrowser &&
		(febeGetBrowser.mCurrentTab.label == "(Untitled)")));
	if(currBlank){
		win.loadURI(URL);
	}else{
		win.openNewTabWith(URL, this.docURL, null, null);
  }//if
	//if(title) win.document.title = title;
	var win = "";	// Clear memory
  return true;
}//febeOpenLink()

function febeOpenResultsPage(URL){
	if(!URL){return false;}
	febeOpenLink(URL);
	return true;
}//febeOpenResultsPage()

function febeHideHelpIcons(){
	var prefName = "extensions.febe.hidehelp";
	febeHideHelp = febePrefs.getBoolPref(prefName);
	var c = "helpButton";
	if(febeHideHelp){c = "none";}
	for(var i=1; i<45; i++){
		var seq = String(i);
		if(i<10){seq = "0".concat(seq);}
		var id = "febeHelp".concat(seq);
		try{	
			document.getElementById(id).setAttribute("class",c) ;
		}catch(e){;}
	}
	return true;
}//febeHideHelpIcons()	

function febeOptions(aPaneID){
	var febeWin = window.openDialog('chrome://febe/content/settings/febeOptions.xul', 'FEBE Options', 'chrome,titlebar,toolbar,centerscreen,resizable');	
	febeWin.focus();
	return true;
}//febeOptions()

function febeHelp(helpIndex,fieldName){
	var febeWin = window.openDialog("chrome://febe/content/febeHelp.xul", "FEBE Help", "chrome,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",helpIndex,fieldName);
	febeWin.focus();
	return true;
}//febeHelp()

function febeAlert(message,modal){
//alert(message)
	var febeMsgType = febePrefs.getCharPref("extensions.febe.alertType");
	if(febeMsgType == "standard"){ // Use plain old alerts instead of sliders
		alert(febeRemoveStyle(message));
		return true;	
	}//if
	var opts = "chrome,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes";
	if(modal){opts = "chrome,dialog=yes,modal=yes,alwaysRaised,resizable,titlebar=no,popup=yes";}
	var febeWin = window.openDialog("chrome://febe/content/febeAlert.xul", "FEBE Alert", opts ,message);	
	febeWin.focus();
	return true;
}//febeAlert()

function febeConfirm(message){
	var febeWin = window.openDialog("chrome://febe/content/febeConfirm.xul", "FEBE Confirm", "chrome,modal=yes,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",message);	
	febeWin.focus();
	var prefName = "extensions.febe.confirm";
	var OK = febePrefs.getBoolPref(prefName);
	return OK;
}//febeConfirm()

function febeConfirmAsk(message){
	var febeWin = window.openDialog("chrome://febe/content/febeConfirmAsk.xul", "FEBE Confirm", "chrome,modal=yes,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",message);	
	febeWin.focus();
	var prefName = "extensions.febe.confirm";
	var OK = febePrefs.getBoolPref(prefName);
	return OK;
}//febeConfirmAsk()

function febeError(message){
	var febeMsgType = febePrefs.getCharPref("extensions.febe.alertType");
	if(febeMsgType == "standard"){ // Use plain old alerts instead of sliders
		alert(febeRemoveStyle(message));
		return true;	
	}//if
	var febeWin = window.openDialog("chrome://febe/content/febeError.xul", "FEBE Error", "chrome,modal=yes,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",message);
	febeWin.focus();	
	return true;
}//febeError()

function febeConfirmOK(){
	var prefName = "extensions.febe.confirm";
	febePrefs.setBoolPref(prefName,true);
	return true;
}//febeConfirmOK()

function febeConfirmCancel(){
	var prefName = "extensions.febe.confirm";
	febePrefs.setBoolPref(prefName,false);
	return true;
}//febeConfirmCancel()

function febeSetAlertMsg(){
	febeSetConfirmMsg();
	return true;
}//febeSetAlertMsg()
	
function febeSetConfirmMsg(){
	// If the message contains a style or class, it must be the first part of the message 
	// (one style per line, if needed).  
	// If a class is assigned, it must be in the form of: <class>classname</class>
	var tmp = window.arguments[0]+"   \n\n";
//alert(tmp)
	var msg = {};
	var i = 0;
	while(true){	// Break it into an array
		var item = new febeAlertObj();
		var p = tmp.indexOf("\n");
		if(p == -1){break;}
		item.Style = "font-family: arial; font-size: 10pt; font-weight: normal; color: purple";  // Default style
		var st1 = tmp.indexOf("<style>");
		if(st1 == 0){	
			var st2 = tmp.indexOf("</style>");
			if(st2 != -1){
				item.Style = tmp.substr(7,st2-7);			// "7" equals the length of "<style>"
				tmp = tmp.replace(tmp.substr(0,st2+8),"");	// Remove the style
				p = tmp.indexOf("\n");
			}//if
		}//if
		
		item.Klass = "normal";
		var cl1 = tmp.indexOf("<class>");
		if(cl1 == 0){	
			var cl2 = tmp.indexOf("</class>");
			if(cl2 != -1){
				item.Klass = tmp.substr(7,cl2-7);			// "7" equals the length of "<class>"
				tmp = tmp.replace(tmp.substr(0,cl2+8),"");	// Remove the class declaration
				p = tmp.indexOf("\n");
			}//if
		}//if

		item.Text = tmp.substr(0,p);
		msg[i] = item;
		i++;
		tmp = tmp.substr(p+1);	
	}//while
	febeClipboard = [];
	tmp = "";
	var msgBox = document.getElementById("febeMsgBox");
	if(msgBox){
		for(var i in msg){
			var desc = document.createElement("description");
			desc.textContent = msg[i].Text;
			desc.setAttribute("style",msg[i].Style);
			if(msg.Klass){
				desc.removeAttribute("style");
				desc.setAttribute("class",msg[i].Klass);
			}//if
			msgBox.appendChild(desc);
			febeClipboard.push(msg[i].Text);
			tmp += desc.textContent+"\n"
			tmp += "class: "+desc.getAttribute("class")+"\n";
			tmp += "style: "+desc.getAttribute("style")+"\n";
//alert(tmp)
			tmp=""
		}//for
		document.documentElement.getButton("extra1").hidden = false;
	}//if
	//var sound = Application.storage.get("alertsound", "alert");
	febePlaySound('message');
//febeProps(msgBox)
	//Application.storage.set("alertsound", "alert")
	return true;
}//febeSetConfirmMsg()

function febeSliderLoad(){
	sizeToContent();
	febeAlertFinalHeight = window.outerHeight;
	window.outerHeight = 1;
	var x =(screen.availLeft + screen.availWidth - window.outerWidth) - 10;
	var y = screen.availTop + screen.availHeight - window.outerHeight;
	window.moveTo(x,y);
	window.focus();
	setTimeout(febeAnimateAlert, 25);
}//febeSliderLoad()

function febeAnimateAlert(){
 	var febeAlertSliderIncrement = 10;	// Amount the slider grows by (pixels)
	var febeAlertSliderTime = 25;		// Time between increments (milliseconds)
	
	if(window.outerHeight < febeAlertFinalHeight){
		window.screenY -= febeAlertSliderIncrement;
		window.outerHeight += febeAlertSliderIncrement;
		setTimeout(febeAnimateAlert, febeAlertSliderTime);
	}//if
}//febeAnimateAlert()

function febeCopyToClipboard(){
  // Copy the contents of a febeAlert, febeConfirm, or febeError box to the system clipboard
	var gClipboardHelper = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
	gClipboardHelper.copyString(febeClipboard.join("\n"));
	return true;
}//febeCopyToClipboard()

function febeAlertObj(Text,Style,Klass){
	this.Text = Text;
	this.Style = Style;
	this.Klass = Klass;
	return true;
}//febeAlertObj()

function febePlaySound(which){
	febeHandleSounds();
	if(!febePlaySounds) return true;
	var gSound = Cc["@mozilla.org/sound;1"].createInstance(Ci.nsISound);
	var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
	var soundURL = febePlaySoundsURI[which];
//alert("PlaySound: "+which+"\n"+soundURL)
	var url = ioService.newURI(soundURL, null, null);
	gSound.init();
	gSound.play(url);
	return true;
}//febePlaySound()

function febePlaySoundHelp(which){
  // Alway play sounds in the "Play sounds" help window
	febeHandleSounds();
	var gSound = Cc["@mozilla.org/sound;1"].createInstance(Ci.nsISound);
	var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
	var soundURL = febePlaySoundsURI[which];
	var url = ioService.newURI(soundURL, null, null);
	gSound.init();
	gSound.play(url);
	return true;
}//febePlaySoundHelp()

function febeHandleSounds(){
	febePlaySounds = febePrefs.getBoolPref("extensions.febe.playSounds");
	
	febePlaySoundsURI['success'] = "chrome://febe/content/sounds/success.wav";
	var opt = febeGetUnicharPref("extensions.febe.sounds.useSuccessSoundType");
	var uri = febeGetUnicharPref("extensions.febe.sounds.useSuccessSoundLocation");
	if(opt == "custom"){febePlaySoundsURI['success'] = "file://"+uri;}
	
	febePlaySoundsURI['failure'] = "chrome://febe/content/sounds/failure.wav";
	var opt = febeGetUnicharPref("extensions.febe.sounds.useFailureSoundType");
	var uri = febeGetUnicharPref("extensions.febe.sounds.useFailureSoundLocation");
	if(opt == "custom"){febePlaySoundsURI['failure'] = "file://"+uri;}
	
	febePlaySoundsURI['warning'] = "chrome://febe/content/sounds/warning.wav";
	var opt = febeGetUnicharPref("extensions.febe.sounds.useWarningSoundType");
	var uri = febeGetUnicharPref("extensions.febe.sounds.useWarningSoundLocation");
	if(opt == "custom"){febePlaySoundsURI['warning'] = "file://"+uri;}
	
	febePlaySoundsURI['message'] = "chrome://febe/content/sounds/alert.wav";
	var opt = febeGetUnicharPref("extensions.febe.sounds.useMessageSoundType");
	var uri = febeGetUnicharPref("extensions.febe.sounds.useMessageSoundLocation");
	if(opt == "custom"){febePlaySoundsURI['message'] = "file://"+uri;}
	
	febePlaySoundsURI['help'] = "chrome://febe/content/sounds/help.wav";
	var opt = febeGetUnicharPref("extensions.febe.sounds.useHelpSoundType");
	var uri = febeGetUnicharPref("extensions.febe.sounds.useHelpSoundLocation");
	if(opt == "custom"){febePlaySoundsURI['help'] = "file://"+uri;}
	return true;
}//febeHandleSounds()


function febeParent(pathname){
  // Return the parent of pathname.  Ex:
  // If pathname is "C:\Documents and Settings\Owner\My Documents\some dir",
  // the function will return "C:\Documents and Settings\Owner\My Documents"
  
	var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	file.initWithPath(pathname);
	return file.parent.path;
}//febeParent()

function febeLeafname(pathname){
  // Return the leafname of pathname.  Ex:
  // If pathname is "C:\Documents and Settings\Owner\My Documents\some dir",
  // the function will return "some dir"
  
	var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	file.initWithPath(pathname);
	return file.leafName;
}//febeLeafname()

function febePause(millis){
  // Pause for (millis) milliseconds
	var date = new Date();
	var curDate = null;
	
	do {curDate = new Date();}
		while(curDate-date < millis);
	return true;
}//febePause() 

function febeWrap(str,len){	
  // Return a string wrapped at len characters max per line
	str = str.toString();
	var tmpA = str.split(" ");
	var returnVal="";
	var tmp = "";
	var skip = Boolean(false);
	for(var i = 0; i < tmpA.length; i++){
		tmp += tmpA[i]+" ";
		if(tmp.length >= len){
			returnVal +="\n"+tmpA[i]+" ";
			tmp = "";
			i--;
			skip = true;
		}else{
			if(skip == false){returnVal += tmpA[i]+" ";}
			skip = false;
		}//if
	}//for
	return returnVal;
}//function febeWrap()

function febeFatal(err,msg){
  // Display fatal errors
	if(err.toString().indexOf(febeIgnoreError) != -1){return true;}
	var style = "<style>color: black;font-size: 8pt;</style>";
	var tmp = febeWrap(err.toString(),100);
	tmp = tmp.replace(/\n/g,"\n"+style);
	tmp = style + tmp;
	tmp +="\n\n";
	var ptSize = 12;
	if(msg.length > 100){ptSize = 8;}
	style = "<style>color: red;font-size: "+ptSize+"pt;</style>";
	msg = msg.replace(/\n/g,"\n"+style);
	tmp += style+msg;
	febeError(tmp);
	throw err;
	return true;
}//febeFatal()

function febeRestoreError(err,msg){
  // Trap restore errors
	if(febeIgnoreError == "all"){return true;}
	var style = "<style>color: black;font-size: 8pt;</style>";
	var tmp = febeWrap(err.toString(),100);
	tmp = tmp.replace(/\n/g,"\n"+style);
	tmp = style + tmp;
	tmp +="\n\n";
	var ptSize = 12;
	if(msg.length > 100){ptSize = 8;}
	style = "<style>color: red;font-size: "+ptSize+"pt;</style>";
	msg = msg.replace(/\n/g,"\n"+style);
	tmp += style+msg;
	var message = tmp;
	var febeWin = window.openDialog("chrome://febe/content/febeRestoreError.xul", "FEBE Restore Error", "chrome,modal=yes,dialog=yes,alwaysRaised,resizable,titlebar=no,popup=yes",message);
	febeSetAlertMsg();
	return true;
}//ffebeRestoreError()

function febeLocalizedDate(aDate){
	var lDate = new Date(aDate);
	var rv = lDate.toLocaleDateString()+" "+lDate.toLocaleTimeString();
	if(rv.indexOf("Invalid") != -1){rv = aDate;}
	return rv;
}//febeLocalizedDate()

function febeNewDirName(which,dirName){
  // Rename timestamped directories from/to ISO8601 to European
	var str = dirName.substr(10,5);
	switch(which){
		case 0:	// Rename DD.MM to MM-DD
			str = str.substr(3,2)+"-"+str.substr(0,2);
			break;
		case 1:	// Rename MM-DD to DD.MM
			str = str.substr(3,2)+"."+str.substr(0,2);
			break;
	}//switch
	var newName = dirName.substr(0,10) + str + dirName.substr(15);
	return newName;
}//febeNewDirName(which,dirName)

function febeStripSpaces(extName){
  // Remove spaces and undesirable characters from extension name
	var tmp = "";
	var mask = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
	mask += ".+-_";
	
	if(extName){
		for (var i = 0; i <= extName.length; i++){
			var c = extName.charAt(i);
			if( mask.indexOf(c) != -1 ){tmp += c};
		}//for
	}//if
	return tmp;
}//febeStripSpaces()

function febeCopyFile(sourcefile,destdir,dName){
//
	febeErr = null;
	if(dName == "parent.lock"){return true;}	// File is locked
	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aFile) return false;
	var aDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aDir){
		febeErr = "skip";
		return false;
	}//if
	aFile.initWithPath(sourcefile);
	aDir.initWithPath(destdir);
	var oFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	oFile.initWithPath(destdir);
	oFile.append(dName);
	try{
		oFile.remove(false);
	}catch(e){;}
		
	try{
		aFile.copyTo(aDir,dName);
	}catch(e){
		var msg = febeMsg[168].replace("%sourcefile%",sourcefile+"\n");
		msg = msg.replace("%destdir%",destdir+"\n");
		msg = msg.replace("%dName%",dName);
		febeFatal(e,msg);
		febeErr = "skip";
		return false;
	}
	return true;
}//febeCopyFile

function febeGetBuDate(filename){
	var oFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	oFile.initWithPath(filename);
	febeBUdate = new Date(oFile.lastModifiedTime);
	return febeBUdate;
}//febeGetBuDate()

function febeRestartFx(){
	// Borrowed from Jed Brown's "Restart Firefox" extension
    a = Ci.nsIAppStartup,Cc["@mozilla.org/toolkit/app-startup;1"].getService(a).quit(a.eRestart | a.eAttemptQuit);
	return true;
}//febeRestartFx()

function febeObfuscate(bool, str){
  //Modified base64 obfuscation
	switch(bool){
		case true:
			try{	//Bug 439711 - btoa does not work on unicode characters, so use encodeURIComponent() instead
				var test = btoa(str);
			}catch(e){
				str = "0"+encodeURIComponent(str);
				return str.toString();
			}//try
			var r=Math.floor(Math.random()*4+2);
			for(var i=0; i<r; i++){
				str = btoa(str);
			}				
			return i.toString()+str;
			break;
		case false:
			var c = new Number(str.charAt(0));
			str = str.substr(1);
			if(c == 0) {return decodeURIComponent(str);}
			for(var i=0; i<c; i++){
				str = atob(str);
			}	
			return str;
			break;
		default:
			return null;
			break;
	}
}//febeObfuscate()

function febeConvertToDataUrl(url){
	var defaultimg = "chrome://febe/skin/xpinstallItemGeneric.png";
	try{
		var ioserv = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService); 
		var channel = ioserv.newChannel(url, 0, null); 
		var stream = channel.open(); 

		if (channel instanceof Ci.nsIHttpChannel && channel.responseStatus != 200) {return defaultimg; }

		var bstream = Cc["@mozilla.org/binaryinputstream;1"].createInstance(Ci.nsIBinaryInputStream); 
		bstream.setInputStream(stream); 

		var size = 0; 
		var file_data = ""; 
		while(size = bstream.available()) { 
			file_data += bstream.readBytes(size); 
		}//while
		var data = btoa(file_data);
		var retval = "data:image;base64,"+data;
	}catch(e){
		var retval = defaultimg;
	}//try/catch
	return retval;
}//febeConvertToDataUrl()

function febeChmod(aDir){
// Recursively set file permissions
//  Directories: 0755
//  Files: 0644
	if(febePlatform == 1) return true;	// Don't bother with Windows
	var aFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	if (!aFile) return false;

	aFile.initWithPath(aDir);
	var entries = aFile.directoryEntries;
	
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var src = entry.path;
		if(entry.isDirectory()){
			entry.permissions = 0755;
			febeChmod(src);
		}else{
			entry.permissions = 0644;
		}//if
	}//while
	return true;
}//febeChmod()

function febeEscape(str){
  // Convert apostrophes to double quotes
	return str.replace(/\'/g,'"');
}//febeEscape()

function febeDontAskAgain(){
	var d = document.getElementById('dontask');
	var dontask = d.checked;
	var prefName = "";	
	febePrefs.setBoolPref("extensions.febe.dontaskagain",dontask);
	return true;
}//febeDontAskAgain()

function febeCheckStatus(){
  // Check to see if all asynchronous extension related routines are finished.
	var extensionsLoaded = Application.storage.get("extensionsLoaded", false);
	if(!extensionsLoaded){	// Extension data is still loading ... try again in a few seconds
		febeAlert(febeMsg[368]);  
		
		// Re-register the observer (Bug https://bugzilla.mozilla.org/show_bug.cgi?id=635548#c43)
		febeObserverService.unregister();
		febeObserverService = new febeObserver();
		febeGetAddonList();
		return false;
	}//if
	return true;
}//febeCheckStatus()

function febeDoSomething(){
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	                   .getService(Components.interfaces.nsIWindowMediator);
	var mostRecent = wm.getMostRecentWindow("navigator:browser");
	if(mostRecent == this.window){
		alert("true")
	}else{
		alert("false")
	}//if
	
}

function febeRemoveStyle(txt){
  // remove ,style> tag from txt
	var styleStart = txt.indexOf("<style>");
	if(styleStart == -1){return txt;}
	var styleEnd = txt.indexOf("</style>");
	if(styleEnd == -1){return txt;}
	return txt.substr(styleEnd+8);
}//febeRemoveStyle()

function febeNow(){
	// Return milliseconds since 1970/01/01
	var dt = new Date();
	return dt.getTime();
}//febeNow

/*
function febeInit2(){
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"]
        .getService(Ci.nsIProperties)
        .get("ProfD", Ci.nsIFile);
	return true;				
}//febeInit2()
*/
