// author: Chuck Baker
// Version 7.0

var febeNameGuidxref = {};
var febeItemsSelectedCount = 0;
var febeItemsListedCount = 0;

function febeBuildList(){
	if(!febeCheckStatus()){return false;}
	var febeIgnList = document.getElementById("febeExtList");
	var febeIgnItems = febeIgnList.childNodes;
	febeItemsSelectedCount = 0;
	febeItemsListedCount = 0;
	
	// Clear the list
	var n = febeIgnItems.length;
	for (var i = 0; i < n; i++) {
		febeIgnList.removeChild(febeIgnItems[0]);
	}//for
	
	febeBuildExtList();
	
	// Sort the list
	var sortArray = [];
	for(var i in febeExtensionsList){
		//if(febeExtensionsList[i].ignore == true) continue;
		var type = febeExtensionsList[i].type;
		if(type != "extension" && type != "theme") continue;
		sortArray.push(febeExtensionsList[i].name);
	}//for
	sortArray.sort();

	for(var i in sortArray){
		var data = febeExtensionsList[febeNameGuidxref[sortArray[i]]];
		//if(data.ignore == true) continue;
		var row = document.createElement('listitem');
		row.setAttribute('id', data.guid );
		row.setAttribute('type', "checkbox" );
		row.setAttribute('oncommand', "febeCountSelected(this)" );
		//var fxver = "(Fx ver "+data.Minversion+" - "+data.Maxversion+")";
		//var fxver = "";
		var aType = "";
		if(data.isGlobal) aType = "(global)";
		if(data.isProxy) aType = "(proxy)";
		row.setAttribute('label', data.name+"{"+data.version+"}  "+aType );
		row.setAttribute('checked', data.ignore );
//alert(data.name+" : "+!!row.hasAttribute('checked')+" : "+!!row.getAttribute('checked'))
		
		// Always ignore Fx default theme and any global/proxy extensions
		if(data.guid == "{972ce4c6-7e08-4474-a285-3208198ce6fd}")row.setAttribute('checked', true );
		if(data.isGlobal == true) row.setAttribute('checked', true );
		if(data.isProxy == true) row.setAttribute('checked', true );

		if(data.type == "extension"){
			row.setAttribute('style', "color: blue;" );
		}else{
			row.setAttribute('style', "color: green;" );
		}//if
		if(data.isCompatible == false) row.setAttribute('style', "color: red;" );
		if(data.userDisabled) row.setAttribute('style', "color: grey;" );
//alert(data.name+" : "+data.type)		
		febeIgnList.appendChild( row );
		if(row.getAttribute('checked') == "true") febeItemsSelectedCount++;
		febeItemsListedCount++;
	}//for
	document.getElementById("febeSelectILAllID").setAttribute("disabled","false");
	document.getElementById("febeDeselectILAllID").setAttribute("disabled","false");
	document.getElementById("febeSelectILAICID").setAttribute("disabled","false");
	document.getElementById("febeSaveIgnoreListID").setAttribute("disabled","false");
	document.getElementById("febeILselectedValueID").value = febeItemsSelectedCount;
	document.getElementById("febeILlistedValueID").value = febeItemsListedCount;
	return true;
}//febeBuListWindow()

function febeSelect(bool){
  // Select/deselect all
	febeItemsSelectedCount = 0;
	for(var i in febeExtensionsList){
		var type = febeExtensionsList[i].type;
		if(type != "extension" && type != "theme") continue;
		var item = document.getElementById(i);
		if(item) item.setAttribute("checked",bool);
		var check = febeExtensionsList[i].isGlobal || febeExtensionsList[i].isProxy;
		if(check){	// Default theme, global and proxy addons
			item.setAttribute("checked",true);
			febeItemsSelectedCount++;
			continue;
		}//if
		if(bool)febeItemsSelectedCount++;
	}//for
	document.getElementById("febeILselectedValueID").value = febeItemsSelectedCount;
}//febeSelect()

function febeSelectIncompatable(){
	febeItemsSelectedCount = 0;
	for(var i in febeExtensionsList){
		var item = febeExtensionsList[i];
		//if(item.ignore) continue;
		var type = febeExtensionsList[i].type;
		if(type != "extension" && type != "theme") continue;
		var item = document.getElementById(i);
//alert(item.name+" : "+item.isCompatible)
		if(!febeExtensionsList[i].isCompatible) {
			item.setAttribute("checked",true)
			febeItemsSelectedCount++;
		}//if
	}//for
	document.getElementById("febeILselectedValueID").value = febeItemsSelectedCount;
}//febeSelect()

function febeCountSelected(which){
	var check = febeExtensionsList[which.id].isGlobal || febeExtensionsList[which.id].isProxy;
	if(check){
		febeAlert(febeMsg[354]);
		which.checked = true;
		return;
	}//if
	var bool = which.checked;
	if(bool){
		febeItemsSelectedCount++;
	}else{
		febeItemsSelectedCount--;
	}//if
	document.getElementById("febeILselectedValueID").value = febeItemsSelectedCount;
	return true;
}//febeCountSelected()

function febeSaveIgnoreList(){
	var febeIgnList = document.getElementById("febeExtList");
	var febeIgnItems = febeIgnList.childNodes;
	var n = febeIgnItems.length;
	
	// Create ignore list data file
	var ignoreList = [];
	for (var i = 0; i < n; i++) {
		var checked = febeIgnItems[i].checked;
		var id = febeIgnItems[i].id;
		var label = febeIgnItems[i].label;
		febeAddons[id].ignore = checked;
		if(checked){
			var ignoreItem = new Object();
			ignoreItem.id = id;
			ignoreItem.name = label;
			ignoreList.push(ignoreItem);
		}//if
	}//for
	
	// Write ignore list to file
	var fos, cos;
	
  // Get data from file - create template if needed
	var febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	febeDataFile.append(FEBEIGNORELISTDATAFILE);
	var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(febeDataFile, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	for(var i in ignoreList){
		var jstr = JSON.encode(ignoreList[i]);
		cos.writeString(jstr+"\n"); 
	}//for
	
	cos.close();
	fos.close();
	febeAddons[FEBE_GUID].guid = "";	// Force rebuild of addon list
//alert("Calling febeGetAddonList from febeSaveIgnoreList")
	febeGetAddonList();
	febeAlert(febeMsg[348]);
	return true;
}//febeSaveIgnoreList()

function febeBuildExtList(){
  //Get a list of all installed extensions/themes
	febeExtensionsList = {};
	//febeGetAddonList();
	for(var guid in febeAddons){
			var ext = febeAddons[guid];
			febeExtensionsList[guid] = ext;
			febeNameGuidxref[ext.name] = guid; 
	}//for
	return true;
}//febeBuildExtList()