// author: Chuck Baker
// Version 7.0
	
	window.addEventListener("load",febeBuProfileCheck,true);

function febeBuSelectAll(bool) {
	var box = document.getElementById("additionalItemsID");
	var checkboxes = box.getElementsByTagName("checkbox");
	for(var i=0; i<checkboxes.length; i++){
		if(!checkboxes[i].disabled){
			checkboxes[i].setAttribute("checked",bool);
			var id = checkboxes[i].id;	// The ID is the same as the preference name.  Clever, eh?
			var prefname = id.replace(/_/g,".");
			febePrefs.setBoolPref(prefname,bool);
		}//if
	}//for
	febeBuProfileCheck();
	return true;
}//febeBuSelectAll()

function febeOptPrefInit() {
	var box = document.getElementById("additionalItemsID");
	var checkboxes = box.getElementsByTagName("checkbox");
	for(var i=0; i<checkboxes.length; i++){
		if(!checkboxes[i].disabled){
			var id = checkboxes[i].id;
			var prefname = id.replace(/_/g,".");
			var bool = febePrefs.getBoolPref(prefname);
			checkboxes[i].setAttribute("checked",bool);
		}//if
	}//for
	return true;
}//febeBuSelectAll()


function febeBuProfileCheck(){
	febeSetMsgs();
	try{  	
		var buType = febePrefs.getCharPref("extensions.febe.buType");

		if(buType == "profile"){  // Disable options if profile backup is checked
			document.getElementById("febeBuExtensions_id").setAttribute("disabled",true);
			document.getElementById("febeBuThemes_id").setAttribute("disabled",true);
			document.getElementById("extensions_febe_buBookmarks_json").setAttribute("disabled",true);
			document.getElementById("extensions_febe_buBookmarks_html").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuPreferences").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuCookies").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuUserChrome").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuUserPwd").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuSearchPlugins").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuBrowserHistory").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuFormFillHistory").setAttribute("disabled",true);
			document.getElementById("extensions_febe_febeBuPermissions").setAttribute("disabled",true);
			document.getElementById("extensions_febe_buUDBu").setAttribute("disabled",true);
		} else {
			document.getElementById("febeBuExtensions_id").setAttribute("disabled",false);
			document.getElementById("febeBuThemes_id").setAttribute("disabled",false);
			document.getElementById("extensions_febe_buBookmarks_json").setAttribute("disabled",false);
			document.getElementById("extensions_febe_buBookmarks_html").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuPreferences").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuCookies").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuUserChrome").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuUserPwd").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuSearchPlugins").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuBrowserHistory").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuFormFillHistory").setAttribute("disabled",false);
			document.getElementById("extensions_febe_febeBuPermissions").setAttribute("disabled",false);
			document.getElementById("extensions_febe_buUDBu").setAttribute("disabled",false);
			febeOptionsCheck();
		}//if
	}catch(e){;}
	window.removeEventListener("load",febeBuProfileCheck,true);
	return true;
}//febeBuProfileCheck()	

function febeSelExt(){
  // Select extensions to backup
    var w = "chrome://febe/content/febeSelExt.xul";
	window.open(w, "FEBE Select Extensions", "chrome,alwaysRaised,centerscreen,resizable");
}//febeSelExt()

function febeSelTheme(){
  // Select extensions to backup
    var w = "chrome://febe/content/febeSelTheme.xul";
	window.open(w, "FEBE Select Themes", "chrome,alwaysRaised,centerscreen,resizable");
}//febeSelTheme()

function febeSelBUDestDir(){
  // Select backup destinaton directory
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[5], nsIFilePicker.modeGetFolder);
	fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText);

    // Set default directory to current backup directory
	if(febePrefs.prefHasUserValue("extensions.febe.extBUdir")){
		var extBUdir = febeGetUnicharPref("extensions.febe.extBUdir");
		if(extBUdir != ""){
			var dd = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
			try{
				dd.initWithPath(extBUdir);
				fp.displayDirectory = dd;
			}catch(e){;;}
		}//if
	}//if
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		rv = fp.file;
		extBUdir = rv.path;
		febeSetUnicharPref("extensions.febe.extBUdir", extBUdir);
		document.getElementById("DestDirID").value = extBUdir;
		var d = document.getElementById("DestDirID");
		d.setAttribute("value",extBUdir);
	}//if
	febeCheckBuDestDir();
	return true;
}//febeSelBUDestDir()

function febeSetStatusbarVisibility(){
	febeHideIcons = document.getElementById("hideIcons_id").checked;
	var wm = Cc["@mozilla.org/appshell/window-mediator;1"].getService(Ci.nsIWindowMediator);
	var enumerator = wm.getEnumerator("navigator:browser");
	while(enumerator.hasMoreElements()) {
		var win = enumerator.getNext();
		var d = win.document.getElementById("febestatusbar");
		if(!Boolean(d)){return false;}
//alert(win.title+"\nController: "+win.febeIsScheduleController+"\nfebeHideIcons: "+febeHideIcons)
		if(win.febeIsScheduleController){
			//setTimeout(function(){d.hidden = d.collapsed = febeHideIcons;},1000);
			d.hidden = d.collapsed = febeHideIcons;
		}else{
			//setTimeout(function(){d.hidden = d.collapsed = true;},1000);
			d.hidden = d.collapsed = true;
		}//if
	}//while
	febeSetStatus();
	return true;
}//febeInvert()

function febeClearPrefs(){
	var tmp = febeMsg[126]+"\n"+febeMsg[127]+"\n\n";
	var style = "<style>color: red; font-weight: bold; font-size: 15px;</style>";
	tmp += style+febeMsg[183]+"\n\n";
	tmp += febeMsg[128]
	var ok = febeConfirm(tmp);
	if(!ok){return false;}
	
	// Clear Box.net credentials
	febeClearLogin();
	
	try {
		var prefCount = {value:0}; 
		var prefService = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService); 
		var prefBranch = prefService.getBranch(null); 
		var prefArray = prefBranch.getChildList("extensions.febe." , prefCount); 
		var nsIPrefBranch = Ci.nsIPrefBranch;  
		for (i = 0; i < prefCount.value; i++){
			if(prefBranch.prefHasUserValue(prefArray[i])){prefBranch.clearUserPref(prefArray[i]);}
		}
		prefBranch.deleteBranch("extensions.febe.");
		
		// delete the user-defined data file if it exists
		var febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		febeDataFile.append(FEBEDATAFILE);
		if(febeDataFile.exists()){febeDataFile.remove(false);}
		
		// delete the ignore list data file if it exists then reuild it
		var febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		febeDataFile.append(FEBEIGNORELISTDATAFILE);
		if(febeDataFile.exists()){febeDataFile.remove(false);}
		febeGetAddonList();
	}catch (e) {
		alert(e);
		return false;
  }
	var version = febeGetVersion();
	var prefName = "extensions.febe.previousversion";
	febePrefs.setCharPref(prefName,version);
	alert(febeMsg[129]);
	febeRestartFx();
	return true;
}//febeClearPrefs()

function febeExportPrefs(){
	var dir = febeGetUnicharPref("extensions.febe.exportprefs.directory");
	var fname = febeGetUnicharPref("extensions.febe.exportprefs.fname");
//alert(dir+"\n"+fname)
	if(dir == "" || fname == ""){
		febeError(febeMsg[367]);
		return false;
	}//if
	var uri = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	try{
		uri.initWithPath(dir);
	}catch(e){
		var tmp = febeMsg[329].replace("%DIR%",dir);
		tmp += "\n\n"+e.toString();
		febeError(tmp);
		return false;
	}//try/catch
	uri.append(fname+".json");
	if(uri.exists()){
		var tmp = febeMsg[331].replace("%DIR%",uri.path);
		tmp+= "\n\n"+febeMsg[332];
		if(!febeConfirm(tmp)){return true;}
	}//if

	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
	var fos, cos, cnt = 0;
	
	fos = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	fos.init(uri, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
	cos = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);
	cos.init(fos, "UTF-8", 0, 0x0000);
	
	var prefCount = {value:0}; 
	var prefService = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService); 
	var prefBranch = prefService.getBranch(null); 
	var prefArray = prefBranch.getChildList("extensions.febe." , prefCount); 
	var prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefBranch);

	for (i = 0; i < prefCount.value; i++){
		var prefName = prefArray[i];
		var type = prefBranch.getPrefType(prefName);
		var prefObj = new Object;
		prefObj.name = prefName;
		switch (type){
			case prefs.PREF_BOOL:	
				prefObj.type = "BOOL";
				prefObj.value = prefs.getBoolPref(prefName);
				break;
			case prefs.PREF_INT:
				prefObj.type = "INT";	
				prefObj.value = prefs.getIntPref(prefName);				
				break;
			case prefs.PREF_STRING:
				prefObj.type = "STRING";
				prefObj.value = prefs.getComplexValue(prefName, Ci.nsISupportsString).data;
				break;
		}//switch
		var jstr = JSON.stringify(prefObj);
		cos.writeString(jstr+"\n"); 
		cnt++;
	}//if

	cos.close();
	fos.close();
	var tmp = febeMsg[330].replace("%NUM%",cnt);
	tmp = tmp.replace("%DIR%","\n"+uri.path);
	febeAlert(tmp);
}//febeExportPrefs()

function febeBrowseForExportDir(){
	var d = document.getElementById("exportprefsdirID");
	var dir = febePickDir(d.value,328);
	if(dir == false) return false;
	d.setAttribute("value",dir);
	febeSetUnicharPref("extensions.febe.exportprefs.directory",dir);
	return true;
}//febeBrowseForExportDir()

function febeImportPrefs(){
	var file = febeBrowseForImportFile();
	if(file == false) return true;
	febeBUdate = febeGetBuDate(file);
	if(febeConfirmRestore(334,febeBUdate)){
		//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);

		var ios = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);

		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(file);
		
		var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
		fis.init(dFile, 0x01, 0444, 0);
		fis.QueryInterface(Ci.nsILineInputStream);

		var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
		cis.init(fis,"UTF-8", 0, 0x0000);
		
		var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

		// Only import prefs that are currently used.  Ignore old, deprecated prefs
		var line = {}, hasmore, cnt = 0;
		var badPrefs = [];
		do {
			hasmore = lis.readLine(line);
			var pref = JSON.parse(line.value);
			var type = pref.type;
			var prefName = pref.name;
			var prefValue = pref.value
			switch(type){
				case "BOOL":	
					try{
						var v = febePrefs.getBoolPref(prefName);	// Try reading the value first.  If it doesn't exist, an error will occur
						febePrefs.setBoolPref(prefName,prefValue);
						cnt++;
					}catch(e){badPrefs.push(prefName+" : "+type+" : "+prefValue);}
					break;
				case "INT":
					try{
						var v = febePrefs.getIntPref(prefName);
						febePrefs.setIntPref(prefName,prefValue);
						cnt++;
					}catch(e){badPrefs.push(prefName+" : "+type+" : "+prefValue);}
					break;
				case "STRING":
					try{
						var v = febeGetUnicharPref(prefName);
						febeSetUnicharPref(prefName, prefValue);
						cnt++;
					}catch(e){badPrefs.push(prefName+" : "+type+" : '"+prefValue+"'");}
					break;
			}//switch
		} while(hasmore);

		var tmp = febeMsg[335].replace("%NUM%",cnt)+"\n\n";
		var l = badPrefs.length;
		if(l != 0){
			tmp += "<style>color: red;</style>"+febeMsg[337].replace("%CNT%",l)+"\n";
			for(var i=0; i<l; i++){
				tmp+= "<style>color: black;</style>"+badPrefs[i]+"\n";
			}//for
		}//if
		febeAlert(tmp);
	}else{
		febeAlert(febeMsg[336]);
	}//if
	return true;
}//febeImportPrefs()

function febeBrowseForImportFile(){
	var extportdir = febeGetUnicharPref("extensions.febe.exportprefs.directory");
	var file = febePickFile("*.json",333,extportdir);
	if(file == false) return false;
	return file;
}//febeBrowseForImportFile()

function febeViewBuDir(){
	var febeBuDestDir = document.getElementById("DestDirID").value;
	febeOpenLink("file:///"+febeBuDestDir);
	return true;
}//febeViewBuDir()

function febeViewInstallDir(){
	var febeInstallDir = document.getElementById("febeInstallPath").value;
	febeOpenLink("file:///"+febeInstallDir);
	return true;
}//febeViewInstallDir

function febeCheckBDD(){
	var d = document.getElementById("febeWherePaneTitleID");
	d.setAttribute("warning", "true");
//febeProps(d)
}//febeCheckBDD

function febeCheckBuDestDir(){
	if(document.getElementById("DestDirID") && document.getElementById("DestDirID").value != ""){
		document.getElementById("febeviewbudirbtnID").disabled = false;
	}else{
		document.getElementById("febeviewbudirbtnID").disabled = true;
	}//if
	return true;
}//febeCheckBuDestDir()

function febeDisableOpts(){
	try{	// Use a try blocks because statements refer to different preference windows which may not be loaded
		document.getElementById("clearwarn_id").disabled = !document.getElementById("clearDestDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("maxBuDirsLabelID").disabled = !document.getElementById("useTimestampedDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("maxBuDirsID").disabled = !document.getElementById("useTimestampedDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("febeTimestampFormatLabelID").disabled = !document.getElementById("useTimestampedDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("febeTimestampFormat1ID").disabled = !document.getElementById("useTimestampedDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("febeTimestampFormat2ID").disabled = !document.getElementById("useTimestampedDir_id").checked;
	}catch(e){;}
	try{
		document.getElementById("febeclearbuinprogresstbtn").disabled = !febeBuInProgress();
	}catch(e){;}
	febePlatform = febeGetPlatform();
	return true;
}//febeDisableOpts()

function febeCloseButtonEtc(){
	// if no backup directory is set, make the field stand out
	var d = document.getElementById("DestDirID");
	if(d){
		var empty = d.emptyText;
		var value = d.value;
		if(value == ""){
			d.className = "warnOn";
		}else{
			d.className = "warnOff";
		}//if
	}//if

	var d = document.getElementById("febeWherePaneTitleID");
	if(d){	
		febeExBuDir = febePrefs.getCharPref("extensions.febe.extBUdir");	
		if(febeExBuDir == ""){
			d.setAttribute("style.list-style-image","url('chrome://febe/skin/febe_pref.png')");
			d.setAttribute("nobudir","true");
		}else{
			d.setAttribute("style.-moz-image-region","rect(0px, 64px, 32px, 32px)");
			d.setAttribute("nobudir","false");
		}//if
	}//if

	febeGetPlatform();
	try{	// Use a try block because statements refer to different preference windows which may not be loaded
	  // Show close button for Mac OS X users because they don't get buttons for <prefwindow>
	  // Looks like Fx3 doesn't show for *nix either	  
		if(febePlatform == 2 || febePlatform == 3){
			document.getElementById("febeMacAcceptBtn").hidden = false;
		}//if
		
		// Set text direction
		var textdir = document.getElementById("febeTextDir").value;
		if(!textdir){textdir = "ltr";}
		var prefName = "extensions.febe.orientation";
		febePrefs.setCharPref(prefName,textdir);
		
	  // Add event listeners
		var d = document.getElementById("febeTimestampFormatID");
		d.addEventListener("RadioStateChange", febeTimestampDirCheck, false);
		
	}catch(e){;}
	febeCheckForGlobalExtensions();
	var d = document.getElementById("febeIncludeGlobal_id");
	if(d && febeGlobalExtCount == 0){
		d.setAttribute("checked",false);	
		d.setAttribute("disabled",true);
		febePrefs.setBoolPref("extensions.febe.febeIncludeGlobal",false);		
	}//if
	return true;
}//febeCloseButtonEtc()
	
function febeOptionsCheck(){
  // Enable/disable options
	// Create pointer to profile directory
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	
	// Disable "Ignore cache and phishing DB" checkbox if cache directory is not located in the current profile folder
	var profileDir = febeProfDir.clone();
	profileDir.append("Cache");
	var d = document.getElementById("ignoreCache_id");
	if(profileDir.exists()){
		if(d){
			d.setAttribute("disabled",false);
		}//if
		//var prefName = "extensions.febe.ignorecache";
		//febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",true);
	}//if
	
	var buType = febePrefs.getCharPref("extensions.febe.buType");
	if(buType == "profile"){return true;}
	var tmp = ""; 
  
	// Check userChrome.css
	var d = document.getElementById("extensions_febe_febeBuUserChrome");
	var profileDir = febeProfDir.clone();
	profileDir.append("chrome");
	profileDir.append("userChrome.css");
	if(!profileDir.exists()){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuUserChrome";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
		
	// Check cookies.sqlite
	var d = document.getElementById("extensions_febe_febeBuCookies");
	var profileDir = febeProfDir.clone();
	profileDir.append("cookies.sqlite");
	if(!profileDir.exists()){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuCookies";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	// Check usernames/passwords
	var d = document.getElementById("extensions_febe_febeBuUserPwd");
	var loginManager = Cc["@mozilla.org/login-manager;1"].getService(Ci.nsILoginManager);	
	var logins = loginManager.getAllLogins({});
	if(logins.length < 1){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuUserPwd";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
		
	// Check searchPlugins
	var d = document.getElementById("extensions_febe_febeBuSearchPlugins");
	var profileDir = febeProfDir.clone();
	profileDir.append("searchplugins");
	if(!profileDir.exists()){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuSearchPlugins";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	// Check history.dat
	var d = document.getElementById("extensions_febe_febeBuBrowserHistory");
	var historyService = Cc["@mozilla.org/browser/nav-history-service;1"].getService(Ci.nsINavHistoryService);
	if(!historyService.hasHistoryEntries){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuBrowserHistory";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	// Check formhistory.dat
	var d = document.getElementById("extensions_febe_febeBuFormFillHistory");
	var dbFile = febeProfDir.clone();
	dbFile.append("formhistory.sqlite");

	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var db = storageService.openDatabase(dbFile);
	var sQuery = "SELECT * FROM moz_formhistory";
	var stmt = db.createStatement(sQuery);
	if(!stmt.executeStep()){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuFormFillHistory";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	// Check permissions
	var d = document.getElementById("extensions_febe_febeBuPermissions");
	var dbFile = febeProfDir.clone();
	dbFile.append("permissions.sqlite");

	var storageService = Cc["@mozilla.org/storage/service;1"].getService(Ci.mozIStorageService);
	var db = storageService.openDatabase(dbFile);
	var sQuery = "SELECT * FROM moz_hosts";
	var stmt = db.createStatement(sQuery);
	if(!stmt.executeStep()){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuPermissions";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	// Check user-defined backups
	var d = document.getElementById("extensions_febe_buUDBu");
	if(febeUDBuInit() == false){
		if(d){
			if(d.checked == true){tmp += d.label + "\n";}
			d.checked = false;
			d.setAttribute("disabled",true);
		}//if
		var prefName = "extensions.febe.febeBuUDBu";
		febePrefs.setBoolPref(prefName,false);
	}else{
		if(d) d.setAttribute("disabled",false);
	}//if
	
	febeResultsFormat();
	
	// Display message
	if(febex == true){return;}	// Display msg only once
	febex = true;
	if(tmp.length != 0){
		var style = "<style>color: red; font-weight: bold; font-size: 15px;</style>";
		tmp = style+febeMsg[184]+"\n\n"+tmp;
		febeAlert(tmp);
	}//if
}//febeOptionsCheck()

function febeProfileWizard(){
	var wizard = "chrome://mozapps/content/profile/createProfileWizard.xul";
	window.open(wizard, "FEBE Help", "chrome,alwaysRaised,centerscreen,resizable");
}//febeProfileWizard()

function febeTimestampDirCheck(event){
	var selected = document.getElementById("febeTimestampFormatID").selectedItem.value;
	var current = febePrefs.getCharPref("extensions.febe.timestamp.format");
	if(current == selected){return true;}
	if(!febeGetBDD()){return false;}		// Get backup destination directory

	var tags = ["ISO8601","European"];
	var masks = [/^FEBE \d\d\d\d \d\d\.\d\d \d\d\.\d\d\.\d\d$/,/^FEBE \d\d\d\d \d\d-\d\d \d\d\.\d\d\.\d\d$/];
	var which = document.getElementById("febeTimestampFormatID").selectedIndex;
	var mask = masks[which];
	var dirArray = {};
	var numDirsToRename = 0;
	var buDirRoot = febeBuDesDir.clone();
	var entries = buDirRoot.directoryEntries;
	
	// Count the number of directories that need to be renamed
	while(entries.hasMoreElements()){
		var entry = entries.getNext();
		entry.QueryInterface(Ci.nsIFile);
		var dirName = entry.leafName;
		if(!entry.isDirectory()){continue;}
		if(!dirName.match(mask)){continue;}
		numDirsToRename++;
		
		dirArray[dirName] = febeNewDirName(which,dirName);
	}//while
	if(numDirsToRename == 0){return true;}
	
	var newformat,oldformat;
	switch(which){
		case 0:	
			oldformat = tags[1];
			newformat = tags[0];
			break;
		case 1:	
			oldformat = tags[0];
			newformat = tags[1];
			break;
	}//switch
	var tmp = febeMsg[204].replace("%NUMDIR%",numDirsToRename);
	tmp = tmp.replace("%FORMT%",oldformat)+"\n";
	tmp += febeMsg[205].replace("%NEWFORMAT%",newformat)+"\n\n"+febeMsg[41];
	tmp="<style>color: red; font-weight: bold; font-size: 15px;</style>"+tmp;
	if(!febeConfirm(tmp)){
		switch(which){ // Switch it back to where it was
		case 0:	
			document.getElementById("febeTimestampFormatID").selectedIndex = 1;
			break;
		case 1:	
			document.getElementById("febeTimestampFormatID").selectedIndex = 0;
			break;
	}//switch
		febePrefs.setCharPref("extensions.febe.timestamp.format",current);
		febeAlert(febeMsg[206]);
		return false;
	}//if
	
	// Rename the directories
	for(var i in dirArray){
		var rnDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		rnDir.initWithPath(buDirRoot.path);
		rnDir.append(i);

		var filespec = Cc["@mozilla.org/filespec;1"].createInstance(Ci.nsIFileSpec);
		filespec.nativePath = rnDir.path;
		
		filespec.rename(dirArray[i]);
//alert("Rename "+i+" to "+dirArray[i])

	}//for
	tmp = febeMsg[207].replace("%NUMDIR%",numDirsToRename);
	tmp = tmp.replace("%NEWFORMAT%",newformat);
	febeAlert(tmp);
	febePrefs.setCharPref("extensions.febe.timestamp.format",selected)
}//febeTimestampDirCheck()

function febeClearBuInProgressFlag(){
	febePrefs.setBoolPref("extensions.febe.backupInProgress",false);
	document.getElementById("febeclearbuinprogresstbtn").disabled = true;
}//febeClearBuInProgressFlag()

function febeDisplayOnlineRestoreMenu(){
  // Enable/disable online restore popups
	var bool = febePrefs.getBoolPref("extensions.febe.boxnet.enabled");
	var d = document.getElementById("febe_tlbr_restorePopups_online");
	if(d){d.setAttribute("hidden",!bool);}
	var d = document.getElementById("febe_tools_menu_restorePopups_online");
	if(d){d.setAttribute("hidden",!bool);}
	var d = document.getElementById("febe_tools_menu_upload");
	if(d){d.setAttribute("hidden",!bool);}
	var d = document.getElementById("febe_tlbr_bn_upload");
	if(d){d.setAttribute("hidden",!bool);}
	return true;
}//febeDisplayOnlineRestoreMenu()

function febeResultsFormat(){
	var bool = febePrefs.getBoolPref("extensions.febe.displayresultspage");
	var d = document.getElementById("dispResultsFormat");
	if(d) d.setAttribute("hidden",!bool);
//febeProps(d)	
}//febeResultsFormat()

function febeGetNextBackup(){
	var prefName = "extensions.febe.schedule.description";
	var febeNB = febeGetUnicharPref(prefName);
	var d = document.getElementById("nextbackupdate");
	febeSetMsgs();
	febeSetIsScheduled();
	if(febeIsScheduled == true){
		var tmp = febeLocalizedDate(febeNB);
	}else{
		var tmp = febeMsg[113];
	}//if
	d.value = tmp;
	return true;
}//febeGetNextBackup()

function febeSchedulePrompts(){
  // Enable/disable prompts
	var d1 = document.getElementById("backupOnStartup_id");
	var d2 = document.getElementById("backupOnStartupPrompt_id");
	var d3 = document.getElementById("lastbackuponstartupwaitlabel");
	var d4 = document.getElementById("backuponstartupwaitvalue");
	var d5 = document.getElementById("lastbackuponstartuplabel");
	var d6 = document.getElementById("lastbackuponstartupvalue");
	d2.disabled = !d1.checked;
	d3.disabled = !d1.checked;
	d4.disabled = !d1.checked;
	d5.disabled = !d1.checked;
	d6.disabled = !d1.checked;
	
	var lastbu = febePrefs.getCharPref("extensions.febe.lastbackuponstartup");
	var lastbustr = febeMsg[397];
	if(lastbu != ""){
		var dt = new Date();
		dt.setTime(lastbu);
		lastbustr = "      "+dt.toLocaleString();
	}//if
	d6.value = 	lastbustr;
	
	var d1 = document.getElementById("backupOnShutdown_id");
	var d2 = document.getElementById("backupOnShutdownPrompt_id");
	var d3 = document.getElementById("lastbackuponshutdownwaitlabel");
	var d4 = document.getElementById("backuponshutdownwaitvalue");
	var d5 = document.getElementById("lastbackuponshutdownlabel");
	var d6 = document.getElementById("lastbackuponshutdownvalue");
	d2.disabled = !d1.checked;
	d3.disabled = !d1.checked;
	d4.disabled = !d1.checked;
	d5.disabled = !d1.checked;
	d6.disabled = !d1.checked;	
	
	var lastbu = febePrefs.getCharPref("extensions.febe.lastbackuponshutdown");
	var lastbustr = febeMsg[397];
	if(lastbu != ""){
		var dt = new Date();
		dt.setTime(lastbu);
		lastbustr = dt.toLocaleString();
	}//if
	d6.value =	"      "+lastbustr;
	
	return true;
}//febeSchedulePrompts()

function febeLoadFxPath(){
	var prefName = "extensions.febe.FxExecutablePath";
	if(febePrefs.prefHasUserValue(prefName)){return true;}
	var app = febeGetEnvironmentVariableValue("MOZ_CRASHREPORTER_RESTART_ARG_0");
	document.getElementById("fullFxPathID").value = app;
	if(febePlatform == 3 || app == ""){	// Disable "Verify" button on Mac (bug 322865)
		var d = document.getElementById("verifyFxPathID");
		d.setAttribute("disabled","true");
	}//if
}//febeLoadFxPath()

function febeCheckFxPath(){
	var fxPath = document.getElementById("fullFxPathID").value
//alert(fxPath)
	if(fxPath == ""){ return false;}
	var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	file.initWithPath(fxPath);
	if(!file.exists()){
		var tmp = febeMsg[299].replace(/%EXECUTABLE%/,fxPath);
		febeAlert(tmp);
		return false;
	}//if
	if(!file.isExecutable() && febePlatform != 3){
		var tmp = febeMsg[300].replace(/%EXECUTABLE%/,fxPath);
		febeAlert(tmp);
		return false;
	}//if
	var prefName = "extensions.febe.FxExecutablePath";
	febeSetUnicharPref(prefName,file.path);
//alert(prefName+"\n"+file.path)
	var tmp = febeMsg[302];
	febeAlert(tmp);
	return true;
}//febeCheckFxPath()

function febeBrowseForFirefox(){
	var d = document.getElementById("fullFxPathID");
	var fxPath = d.value;

  // Select firefox executable
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[301], nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterApps);
	fp.defaultString = "firefox";
	
	// Set the start directory 
	var aDir = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	var startDir;
	if(fxPath != ""){
		aDir.initWithPath(fxPath);
		startDir = aDir.parent;
	}else{
		startDir = Cc["@mozilla.org/file/directory_service;1"]
						.getService(Ci.nsIProperties)
						.get("CurProcD", Ci.nsILocalFile);
	}//if
	fp.displayDirectory = startDir;

	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		d.value = fp.file.path;
		return true;
	}//if
	return false;
}//febeBrowseForFirefox()

function febeDirInfoLoad(){
	// Profile name and location
	var d = document.getElementById("dirinfoprofilenameID");
	var tmp = febeProfDir.leafName;
	var p = tmp.indexOf(".")
	febeProfName = tmp.substr(p+1);
	d.value = febeProfName;
	var d = document.getElementById("dirinfoprofilepathID");
	d.value = febeProfDir.path;

	// Cache location
	var d = document.getElementById("dirinfocachepathID");
	d.value = febeGetCacheDirectory();
	
	// Firefox install path
	var d = document.getElementById("dirinfoinstallpathID");
	var dir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("CurProcD", Ci.nsIFile);
	d.value = dir.path;
	
	// Extensions directory
	var d = document.getElementById("dirinfoextensionspathID");
	var dir = febeProfDir.clone();
	dir.append("extensions");
	d.value = dir.path;
	return true;
}//febeDirInfoLoad()

function febeGetCacheDirectory(){
	try{
		var cacheDir = Cc["@mozilla.org/preferences-service;1"]
						 .getService(ci.nsIPrefBranch)
						 .getComplexValue("browser.cache.disk.parent_directory",Ci.nsILocalFile);
		return cacheDir;
  }catch(er){
    var dirServ = Cc["@mozilla.org/file/directory_service;1"]
                  .getService(Ci.nsIProperties);
		try{
			cacheDir = dirServ.get("cachePDir",Ci.nsILocalFile);
		}catch(er){
			cacheDir = dirServ.get("ProfLD",Ci.nsILocalFile);
		}
	}
	return cacheDir.path;
}//febeGetCacheDirectory()

function febeDirInfoView(id,title){
	var URL = document.getElementById(id).value;
	febeOpenLink(URL,title);
	return true;
}//febeDirInfoView()

var febeFlashTimeout = null;
function febeFlashNode(id,stop){
return true;
	d=document.getElementById(id);
	//if(!febeFlashTimeout)febeProps(d)
	if(stop){
		d.style.border = "";
		window.clearTimeout(febeFlashTimeout);
		febeFlashTimeout = null;
		return;
	}
	var style2 = "1px solid red"
	var style = d.style.border;
	if(d.style.border == style2){
		d.style.border = "";
	}else{
		d.style.border = style2;
	}
	//alert(d.style.border)
	febeFlashTimeout = setTimeout(function(){febeFlashNode(id,false)},2750)
}

// Sounds
function febeHideSoundOptions(){
	var d = document.getElementById("febePlaySoundsID");
	var checked = d.hasAttribute("checked");
	var d = document.getElementById("febeSoundOptionGrid");
	d.hidden = !checked;
	febeHandleSounds();
	return true
}//febeHideSoundOptions()

function febeBrowseSounds(which){
	const nsIFilePicker = Ci.nsIFilePicker;
	var fp = Cc["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, febeMsg[370], nsIFilePicker.modeOpen);
	fp.filterAudio;
	var filter = "*.wav";
	fp.appendFilter(febeMsg[371],filter);
	
	// Set default directory to where the custom sound originated if it is set, otherwise just default
	var err = Boolean(false);
	var dd = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	try {
		var prefName = "extensions.febe.sounds.use"+which+"SoundLocation";
		var url = febeGetUnicharPref(prefName);
		dd.initWithPath(url);
	}catch(e){err = true;}
	if(!err){fp.displayDirectory = dd.parent;}

	
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK){
		var prefName = "extensions.febe.sounds.use"+which+"SoundLocation";
		febeSetUnicharPref(prefName, fp.file.path);
		var d = document.getElementById("febe"+which+"SoundTB");
		d.value = fp.file.leafName;
	}//if
	febeHandleSounds();
	return true;
}//c2apBuildAudioList()

function febeDisplaySoundFilenames(){
	febeHandleSounds();
	var a = ['Success','Failure','Warning','Message','Help'];
	for(var i in a){
		var prefName = "extensions.febe.sounds.use"+a[i]+"SoundLocation";
		var url = febeGetUnicharPref(prefName);
		var d = document.getElementById("febe"+a[i]+"SoundTB");
		var p = url.lastIndexOf("\\");
		d.value = url.substr(p+1);
	}//for
}//febeDisplaySoundFilenames

function febeClearSounds(){
	var a = ['Success','Failure','Warning','Message','Help'];
	for(var i in a){
		var prefName = "extensions.febe.sounds.use"+a[i]+"SoundLocation";
		febeSetUnicharPref(prefName,"");
		var prefName = "extensions.febe.sounds.use"+a[i]+"SoundType";
		febeSetUnicharPref(prefName,"default");
		var d = document.getElementById("febe"+a[i]+"SoundTB");
		d.value = "";
	}//for
	return true;
}//febeClearSounds()

function febePlaySoundCheck(which){
	febeHandleSounds();
	var prefName = "extensions.febe.sounds.use"+which+"SoundLocation";
	var url = febeGetUnicharPref(prefName);
	var url = febePlaySoundsURI[which.toLowerCase()]
//alert("PlaySoundCheck: "+which+" : "+which.toLowerCase()+"\n["+url+"]\n"+prefName)
	if(url.length != 7){	// length of "file://"
		febePlaySound(which.toLowerCase());
	}else{
		febeAlert(febeMsg[369]);
		return false;
	}//if
	return true;
}//febePlaySoundCheck()

function febeDisplayReportButtons(){
	febeInitDir();
	var results = false;
	var resultspageurl = "";
	var prefName = "extensions.febe.lastbackupresultspageurl";
	if(febePrefs.prefHasUserValue(prefName)){
		var febeResultsPage = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		resultspageurl = febePrefs.getCharPref(prefName);
		try{
			febeResultsPage.initWithPath(resultspageurl);
			if(febeResultsPage.exists()) results = true;
		}catch(e){;;}
	}//if
	var prefName = "extensions.febe.lastbackup";
	if(febePrefs.prefHasUserValue(prefName)){
		var tmp = febePrefs.getCharPref(prefName);
		tmp = febeLocalizedDate(tmp);
		document.getElementById("viewlastbudir").disabled = false;
		document.getElementById("viewlastbupage").disabled = !results;
	}else{
		var tmp = febeMsg[173];
		document.getElementById("viewlastbudir").disabled = true;
		document.getElementById("viewlastbupage").disabled = true;
	}//if
	return true;
}//febeDisplayReportButtons()

function febeDisplayLastBU(){
	febeInitDir();
	var tmp = febeMsg[397];
	var prefName = "extensions.febe.lastbackup";
	if(febePrefs.prefHasUserValue(prefName)){
		tmp = febePrefs.getCharPref(prefName);
		tmp = febeLocalizedDate(tmp);
	}//if
	document.getElementById("febeLastBU").value = tmp;
	document.getElementById("febeLastBuType").value = febeGetUnicharPref("extensions.febe.lastbackup.type.desc");
	return true;
}//febeDisplayLastBU()

function febeViewLastBUdir(){
	var prefName = "extensions.febe.lastbackup.folder";
	if(febePrefs.prefHasUserValue(prefName)){
		var febeBuDestDir = febeGetUnicharPref(prefName);
		febeOpenLink("file:///"+febeBuDestDir);
	}//if
	return true;
}//febeViewLastBU()

function febeViewLastBUpage(){
	febeOpenLink("chrome://febe/content/febeResultsLoad.html");
	return true;
}//febeViewLastBUpage()

function febeViewBuHistory(){
	// Load history
	var history = febeGetHistoryData();
	if(!history) return true;
	
	// Pointer to history page html file
	febeProfDir = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	var febeHistoryPage = febeProfDir.clone();
	febeHistoryPage.append("FEBEhistory.html");
		
  // Open history page for writing
	var historyFile = Cc["@mozilla.org/network/file-output-stream;1"].createInstance(Ci.nsIFileOutputStream);
	historyFile.init(febeHistoryPage, 0x02 | 0x08 | 0x20, 0755, 0); // write, create, truncate
	
  // Get history template
	var historyTemplate=febeGetResultsTemplate("chrome://febe/content/FEBEhistoryTemplate.html");
	var histDoc = document.implementation.createHTMLDocument(febeMsg[372]);
	var pageSource = historyTemplate.replace("%title%", febeMsg[372]);
	pageSource = pageSource.replace("%reportheading%", febeMsg[372]);
	pageSource = pageSource.replace("%version%", febeMsg[49]+" "+febePrefs.getCharPref("extensions.febe.currentversion"));
  pageSource = pageSource.replace("%table%", febeBuildHistory(history));
	
	//histDoc.innerHTML = pageSource;
	
	// Create an UTF-8 output stream
	var charset = "UTF-8";
	var os = Cc["@mozilla.org/intl/converter-output-stream;1"].createInstance(Ci.nsIConverterOutputStream);

	os.init(historyFile, charset, 4096, 0x0000);
	os.writeString(pageSource);
	os.close();

	// Open and display results
	febeOpenResultsPage(febeHistoryPage.path);
	return true;
}//febeViewBuHistory()

function febeBuildHistory(history){
	var doc = document.implementation.createHTMLDocument(febeMsg[372]);
	var oSpan = doc.createElement("span");
	var table = doc.createElement("table");
	var oTbody = doc.createElement("tbody");
	var oAnchor = doc.createElement("a");
	var oRow = doc.createElement("tr");
	var oCell = doc.createElement("td");
	var cellStyle = "vertical-align: top;";
	var numStyle = "vertical-align: top; text-align: right;";
	var oBR = doc.createElement("br");
	var oPara = doc.createElement("p");
	var ttime = 0;
	
	// Write notes
	var para = oPara.cloneNode(false);
	var span = oSpan.cloneNode(false);
	span.setAttribute("style","font-style: italic;");
	var txt = doc.createTextNode(febeMsg[391]);
	span.appendChild(txt);
	para.appendChild(span);
	doc.body.appendChild(para);
	
	// Setup the table
	table.setAttribute("style","margin-left: auto; margin-right: auto; text-align: left;");
	table.setAttribute("border","1");
	table.setAttribute("cellpadding","2");
  table.setAttribute("cellspacing","2");
		
	// Create table headings
	var row = oRow.cloneNode(false);
	for(var i=373; i<=378; i++){
		var cell = oCell.cloneNode(false);
		var span = oSpan.cloneNode(false);
		span.setAttribute("class","heading");
		var txt = doc.createTextNode(febeMsg[i]);
		span.appendChild(txt);
		cell.appendChild(span);
		row.appendChild(cell);
	}//for
	table.appendChild(row);

	//Add history lines to table
	for(var i=0; i<history.length; i++){
		var histdata = new Object(history[i]);
		var date = histdata.date;
		var type = histdata.type;
		var time = histdata.time;
		var location = histdata.resultsurl;
		var runType = histdata.runtype;
		var resultsPageURL = histdata.resultspage;
		var runTypeDesc = [];
		runTypeDesc[0] = "(Unknown)"
		runTypeDesc[1] = febeMsg[382];
		runTypeDesc[2] = febeMsg[383];
		runTypeDesc[3] = febeMsg[384];
		runTypeDesc[4] = febeMsg[385];
		runTypeDesc[5] = febeMsg[386];

		var row = oRow.cloneNode(false);
		
		// Create the date cell
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",cellStyle);
		var txt = doc.createTextNode(date);
		cell.appendChild(txt);
		row.appendChild(cell);
		
		// Create the backup type cell
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",cellStyle);
		var txt = doc.createTextNode(type);
		cell.appendChild(txt);
		row.appendChild(cell);
		
		// Create the backup time cell
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",numStyle);
		var txt = doc.createTextNode(time.toFixed(3));
		ttime += time;
		cell.appendChild(txt);
		row.appendChild(cell);
		
		// Create the backup location cell
		var url = "";
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(location);
		if(dFile.exists() && dFile.isDirectory()){url = dFile.path;}
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",cellStyle);
		var txt = doc.createTextNode(location);
		if(url){
			var anchor = oAnchor.cloneNode(false);
			anchor.setAttribute("href","file:///"+url);
			anchor.appendChild(txt);
			cell.appendChild(anchor);
			row.setAttribute("class","exists");
		}else{
			cell.appendChild(txt);
			row.setAttribute("class","notexists");
		}//if
		row.appendChild(cell);
		
		// Create the run type cell
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",cellStyle);
		var txt = doc.createTextNode(runTypeDesc[runType]);
		cell.appendChild(txt);
		row.appendChild(cell);

		// Create the results page cell
		var url = "";
		var cellTxt = febeMsg[388];
		if(resultsPageURL){
			cellTxt = febeMsg[387];
			var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
			dFile.initWithPath(resultsPageURL);
			if(dFile.exists()){url = dFile.path;}
		}//if
		var cell = oCell.cloneNode(false);
		cell.setAttribute("style",cellStyle);
		var txt = doc.createTextNode(cellTxt);
		if(url){
			var anchor = oAnchor.cloneNode(false);
			anchor.setAttribute("href","file:///"+url);
			anchor.appendChild(txt);
			cell.appendChild(anchor);
		}else{
			cell.appendChild(txt);
		}//if
		row.appendChild(cell);
		
		table.appendChild(row);
	}//for
	doc.body.appendChild(table);
	
	// Write totals
	var para = oPara.cloneNode(false);
	var br = oBR.cloneNode(false);

	para.appendChild(br);
	para.appendChild(br);

	var cellTxt = febeMsg[389].replace("%TOTAL%",history.length);
	var txt = doc.createTextNode(cellTxt);
	para.appendChild(txt);
	para.appendChild(br);
	
	ttime = ttime / history.length;
	ttime +=0.0005;
	ttime = ttime * 1000;
	ttime = parseInt(ttime) / 1000;
	var cellTxt = febeMsg[390].replace("%AVG%",ttime.toFixed(3));
	var txt = doc.createTextNode(cellTxt);
	para.appendChild(txt);
	
	doc.body.appendChild(para);
	
	return doc.body.innerHTML;

}//febeBuildHistory()

function febeGetHistoryData(){
	febeSetMsgs();
	febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
	febeDataFile.append(FEBEBUHISTORYFILE);
	var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
	dFile.initWithPath(febeDataFile.path);
	if(!dFile.exists()){
		febeAlert(febeMsg[381]);
		return false;
	}//if
	
	//var JSON = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);	
	var fis = Cc["@mozilla.org/network/file-input-stream;1"].createInstance(Ci.nsIFileInputStream);
	fis.init(dFile, 0x01, 0444, 0);
	fis.QueryInterface(Ci.nsILineInputStream);

	var cis = Cc["@mozilla.org/intl/converter-input-stream;1"].createInstance(Ci.nsIConverterInputStream);
	cis.init(fis,"UTF-8", 0, 0x0000);
		
	var lis = cis.QueryInterface(Ci.nsIUnicharLineInputStream);

	var line = {}, hasmore, cnt = 0;
	var history = [];
	do {
		hasmore = lis.readLine(line);
		var histdata = JSON.parse(line.value);
		var date = histdata.date;
		var type = histdata.type;
		var time = histdata.time;
		var location = histdata.location;
		var runType = histdata.runType;
		history[cnt] = new Object(histdata);
		cnt++;
	} while(hasmore);
	return history;
}//febeGetHistoryData()

function febeClearBuHistory(){
	febeSetMsgs();
	var OK = febeConfirm(febeMsg[379]);
	if(OK){
		febeDataFile = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties).get("ProfD", Ci.nsIFile);
		febeDataFile.append(FEBEBUHISTORYFILE);
		var dFile = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
		dFile.initWithPath(febeDataFile.path);
		if(dFile.exists()){
			dFile.remove(false);
			febeAlert(febeMsg[380]);
		}//if
	}//if
	return true;
}//febeClearBuHistory()
